/* InputSource.c generated by valac 0.56.10, the Vala compiler
 * generated from InputSource.vala, do not modify */

/*
* Copyright 2017-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "keyboard.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	KEYBOARD_INPUT_SOURCE_0_PROPERTY,
	KEYBOARD_INPUT_SOURCE_LAYOUT_TYPE_PROPERTY,
	KEYBOARD_INPUT_SOURCE_NAME_PROPERTY,
	KEYBOARD_INPUT_SOURCE_NUM_PROPERTIES
};
static GParamSpec* keyboard_input_source_properties[KEYBOARD_INPUT_SOURCE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KeyboardInputSourcePrivate {
	KeyboardLayoutType _layout_type;
	gchar* _name;
};

static gint KeyboardInputSource_private_offset;
static gpointer keyboard_input_source_parent_class = NULL;

static KeyboardInputSource* keyboard_input_source_new (KeyboardLayoutType layout_type,
                                                const gchar* name);
static KeyboardInputSource* keyboard_input_source_construct (GType object_type,
                                                      KeyboardLayoutType layout_type,
                                                      const gchar* name);
static void keyboard_input_source_finalize (GObject * obj);
static GType keyboard_input_source_get_type_once (void);
static void _vala_keyboard_input_source_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_keyboard_input_source_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
     * Type of a keyboard-InputSource as described in the description of
     * "org.gnome.desktop.input-sources sources".
     */
static GType
keyboard_layout_type_get_type_once (void)
{
	static const GEnumValue values[] = {{KEYBOARD_LAYOUT_TYPE_IBUS, "KEYBOARD_LAYOUT_TYPE_IBUS", "ibus"}, {KEYBOARD_LAYOUT_TYPE_XKB, "KEYBOARD_LAYOUT_TYPE_XKB", "xkb"}, {0, NULL, NULL}};
	GType keyboard_layout_type_type_id;
	keyboard_layout_type_type_id = g_enum_register_static ("KeyboardLayoutType", values);
	return keyboard_layout_type_type_id;
}

GType
keyboard_layout_type_get_type (void)
{
	static volatile gsize keyboard_layout_type_type_id__once = 0;
	if (g_once_init_enter (&keyboard_layout_type_type_id__once)) {
		GType keyboard_layout_type_type_id;
		keyboard_layout_type_type_id = keyboard_layout_type_get_type_once ();
		g_once_init_leave (&keyboard_layout_type_type_id__once, keyboard_layout_type_type_id);
	}
	return keyboard_layout_type_type_id__once;
}

static inline gpointer
keyboard_input_source_get_instance_private (KeyboardInputSource* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardInputSource_private_offset);
}

KeyboardInputSource*
keyboard_input_source_new_xkb (const gchar* name,
                               const gchar* xkb_variant)
{
	gchar* full_name = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp6_;
	KeyboardInputSource* _tmp7_;
	KeyboardInputSource* result;
#line 35 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 36 "../src/InputSources/InputSource.vala"
	if (g_strcmp0 (name, "") == 0) {
#line 37 "../src/InputSources/InputSource.vala"
		g_critical ("InputSource.vala:37: Ignoring attempt to create invalid Xkb InputSourc" \
"e name %s", name);
#line 38 "../src/InputSources/InputSource.vala"
		result = NULL;
#line 38 "../src/InputSources/InputSource.vala"
		return result;
#line 128 "InputSource.c"
	}
#line 41 "../src/InputSources/InputSource.vala"
	_tmp0_ = g_strdup (name);
#line 41 "../src/InputSources/InputSource.vala"
	full_name = _tmp0_;
#line 42 "../src/InputSources/InputSource.vala"
	if (xkb_variant != NULL) {
#line 42 "../src/InputSources/InputSource.vala"
		_tmp1_ = g_strcmp0 (xkb_variant, "") != 0;
#line 138 "InputSource.c"
	} else {
#line 42 "../src/InputSources/InputSource.vala"
		_tmp1_ = FALSE;
#line 142 "InputSource.c"
	}
#line 42 "../src/InputSources/InputSource.vala"
	if (_tmp1_) {
#line 146 "InputSource.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 43 "../src/InputSources/InputSource.vala"
		_tmp2_ = full_name;
#line 43 "../src/InputSources/InputSource.vala"
		_tmp3_ = g_strconcat ("+", xkb_variant, NULL);
#line 43 "../src/InputSources/InputSource.vala"
		_tmp4_ = _tmp3_;
#line 43 "../src/InputSources/InputSource.vala"
		_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 43 "../src/InputSources/InputSource.vala"
		_g_free0 (full_name);
#line 43 "../src/InputSources/InputSource.vala"
		full_name = _tmp5_;
#line 43 "../src/InputSources/InputSource.vala"
		_g_free0 (_tmp4_);
#line 165 "InputSource.c"
	}
#line 46 "../src/InputSources/InputSource.vala"
	_tmp6_ = full_name;
#line 46 "../src/InputSources/InputSource.vala"
	_tmp7_ = keyboard_input_source_new (KEYBOARD_LAYOUT_TYPE_XKB, _tmp6_);
#line 46 "../src/InputSources/InputSource.vala"
	result = _tmp7_;
#line 46 "../src/InputSources/InputSource.vala"
	_g_free0 (full_name);
#line 46 "../src/InputSources/InputSource.vala"
	return result;
#line 177 "InputSource.c"
}

KeyboardInputSource*
keyboard_input_source_new_ibus (const gchar* engine_name)
{
	KeyboardInputSource* _tmp0_;
	KeyboardInputSource* result;
#line 49 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (engine_name != NULL, NULL);
#line 50 "../src/InputSources/InputSource.vala"
	if (g_strcmp0 (engine_name, "") == 0) {
#line 51 "../src/InputSources/InputSource.vala"
		g_critical ("InputSource.vala:51: Ignoring attempt to create invalid IBus InputSour" \
"ce name %s", engine_name);
#line 52 "../src/InputSources/InputSource.vala"
		result = NULL;
#line 52 "../src/InputSources/InputSource.vala"
		return result;
#line 195 "InputSource.c"
	}
#line 55 "../src/InputSources/InputSource.vala"
	_tmp0_ = keyboard_input_source_new (KEYBOARD_LAYOUT_TYPE_IBUS, engine_name);
#line 55 "../src/InputSources/InputSource.vala"
	result = _tmp0_;
#line 55 "../src/InputSources/InputSource.vala"
	return result;
#line 203 "InputSource.c"
}

KeyboardInputSource*
keyboard_input_source_new_from_variant (GVariant* variant)
{
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	gboolean _tmp2_;
	KeyboardInputSource* result;
#line 59 "../src/InputSources/InputSource.vala"
	_tmp0_ = g_variant_type_new ("(ss)");
#line 59 "../src/InputSources/InputSource.vala"
	_tmp1_ = _tmp0_;
#line 59 "../src/InputSources/InputSource.vala"
	_tmp2_ = g_variant_is_of_type (variant, _tmp1_);
#line 59 "../src/InputSources/InputSource.vala"
	_g_variant_type_free0 (_tmp1_);
#line 59 "../src/InputSources/InputSource.vala"
	if (_tmp2_) {
#line 223 "InputSource.c"
		const gchar* type = NULL;
		const gchar* name = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
#line 63 "../src/InputSources/InputSource.vala"
		g_variant_get (variant, "(&s&s)", &_tmp3_, &_tmp4_, NULL);
#line 63 "../src/InputSources/InputSource.vala"
		type = _tmp3_;
#line 63 "../src/InputSources/InputSource.vala"
		name = _tmp4_;
#line 65 "../src/InputSources/InputSource.vala"
		_tmp5_ = name;
#line 65 "../src/InputSources/InputSource.vala"
		if (g_strcmp0 (_tmp5_, "") != 0) {
#line 239 "InputSource.c"
			const gchar* _tmp6_;
#line 66 "../src/InputSources/InputSource.vala"
			_tmp6_ = type;
#line 66 "../src/InputSources/InputSource.vala"
			if (g_strcmp0 (_tmp6_, "xkb") == 0) {
#line 245 "InputSource.c"
				const gchar* _tmp7_;
				KeyboardInputSource* _tmp8_;
#line 67 "../src/InputSources/InputSource.vala"
				_tmp7_ = name;
#line 67 "../src/InputSources/InputSource.vala"
				_tmp8_ = keyboard_input_source_new (KEYBOARD_LAYOUT_TYPE_XKB, _tmp7_);
#line 67 "../src/InputSources/InputSource.vala"
				result = _tmp8_;
#line 67 "../src/InputSources/InputSource.vala"
				return result;
#line 256 "InputSource.c"
			} else {
				const gchar* _tmp9_;
#line 68 "../src/InputSources/InputSource.vala"
				_tmp9_ = type;
#line 68 "../src/InputSources/InputSource.vala"
				if (g_strcmp0 (_tmp9_, "ibus") == 0) {
#line 263 "InputSource.c"
					const gchar* _tmp10_;
					KeyboardInputSource* _tmp11_;
#line 69 "../src/InputSources/InputSource.vala"
					_tmp10_ = name;
#line 69 "../src/InputSources/InputSource.vala"
					_tmp11_ = keyboard_input_source_new (KEYBOARD_LAYOUT_TYPE_IBUS, _tmp10_);
#line 69 "../src/InputSources/InputSource.vala"
					result = _tmp11_;
#line 69 "../src/InputSources/InputSource.vala"
					return result;
#line 274 "InputSource.c"
				}
			}
		} else {
			const gchar* _tmp12_;
#line 72 "../src/InputSources/InputSource.vala"
			_tmp12_ = name;
#line 72 "../src/InputSources/InputSource.vala"
			g_critical ("InputSource.vala:72: Attempt to create invalid InputSource name %s", _tmp12_);
#line 283 "InputSource.c"
		}
	} else {
#line 76 "../src/InputSources/InputSource.vala"
		g_critical ("InputSource.vala:76: Ignoring attempt to create InputSource from inval" \
"id VariantType");
#line 288 "InputSource.c"
	}
#line 79 "../src/InputSources/InputSource.vala"
	result = NULL;
#line 79 "../src/InputSources/InputSource.vala"
	return result;
#line 294 "InputSource.c"
}

static KeyboardInputSource*
keyboard_input_source_construct (GType object_type,
                                 KeyboardLayoutType layout_type,
                                 const gchar* name)
{
	KeyboardInputSource * self = NULL;
#line 87 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 88 "../src/InputSources/InputSource.vala"
	self = (KeyboardInputSource*) g_object_new (object_type, "layout-type", layout_type, "name", name, NULL);
#line 87 "../src/InputSources/InputSource.vala"
	return self;
#line 309 "InputSource.c"
}

static KeyboardInputSource*
keyboard_input_source_new (KeyboardLayoutType layout_type,
                           const gchar* name)
{
#line 87 "../src/InputSources/InputSource.vala"
	return keyboard_input_source_construct (KEYBOARD_TYPE_INPUT_SOURCE, layout_type, name);
#line 318 "InputSource.c"
}

gboolean
keyboard_input_source_equal (KeyboardInputSource* self,
                             KeyboardInputSource* other)
{
	gboolean _tmp0_ = FALSE;
	KeyboardLayoutType _tmp1_;
	KeyboardLayoutType _tmp2_;
	gboolean result;
#line 94 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 94 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 95 "../src/InputSources/InputSource.vala"
	_tmp1_ = self->priv->_layout_type;
#line 95 "../src/InputSources/InputSource.vala"
	_tmp2_ = other->priv->_layout_type;
#line 95 "../src/InputSources/InputSource.vala"
	if (_tmp1_ == _tmp2_) {
#line 339 "InputSource.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 95 "../src/InputSources/InputSource.vala"
		_tmp3_ = self->priv->_name;
#line 95 "../src/InputSources/InputSource.vala"
		_tmp4_ = other->priv->_name;
#line 95 "../src/InputSources/InputSource.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 348 "InputSource.c"
	} else {
#line 95 "../src/InputSources/InputSource.vala"
		_tmp0_ = FALSE;
#line 352 "InputSource.c"
	}
#line 95 "../src/InputSources/InputSource.vala"
	result = _tmp0_;
#line 95 "../src/InputSources/InputSource.vala"
	return result;
#line 358 "InputSource.c"
}

/**
         * GSettings saves values in the form of GLib.Variant and this
         * function creates a Variant representing this object.
         */
static gpointer
_g_variant_ref0 (gpointer self)
{
#line 116 "../src/InputSources/InputSource.vala"
	return self ? g_variant_ref (self) : NULL;
#line 370 "InputSource.c"
}

GVariant*
keyboard_input_source_to_variant (KeyboardInputSource* self)
{
	const gchar* _tmp0_;
	gchar* type_name = NULL;
	gchar* _tmp1_;
	KeyboardLayoutType _tmp2_;
	GVariant* first = NULL;
	const gchar* _tmp5_;
	GVariant* _tmp6_;
	GVariant* second = NULL;
	const gchar* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _result_ = NULL;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant** _tmp11_;
	GVariant** _tmp12_;
	gint _tmp12__length1;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* result;
#line 102 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/InputSources/InputSource.vala"
	_tmp0_ = self->priv->_name;
#line 102 "../src/InputSources/InputSource.vala"
	_vala_return_val_if_fail (g_strcmp0 (_tmp0_, "") != 0, "name != \"\"", NULL);
#line 103 "../src/InputSources/InputSource.vala"
	_tmp1_ = g_strdup ("");
#line 103 "../src/InputSources/InputSource.vala"
	type_name = _tmp1_;
#line 104 "../src/InputSources/InputSource.vala"
	_tmp2_ = self->priv->_layout_type;
#line 104 "../src/InputSources/InputSource.vala"
	switch (_tmp2_) {
#line 104 "../src/InputSources/InputSource.vala"
		case KEYBOARD_LAYOUT_TYPE_IBUS:
#line 411 "InputSource.c"
		{
			gchar* _tmp3_;
#line 106 "../src/InputSources/InputSource.vala"
			_tmp3_ = g_strdup ("ibus");
#line 106 "../src/InputSources/InputSource.vala"
			_g_free0 (type_name);
#line 106 "../src/InputSources/InputSource.vala"
			type_name = _tmp3_;
#line 107 "../src/InputSources/InputSource.vala"
			break;
#line 422 "InputSource.c"
		}
#line 104 "../src/InputSources/InputSource.vala"
		case KEYBOARD_LAYOUT_TYPE_XKB:
#line 426 "InputSource.c"
		{
			gchar* _tmp4_;
#line 109 "../src/InputSources/InputSource.vala"
			_tmp4_ = g_strdup ("xkb");
#line 109 "../src/InputSources/InputSource.vala"
			_g_free0 (type_name);
#line 109 "../src/InputSources/InputSource.vala"
			type_name = _tmp4_;
#line 110 "../src/InputSources/InputSource.vala"
			break;
#line 437 "InputSource.c"
		}
		default:
		{
#line 112 "../src/InputSources/InputSource.vala"
			g_assert_not_reached ();
#line 443 "InputSource.c"
		}
	}
#line 114 "../src/InputSources/InputSource.vala"
	_tmp5_ = type_name;
#line 114 "../src/InputSources/InputSource.vala"
	_tmp6_ = g_variant_new_string (_tmp5_);
#line 114 "../src/InputSources/InputSource.vala"
	g_variant_ref_sink (_tmp6_);
#line 114 "../src/InputSources/InputSource.vala"
	first = _tmp6_;
#line 115 "../src/InputSources/InputSource.vala"
	_tmp7_ = self->priv->_name;
#line 115 "../src/InputSources/InputSource.vala"
	_tmp8_ = g_variant_new_string (_tmp7_);
#line 115 "../src/InputSources/InputSource.vala"
	g_variant_ref_sink (_tmp8_);
#line 115 "../src/InputSources/InputSource.vala"
	second = _tmp8_;
#line 116 "../src/InputSources/InputSource.vala"
	_tmp9_ = _g_variant_ref0 (first);
#line 116 "../src/InputSources/InputSource.vala"
	_tmp10_ = _g_variant_ref0 (second);
#line 116 "../src/InputSources/InputSource.vala"
	_tmp11_ = g_new0 (GVariant*, 2 + 1);
#line 116 "../src/InputSources/InputSource.vala"
	_tmp11_[0] = _tmp9_;
#line 116 "../src/InputSources/InputSource.vala"
	_tmp11_[1] = _tmp10_;
#line 116 "../src/InputSources/InputSource.vala"
	_tmp12_ = _tmp11_;
#line 116 "../src/InputSources/InputSource.vala"
	_tmp12__length1 = 2;
#line 116 "../src/InputSources/InputSource.vala"
	_tmp13_ = g_variant_new_tuple (_tmp12_, 2);
#line 116 "../src/InputSources/InputSource.vala"
	g_variant_ref_sink (_tmp13_);
#line 116 "../src/InputSources/InputSource.vala"
	_tmp14_ = _tmp13_;
#line 116 "../src/InputSources/InputSource.vala"
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 116 "../src/InputSources/InputSource.vala"
	_result_ = _tmp14_;
#line 118 "../src/InputSources/InputSource.vala"
	result = _result_;
#line 118 "../src/InputSources/InputSource.vala"
	_g_variant_unref0 (second);
#line 118 "../src/InputSources/InputSource.vala"
	_g_variant_unref0 (first);
#line 118 "../src/InputSources/InputSource.vala"
	_g_free0 (type_name);
#line 118 "../src/InputSources/InputSource.vala"
	return result;
#line 496 "InputSource.c"
}

KeyboardLayoutType
keyboard_input_source_get_layout_type (KeyboardInputSource* self)
{
	KeyboardLayoutType result;
#line 82 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 82 "../src/InputSources/InputSource.vala"
	result = self->priv->_layout_type;
#line 82 "../src/InputSources/InputSource.vala"
	return result;
#line 509 "InputSource.c"
}

static void
keyboard_input_source_set_layout_type (KeyboardInputSource* self,
                                       KeyboardLayoutType value)
{
	KeyboardLayoutType old_value;
#line 82 "../src/InputSources/InputSource.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/InputSources/InputSource.vala"
	old_value = keyboard_input_source_get_layout_type (self);
#line 82 "../src/InputSources/InputSource.vala"
	if (old_value != value) {
#line 82 "../src/InputSources/InputSource.vala"
		self->priv->_layout_type = value;
#line 82 "../src/InputSources/InputSource.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_input_source_properties[KEYBOARD_INPUT_SOURCE_LAYOUT_TYPE_PROPERTY]);
#line 527 "InputSource.c"
	}
}

const gchar*
keyboard_input_source_get_name (KeyboardInputSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 85 "../src/InputSources/InputSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../src/InputSources/InputSource.vala"
	_tmp0_ = self->priv->_name;
#line 85 "../src/InputSources/InputSource.vala"
	result = _tmp0_;
#line 85 "../src/InputSources/InputSource.vala"
	return result;
#line 544 "InputSource.c"
}

static void
keyboard_input_source_set_name (KeyboardInputSource* self,
                                const gchar* value)
{
	gchar* old_value;
#line 85 "../src/InputSources/InputSource.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/InputSources/InputSource.vala"
	old_value = keyboard_input_source_get_name (self);
#line 85 "../src/InputSources/InputSource.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 558 "InputSource.c"
		gchar* _tmp0_;
#line 85 "../src/InputSources/InputSource.vala"
		_tmp0_ = g_strdup (value);
#line 85 "../src/InputSources/InputSource.vala"
		_g_free0 (self->priv->_name);
#line 85 "../src/InputSources/InputSource.vala"
		self->priv->_name = _tmp0_;
#line 85 "../src/InputSources/InputSource.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_input_source_properties[KEYBOARD_INPUT_SOURCE_NAME_PROPERTY]);
#line 568 "InputSource.c"
	}
}

static void
keyboard_input_source_class_init (KeyboardInputSourceClass * klass,
                                  gpointer klass_data)
{
#line 34 "../src/InputSources/InputSource.vala"
	keyboard_input_source_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/InputSources/InputSource.vala"
	g_type_class_adjust_private_offset (klass, &KeyboardInputSource_private_offset);
#line 34 "../src/InputSources/InputSource.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_keyboard_input_source_get_property;
#line 34 "../src/InputSources/InputSource.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_keyboard_input_source_set_property;
#line 34 "../src/InputSources/InputSource.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_input_source_finalize;
#line 34 "../src/InputSources/InputSource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_INPUT_SOURCE_LAYOUT_TYPE_PROPERTY, keyboard_input_source_properties[KEYBOARD_INPUT_SOURCE_LAYOUT_TYPE_PROPERTY] = g_param_spec_enum ("layout-type", "layout-type", "layout-type", KEYBOARD_TYPE_LAYOUT_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 34 "../src/InputSources/InputSource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_INPUT_SOURCE_NAME_PROPERTY, keyboard_input_source_properties[KEYBOARD_INPUT_SOURCE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 590 "InputSource.c"
}

static void
keyboard_input_source_instance_init (KeyboardInputSource * self,
                                     gpointer klass)
{
#line 34 "../src/InputSources/InputSource.vala"
	self->priv = keyboard_input_source_get_instance_private (self);
#line 599 "InputSource.c"
}

static void
keyboard_input_source_finalize (GObject * obj)
{
	KeyboardInputSource * self;
#line 34 "../src/InputSources/InputSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_TYPE_INPUT_SOURCE, KeyboardInputSource);
#line 85 "../src/InputSources/InputSource.vala"
	_g_free0 (self->priv->_name);
#line 34 "../src/InputSources/InputSource.vala"
	G_OBJECT_CLASS (keyboard_input_source_parent_class)->finalize (obj);
#line 612 "InputSource.c"
}

/**
     * Immutable class that respresents a keyboard-InputSource according to
     * "org.gnome.desktop.input-sources sources".
     * This means that the enum parameter @layout_type equals the first string in the
     * tupel of strings, and the @name parameter equals the second string.
     */
static GType
keyboard_input_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardInputSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_input_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardInputSource), 0, (GInstanceInitFunc) keyboard_input_source_instance_init, NULL };
	GType keyboard_input_source_type_id;
	keyboard_input_source_type_id = g_type_register_static (G_TYPE_OBJECT, "KeyboardInputSource", &g_define_type_info, 0);
	KeyboardInputSource_private_offset = g_type_add_instance_private (keyboard_input_source_type_id, sizeof (KeyboardInputSourcePrivate));
	return keyboard_input_source_type_id;
}

GType
keyboard_input_source_get_type (void)
{
	static volatile gsize keyboard_input_source_type_id__once = 0;
	if (g_once_init_enter (&keyboard_input_source_type_id__once)) {
		GType keyboard_input_source_type_id;
		keyboard_input_source_type_id = keyboard_input_source_get_type_once ();
		g_once_init_leave (&keyboard_input_source_type_id__once, keyboard_input_source_type_id);
	}
	return keyboard_input_source_type_id__once;
}

static void
_vala_keyboard_input_source_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	KeyboardInputSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_TYPE_INPUT_SOURCE, KeyboardInputSource);
#line 34 "../src/InputSources/InputSource.vala"
	switch (property_id) {
#line 34 "../src/InputSources/InputSource.vala"
		case KEYBOARD_INPUT_SOURCE_LAYOUT_TYPE_PROPERTY:
#line 34 "../src/InputSources/InputSource.vala"
		g_value_set_enum (value, keyboard_input_source_get_layout_type (self));
#line 34 "../src/InputSources/InputSource.vala"
		break;
#line 34 "../src/InputSources/InputSource.vala"
		case KEYBOARD_INPUT_SOURCE_NAME_PROPERTY:
#line 34 "../src/InputSources/InputSource.vala"
		g_value_set_string (value, keyboard_input_source_get_name (self));
#line 34 "../src/InputSources/InputSource.vala"
		break;
#line 665 "InputSource.c"
		default:
#line 34 "../src/InputSources/InputSource.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/InputSources/InputSource.vala"
		break;
#line 671 "InputSource.c"
	}
}

static void
_vala_keyboard_input_source_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	KeyboardInputSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_TYPE_INPUT_SOURCE, KeyboardInputSource);
#line 34 "../src/InputSources/InputSource.vala"
	switch (property_id) {
#line 34 "../src/InputSources/InputSource.vala"
		case KEYBOARD_INPUT_SOURCE_LAYOUT_TYPE_PROPERTY:
#line 34 "../src/InputSources/InputSource.vala"
		keyboard_input_source_set_layout_type (self, g_value_get_enum (value));
#line 34 "../src/InputSources/InputSource.vala"
		break;
#line 34 "../src/InputSources/InputSource.vala"
		case KEYBOARD_INPUT_SOURCE_NAME_PROPERTY:
#line 34 "../src/InputSources/InputSource.vala"
		keyboard_input_source_set_name (self, g_value_get_string (value));
#line 34 "../src/InputSources/InputSource.vala"
		break;
#line 697 "InputSource.c"
		default:
#line 34 "../src/InputSources/InputSource.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/InputSources/InputSource.vala"
		break;
#line 703 "InputSource.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

