/* SourceSettings.c generated by valac 0.56.10, the Vala compiler
 * generated from SourceSettings.vala, do not modify */

/*
* Copyright 2017-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "keyboard.h"
#include <gio/gio.h>

#define KEYBOARD_TYPE_SOURCE_SETTINGS (keyboard_source_settings_get_type ())
#define KEYBOARD_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings))
#define KEYBOARD_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))
#define KEYBOARD_IS_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_IS_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_SOURCE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))

typedef struct _KeyboardSourceSettings KeyboardSourceSettings;
typedef struct _KeyboardSourceSettingsClass KeyboardSourceSettingsClass;
typedef struct _KeyboardSourceSettingsPrivate KeyboardSourceSettingsPrivate;

#define KEYBOARD_TYPE_XKB_MODIFIER (keyboard_xkb_modifier_get_type ())
#define KEYBOARD_XKB_MODIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEYBOARD_TYPE_XKB_MODIFIER, KeyboardXkbModifier))
#define KEYBOARD_XKB_MODIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEYBOARD_TYPE_XKB_MODIFIER, KeyboardXkbModifierClass))
#define KEYBOARD_IS_XKB_MODIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEYBOARD_TYPE_XKB_MODIFIER))
#define KEYBOARD_IS_XKB_MODIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEYBOARD_TYPE_XKB_MODIFIER))
#define KEYBOARD_XKB_MODIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEYBOARD_TYPE_XKB_MODIFIER, KeyboardXkbModifierClass))

typedef struct _KeyboardXkbModifier KeyboardXkbModifier;
typedef struct _KeyboardXkbModifierClass KeyboardXkbModifierClass;
enum  {
	KEYBOARD_SOURCE_SETTINGS_0_PROPERTY,
	KEYBOARD_SOURCE_SETTINGS_ACTIVE_INDEX_PROPERTY,
	KEYBOARD_SOURCE_SETTINGS_ACTIVE_INPUT_SOURCE_PROPERTY,
	KEYBOARD_SOURCE_SETTINGS_ACTIVE_ENGINES_PROPERTY,
	KEYBOARD_SOURCE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* keyboard_source_settings_properties[KEYBOARD_SOURCE_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block17Data Block17Data;
typedef struct _Block18Data Block18Data;
typedef struct _Block19Data Block19Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
enum  {
	KEYBOARD_SOURCE_SETTINGS_EXTERNAL_LAYOUT_CHANGE_SIGNAL,
	KEYBOARD_SOURCE_SETTINGS_NUM_SIGNALS
};
static guint keyboard_source_settings_signals[KEYBOARD_SOURCE_SETTINGS_NUM_SIGNALS] = {0};

struct _KeyboardSourceSettings {
	GObject parent_instance;
	KeyboardSourceSettingsPrivate * priv;
};

struct _KeyboardSourceSettingsClass {
	GObjectClass parent_class;
};

struct _KeyboardSourceSettingsPrivate {
	guint _active_index;
	gchar** _active_engines;
	gint _active_engines_length1;
	gint __active_engines_size_;
	GList* input_sources;
	KeyboardXkbModifier** xkb_options_modifiers;
	gint xkb_options_modifiers_length1;
	gint _xkb_options_modifiers_size_;
	GSettings* settings;
	gboolean currently_writing;
};

struct _Block16Data {
	int _ref_count_;
	KeyboardSourceSettings* self;
	gboolean have_xkb;
};

struct _Block17Data {
	int _ref_count_;
	KeyboardSourceSettings* self;
	GList* remove_layouts;
	KeyboardLayoutType* layout_type;
};

struct _Block18Data {
	int _ref_count_;
	KeyboardSourceSettings* self;
	guint index;
	gchar* engine_name;
};

struct _Block19Data {
	int _ref_count_;
	KeyboardSourceSettings* self;
	GVariant** elements;
	gint elements_length1;
	gint _elements_size_;
	GList* xkb_sources;
	GList* ibus_sources;
};

static gint KeyboardSourceSettings_private_offset;
static gpointer keyboard_source_settings_parent_class = NULL;
static KeyboardSourceSettings* keyboard_source_settings_instance;
static KeyboardSourceSettings* keyboard_source_settings_instance = NULL;

VALA_EXTERN GType keyboard_source_settings_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType keyboard_xkb_modifier_get_type (void) G_GNUC_CONST ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN KeyboardSourceSettings* keyboard_source_settings_get_instance (void);
static KeyboardSourceSettings* keyboard_source_settings_new (void);
static KeyboardSourceSettings* keyboard_source_settings_construct (GType object_type);
static void __lambda4_ (KeyboardSourceSettings* self);
static void keyboard_source_settings_update_list_from_gsettings (KeyboardSourceSettings* self);
static void ___lambda4__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
VALA_EXTERN void keyboard_source_settings_reset (KeyboardSourceSettings* self,
                                     KeyboardLayoutType* layout_type,
                                     gboolean signal_changed);
VALA_EXTERN gboolean keyboard_source_settings_add_layout_internal (KeyboardSourceSettings* self,
                                                       KeyboardInputSource* new_layout);
static void keyboard_source_settings_add_default_keyboard_if_required (KeyboardSourceSettings* self);
VALA_EXTERN void keyboard_source_settings_add_xkb_modifier (KeyboardSourceSettings* self,
                                                KeyboardXkbModifier* modifier);
VALA_EXTERN void keyboard_xkb_modifier_update_from_gsettings (KeyboardXkbModifier* self);
static void _vala_array_add18 (KeyboardXkbModifier** * array,
                        gint* length,
                        gint* size,
                        KeyboardXkbModifier* value);
VALA_EXTERN KeyboardXkbModifier* keyboard_source_settings_get_xkb_modifier_by_name (KeyboardSourceSettings* self,
                                                                        const gchar* name);
VALA_EXTERN const gchar* keyboard_xkb_modifier_get_name (KeyboardXkbModifier* self);
static void keyboard_source_settings_switch_items (KeyboardSourceSettings* self,
                                            guint pos1,
                                            gboolean move_up);
VALA_EXTERN guint keyboard_source_settings_get_active_index (KeyboardSourceSettings* self);
VALA_EXTERN void keyboard_source_settings_set_active_index (KeyboardSourceSettings* self,
                                                guint value);
static void keyboard_source_settings_write_to_gsettings (KeyboardSourceSettings* self);
VALA_EXTERN void keyboard_source_settings_move_active_layout_up (KeyboardSourceSettings* self);
VALA_EXTERN void keyboard_source_settings_move_active_layout_down (KeyboardSourceSettings* self);
VALA_EXTERN void keyboard_source_settings_foreach_layout (KeyboardSourceSettings* self,
                                              GFunc func,
                                              gpointer func_target);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void __lambda7_ (Block16Data* _data16_,
                 KeyboardInputSource* source);
static void ___lambda7__gfunc (gconstpointer data,
                        gpointer self);
VALA_EXTERN gboolean keyboard_source_settings_add_layout (KeyboardSourceSettings* self,
                                              KeyboardInputSource* new_layout);
VALA_EXTERN void keyboard_source_settings_remove_active_layout (KeyboardSourceSettings* self);
VALA_EXTERN KeyboardInputSource* keyboard_source_settings_get_active_input_source (KeyboardSourceSettings* self);
static KeyboardLayoutType* _keyboard_layout_type_dup (KeyboardLayoutType* self);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void __lambda5_ (Block17Data* _data17_,
                 KeyboardInputSource* source);
static gboolean _keyboard_layout_type_equal (const KeyboardLayoutType * s1,
                                      const KeyboardLayoutType * s2);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static void __lambda6_ (KeyboardSourceSettings* self,
                 KeyboardInputSource* layout);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
static void keyboard_source_settings_update_input_sources_ibus (KeyboardSourceSettings* self);
VALA_EXTERN gchar** keyboard_source_settings_get_active_engines (KeyboardSourceSettings* self,
                                                     gint* result_length1);
VALA_EXTERN gboolean keyboard_source_settings_add_active_engine (KeyboardSourceSettings* self,
                                                     const gchar* engine_name);
static gchar** _vala_array_dup11 (gchar** self,
                           gssize length);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void keyboard_source_settings_set_active_engines (KeyboardSourceSettings* self,
                                                  gchar** value,
                                                  gint value_length1);
VALA_EXTERN void keyboard_source_settings_set_active_engine_name (KeyboardSourceSettings* self,
                                                      const gchar* engine_name);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void __lambda11_ (Block18Data* _data18_,
                  KeyboardInputSource* input_source);
static void ___lambda11__gfunc (gconstpointer data,
                         gpointer self);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void ___lambda8_ (Block19Data* _data19_,
                  KeyboardInputSource* input_source);
static void ____lambda8__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda9_ (Block19Data* _data19_,
                  KeyboardInputSource* input_source);
static void _vala_array_add20 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
static void ____lambda9__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda10_ (Block19Data* _data19_,
                   KeyboardInputSource* input_source);
static void _vala_array_add21 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
static void ____lambda10__gfunc (gconstpointer data,
                          gpointer self);
static GObject * keyboard_source_settings_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void keyboard_source_settings_finalize (GObject * obj);
static GType keyboard_source_settings_get_type_once (void);
static void _vala_keyboard_source_settings_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_keyboard_source_settings_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
keyboard_source_settings_get_instance_private (KeyboardSourceSettings* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardSourceSettings_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 51 "../src/InputSources/SourceSettings.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 273 "SourceSettings.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 51 "../src/InputSources/SourceSettings.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 281 "SourceSettings.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 67 "../src/InputSources/SourceSettings.vala"
	return self ? g_object_ref (self) : NULL;
#line 289 "SourceSettings.c"
}

KeyboardSourceSettings*
keyboard_source_settings_get_instance (void)
{
	KeyboardSourceSettings* _tmp0_;
	KeyboardSourceSettings* _tmp2_;
	KeyboardSourceSettings* _tmp3_;
	KeyboardSourceSettings* result;
#line 64 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_source_settings_instance;
#line 64 "../src/InputSources/SourceSettings.vala"
	if (_tmp0_ == NULL) {
#line 303 "SourceSettings.c"
		KeyboardSourceSettings* _tmp1_;
#line 65 "../src/InputSources/SourceSettings.vala"
		_tmp1_ = keyboard_source_settings_new ();
#line 65 "../src/InputSources/SourceSettings.vala"
		_g_object_unref0 (keyboard_source_settings_instance);
#line 65 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_instance = _tmp1_;
#line 311 "SourceSettings.c"
	}
#line 67 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = keyboard_source_settings_instance;
#line 67 "../src/InputSources/SourceSettings.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 67 "../src/InputSources/SourceSettings.vala"
	result = _tmp3_;
#line 67 "../src/InputSources/SourceSettings.vala"
	return result;
#line 321 "SourceSettings.c"
}

static void
__lambda4_ (KeyboardSourceSettings* self)
{
#line 78 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_update_list_from_gsettings (self);
#line 79 "../src/InputSources/SourceSettings.vala"
	g_signal_emit (self, keyboard_source_settings_signals[KEYBOARD_SOURCE_SETTINGS_EXTERNAL_LAYOUT_CHANGE_SIGNAL], 0);
#line 331 "SourceSettings.c"
}

static void
___lambda4__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 77 "../src/InputSources/SourceSettings.vala"
	__lambda4_ ((KeyboardSourceSettings*) self);
#line 341 "SourceSettings.c"
}

static KeyboardSourceSettings*
keyboard_source_settings_construct (GType object_type)
{
	KeyboardSourceSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
#line 74 "../src/InputSources/SourceSettings.vala"
	self = (KeyboardSourceSettings*) g_object_new (object_type, NULL);
#line 75 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.input-sources");
#line 75 "../src/InputSources/SourceSettings.vala"
	_g_object_unref0 (self->priv->settings);
#line 75 "../src/InputSources/SourceSettings.vala"
	self->priv->settings = _tmp0_;
#line 77 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = self->priv->settings;
#line 77 "../src/InputSources/SourceSettings.vala"
	g_signal_connect_object (_tmp1_, "changed::sources", (GCallback) ___lambda4__g_settings_changed, self, 0);
#line 82 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = self->priv->settings;
#line 82 "../src/InputSources/SourceSettings.vala"
	g_settings_bind (_tmp2_, "current", (GObject*) self, "active-index", G_SETTINGS_BIND_DEFAULT);
#line 84 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_update_list_from_gsettings (self);
#line 74 "../src/InputSources/SourceSettings.vala"
	return self;
#line 371 "SourceSettings.c"
}

static KeyboardSourceSettings*
keyboard_source_settings_new (void)
{
#line 74 "../src/InputSources/SourceSettings.vala"
	return keyboard_source_settings_construct (KEYBOARD_TYPE_SOURCE_SETTINGS);
#line 379 "SourceSettings.c"
}

static void
keyboard_source_settings_update_list_from_gsettings (KeyboardSourceSettings* self)
{
	GVariant* sources = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
#line 87 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/InputSources/SourceSettings.vala"
	if (self->priv->currently_writing) {
#line 90 "../src/InputSources/SourceSettings.vala"
		return;
#line 399 "SourceSettings.c"
	}
#line 93 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_reset (self, NULL, TRUE);
#line 95 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->settings;
#line 95 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "sources");
#line 95 "../src/InputSources/SourceSettings.vala"
	sources = _tmp1_;
#line 96 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = sources;
#line 96 "../src/InputSources/SourceSettings.vala"
	_tmp3_ = g_variant_get_type (_tmp2_);
#line 96 "../src/InputSources/SourceSettings.vala"
	_tmp4_ = g_variant_type_dup_string (_tmp3_);
#line 96 "../src/InputSources/SourceSettings.vala"
	_tmp5_ = _tmp4_;
#line 96 "../src/InputSources/SourceSettings.vala"
	_tmp6_ = g_strcmp0 (_tmp5_, "a(ss)") == 0;
#line 96 "../src/InputSources/SourceSettings.vala"
	_g_free0 (_tmp5_);
#line 96 "../src/InputSources/SourceSettings.vala"
	if (_tmp6_) {
#line 423 "SourceSettings.c"
		{
			gsize i = 0UL;
#line 97 "../src/InputSources/SourceSettings.vala"
			i = (gsize) 0;
#line 428 "SourceSettings.c"
			{
				gboolean _tmp7_ = FALSE;
#line 97 "../src/InputSources/SourceSettings.vala"
				_tmp7_ = TRUE;
#line 97 "../src/InputSources/SourceSettings.vala"
				while (TRUE) {
#line 435 "SourceSettings.c"
					GVariant* _tmp9_;
					GVariant* child = NULL;
					GVariant* _tmp10_;
					GVariant* _tmp11_;
					GVariant* _tmp12_;
					KeyboardInputSource* _tmp13_;
					KeyboardInputSource* _tmp14_;
#line 97 "../src/InputSources/SourceSettings.vala"
					if (!_tmp7_) {
#line 445 "SourceSettings.c"
						gsize _tmp8_;
#line 97 "../src/InputSources/SourceSettings.vala"
						_tmp8_ = i;
#line 97 "../src/InputSources/SourceSettings.vala"
						i = _tmp8_ + 1;
#line 451 "SourceSettings.c"
					}
#line 97 "../src/InputSources/SourceSettings.vala"
					_tmp7_ = FALSE;
#line 97 "../src/InputSources/SourceSettings.vala"
					_tmp9_ = sources;
#line 97 "../src/InputSources/SourceSettings.vala"
					if (!(i < g_variant_n_children (_tmp9_))) {
#line 97 "../src/InputSources/SourceSettings.vala"
						break;
#line 461 "SourceSettings.c"
					}
#line 98 "../src/InputSources/SourceSettings.vala"
					_tmp10_ = sources;
#line 98 "../src/InputSources/SourceSettings.vala"
					_tmp11_ = g_variant_get_child_value (_tmp10_, i);
#line 98 "../src/InputSources/SourceSettings.vala"
					child = _tmp11_;
#line 99 "../src/InputSources/SourceSettings.vala"
					_tmp12_ = child;
#line 99 "../src/InputSources/SourceSettings.vala"
					_tmp13_ = keyboard_input_source_new_from_variant (_tmp12_);
#line 99 "../src/InputSources/SourceSettings.vala"
					_tmp14_ = _tmp13_;
#line 99 "../src/InputSources/SourceSettings.vala"
					keyboard_source_settings_add_layout_internal (self, _tmp14_);
#line 99 "../src/InputSources/SourceSettings.vala"
					_g_object_unref0 (_tmp14_);
#line 97 "../src/InputSources/SourceSettings.vala"
					_g_variant_unref0 (child);
#line 481 "SourceSettings.c"
				}
			}
		}
#line 102 "../src/InputSources/SourceSettings.vala"
		g_signal_emit (self, keyboard_source_settings_signals[KEYBOARD_SOURCE_SETTINGS_EXTERNAL_LAYOUT_CHANGE_SIGNAL], 0);
#line 487 "SourceSettings.c"
	} else {
#line 104 "../src/InputSources/SourceSettings.vala"
		g_warning ("SourceSettings.vala:104: GSettings sources of unexpected type");
#line 491 "SourceSettings.c"
	}
#line 107 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_add_default_keyboard_if_required (self);
#line 87 "../src/InputSources/SourceSettings.vala"
	_g_variant_unref0 (sources);
#line 497 "SourceSettings.c"
}

static void
_vala_array_add18 (KeyboardXkbModifier** * array,
                   gint* length,
                   gint* size,
                   KeyboardXkbModifier* value)
{
#line 113 "../src/InputSources/SourceSettings.vala"
	if ((*length) == (*size)) {
#line 113 "../src/InputSources/SourceSettings.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 113 "../src/InputSources/SourceSettings.vala"
		*array = g_renew (KeyboardXkbModifier*, *array, (*size) + 1);
#line 512 "SourceSettings.c"
	}
#line 113 "../src/InputSources/SourceSettings.vala"
	(*array)[(*length)++] = value;
#line 113 "../src/InputSources/SourceSettings.vala"
	(*array)[*length] = NULL;
#line 518 "SourceSettings.c"
}

void
keyboard_source_settings_add_xkb_modifier (KeyboardSourceSettings* self,
                                           KeyboardXkbModifier* modifier)
{
	KeyboardXkbModifier* _tmp0_;
#line 110 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (modifier != NULL);
#line 112 "../src/InputSources/SourceSettings.vala"
	keyboard_xkb_modifier_update_from_gsettings (modifier);
#line 113 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = _g_object_ref0 (modifier);
#line 113 "../src/InputSources/SourceSettings.vala"
	_vala_array_add18 (&self->priv->xkb_options_modifiers, &self->priv->xkb_options_modifiers_length1, &self->priv->_xkb_options_modifiers_size_, _tmp0_);
#line 536 "SourceSettings.c"
}

KeyboardXkbModifier*
keyboard_source_settings_get_xkb_modifier_by_name (KeyboardSourceSettings* self,
                                                   const gchar* name)
{
	KeyboardXkbModifier** _tmp0_;
	gint _tmp0__length1;
	KeyboardXkbModifier* result;
#line 116 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 117 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->xkb_options_modifiers;
#line 117 "../src/InputSources/SourceSettings.vala"
	_tmp0__length1 = self->priv->xkb_options_modifiers_length1;
#line 554 "SourceSettings.c"
	{
		KeyboardXkbModifier** modifier_collection = NULL;
		gint modifier_collection_length1 = 0;
		gint _modifier_collection_size_ = 0;
		gint modifier_it = 0;
#line 117 "../src/InputSources/SourceSettings.vala"
		modifier_collection = _tmp0_;
#line 117 "../src/InputSources/SourceSettings.vala"
		modifier_collection_length1 = _tmp0__length1;
#line 117 "../src/InputSources/SourceSettings.vala"
		for (modifier_it = 0; modifier_it < modifier_collection_length1; modifier_it = modifier_it + 1) {
#line 566 "SourceSettings.c"
			KeyboardXkbModifier* _tmp1_;
			KeyboardXkbModifier* modifier = NULL;
#line 117 "../src/InputSources/SourceSettings.vala"
			_tmp1_ = _g_object_ref0 (modifier_collection[modifier_it]);
#line 117 "../src/InputSources/SourceSettings.vala"
			modifier = _tmp1_;
#line 573 "SourceSettings.c"
			{
				KeyboardXkbModifier* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
#line 118 "../src/InputSources/SourceSettings.vala"
				_tmp2_ = modifier;
#line 118 "../src/InputSources/SourceSettings.vala"
				_tmp3_ = keyboard_xkb_modifier_get_name (_tmp2_);
#line 118 "../src/InputSources/SourceSettings.vala"
				_tmp4_ = _tmp3_;
#line 118 "../src/InputSources/SourceSettings.vala"
				if (g_strcmp0 (_tmp4_, name) == 0) {
#line 119 "../src/InputSources/SourceSettings.vala"
					result = modifier;
#line 119 "../src/InputSources/SourceSettings.vala"
					return result;
#line 590 "SourceSettings.c"
				}
#line 117 "../src/InputSources/SourceSettings.vala"
				_g_object_unref0 (modifier);
#line 594 "SourceSettings.c"
			}
		}
	}
#line 123 "../src/InputSources/SourceSettings.vala"
	result = NULL;
#line 123 "../src/InputSources/SourceSettings.vala"
	return result;
#line 602 "SourceSettings.c"
}

static void
keyboard_source_settings_switch_items (KeyboardSourceSettings* self,
                                       guint pos1,
                                       gboolean move_up)
{
	guint _tmp0_ = 0U;
	guint pos2 = 0U;
	GList* container1 = NULL;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* container2 = NULL;
	GList* _tmp3_;
	GList* _tmp4_;
	guint max_pos = 0U;
	GList* _tmp5_;
	KeyboardInputSource* tmp = NULL;
	GList* _tmp18_;
	gconstpointer _tmp19_;
	KeyboardInputSource* _tmp20_;
	GList* _tmp21_;
	GList* _tmp22_;
	gconstpointer _tmp23_;
	KeyboardInputSource* _tmp24_;
	GList* _tmp25_;
	KeyboardInputSource* _tmp26_;
	KeyboardInputSource* _tmp27_;
	guint _tmp28_;
#line 126 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/InputSources/SourceSettings.vala"
	if (move_up) {
#line 127 "../src/InputSources/SourceSettings.vala"
		_tmp0_ = pos1 - 1;
#line 638 "SourceSettings.c"
	} else {
#line 127 "../src/InputSources/SourceSettings.vala"
		_tmp0_ = pos1 + 1;
#line 642 "SourceSettings.c"
	}
#line 127 "../src/InputSources/SourceSettings.vala"
	pos2 = _tmp0_;
#line 128 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = self->priv->input_sources;
#line 128 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = g_list_nth (_tmp1_, pos1);
#line 128 "../src/InputSources/SourceSettings.vala"
	container1 = _tmp2_;
#line 129 "../src/InputSources/SourceSettings.vala"
	_tmp3_ = self->priv->input_sources;
#line 129 "../src/InputSources/SourceSettings.vala"
	_tmp4_ = g_list_nth (_tmp3_, pos2);
#line 129 "../src/InputSources/SourceSettings.vala"
	container2 = _tmp4_;
#line 131 "../src/InputSources/SourceSettings.vala"
	_tmp5_ = self->priv->input_sources;
#line 131 "../src/InputSources/SourceSettings.vala"
	max_pos = g_list_length (_tmp5_) - 1;
#line 132 "../src/InputSources/SourceSettings.vala"
	while (TRUE) {
#line 664 "SourceSettings.c"
		GList* _tmp6_;
		gconstpointer _tmp7_;
		KeyboardLayoutType _tmp8_;
		KeyboardLayoutType _tmp9_;
		GList* _tmp10_;
		gconstpointer _tmp11_;
		KeyboardLayoutType _tmp12_;
		KeyboardLayoutType _tmp13_;
		guint _tmp14_ = 0U;
		gboolean _tmp15_ = FALSE;
		GList* _tmp16_;
		GList* _tmp17_;
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp6_ = container1;
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp7_ = _tmp6_->data;
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp8_ = keyboard_input_source_get_layout_type ((KeyboardInputSource*) _tmp7_);
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp9_ = _tmp8_;
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp10_ = container2;
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp11_ = _tmp10_->data;
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp12_ = keyboard_input_source_get_layout_type ((KeyboardInputSource*) _tmp11_);
#line 132 "../src/InputSources/SourceSettings.vala"
		_tmp13_ = _tmp12_;
#line 132 "../src/InputSources/SourceSettings.vala"
		if (!(_tmp9_ != _tmp13_)) {
#line 132 "../src/InputSources/SourceSettings.vala"
			break;
#line 697 "SourceSettings.c"
		}
#line 133 "../src/InputSources/SourceSettings.vala"
		if (move_up) {
#line 133 "../src/InputSources/SourceSettings.vala"
			_tmp14_ = pos2 - 1;
#line 703 "SourceSettings.c"
		} else {
#line 133 "../src/InputSources/SourceSettings.vala"
			_tmp14_ = pos2 + 1;
#line 707 "SourceSettings.c"
		}
#line 133 "../src/InputSources/SourceSettings.vala"
		pos2 = _tmp14_;
#line 134 "../src/InputSources/SourceSettings.vala"
		if (pos2 < ((guint) 0)) {
#line 134 "../src/InputSources/SourceSettings.vala"
			_tmp15_ = TRUE;
#line 715 "SourceSettings.c"
		} else {
#line 134 "../src/InputSources/SourceSettings.vala"
			_tmp15_ = pos2 > max_pos;
#line 719 "SourceSettings.c"
		}
#line 134 "../src/InputSources/SourceSettings.vala"
		if (_tmp15_) {
#line 135 "../src/InputSources/SourceSettings.vala"
			return;
#line 725 "SourceSettings.c"
		}
#line 138 "../src/InputSources/SourceSettings.vala"
		_tmp16_ = self->priv->input_sources;
#line 138 "../src/InputSources/SourceSettings.vala"
		_tmp17_ = g_list_nth (_tmp16_, pos2);
#line 138 "../src/InputSources/SourceSettings.vala"
		container2 = _tmp17_;
#line 733 "SourceSettings.c"
	}
#line 141 "../src/InputSources/SourceSettings.vala"
	_tmp18_ = container1;
#line 141 "../src/InputSources/SourceSettings.vala"
	_tmp19_ = _tmp18_->data;
#line 141 "../src/InputSources/SourceSettings.vala"
	_tmp20_ = _g_object_ref0 ((KeyboardInputSource*) _tmp19_);
#line 141 "../src/InputSources/SourceSettings.vala"
	tmp = _tmp20_;
#line 142 "../src/InputSources/SourceSettings.vala"
	_tmp21_ = container1;
#line 142 "../src/InputSources/SourceSettings.vala"
	_tmp22_ = container2;
#line 142 "../src/InputSources/SourceSettings.vala"
	_tmp23_ = _tmp22_->data;
#line 142 "../src/InputSources/SourceSettings.vala"
	_tmp24_ = _g_object_ref0 ((KeyboardInputSource*) _tmp23_);
#line 142 "../src/InputSources/SourceSettings.vala"
	_g_object_unref0 (_tmp21_->data);
#line 142 "../src/InputSources/SourceSettings.vala"
	_tmp21_->data = _tmp24_;
#line 143 "../src/InputSources/SourceSettings.vala"
	_tmp25_ = container2;
#line 143 "../src/InputSources/SourceSettings.vala"
	_tmp26_ = tmp;
#line 143 "../src/InputSources/SourceSettings.vala"
	_tmp27_ = _g_object_ref0 (_tmp26_);
#line 143 "../src/InputSources/SourceSettings.vala"
	_g_object_unref0 (_tmp25_->data);
#line 143 "../src/InputSources/SourceSettings.vala"
	_tmp25_->data = _tmp27_;
#line 145 "../src/InputSources/SourceSettings.vala"
	_tmp28_ = self->priv->_active_index;
#line 145 "../src/InputSources/SourceSettings.vala"
	if (_tmp28_ == pos1) {
#line 146 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_set_active_index (self, pos2);
#line 771 "SourceSettings.c"
	} else {
		guint _tmp29_;
#line 147 "../src/InputSources/SourceSettings.vala"
		_tmp29_ = self->priv->_active_index;
#line 147 "../src/InputSources/SourceSettings.vala"
		if (_tmp29_ == pos2) {
#line 148 "../src/InputSources/SourceSettings.vala"
			keyboard_source_settings_set_active_index (self, pos1);
#line 780 "SourceSettings.c"
		}
	}
#line 151 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_write_to_gsettings (self);
#line 126 "../src/InputSources/SourceSettings.vala"
	_g_object_unref0 (tmp);
#line 787 "SourceSettings.c"
}

void
keyboard_source_settings_move_active_layout_up (KeyboardSourceSettings* self)
{
	GList* _tmp0_;
	guint _tmp1_;
#line 154 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->input_sources;
#line 155 "../src/InputSources/SourceSettings.vala"
	if (g_list_length (_tmp0_) == ((guint) 0)) {
#line 156 "../src/InputSources/SourceSettings.vala"
		return;
#line 803 "SourceSettings.c"
	}
#line 160 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = self->priv->_active_index;
#line 160 "../src/InputSources/SourceSettings.vala"
	if (_tmp1_ > ((guint) 0)) {
#line 809 "SourceSettings.c"
		guint _tmp2_;
#line 161 "../src/InputSources/SourceSettings.vala"
		_tmp2_ = self->priv->_active_index;
#line 161 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_switch_items (self, _tmp2_, TRUE);
#line 815 "SourceSettings.c"
	}
}

void
keyboard_source_settings_move_active_layout_down (KeyboardSourceSettings* self)
{
	GList* _tmp0_;
	guint _tmp1_;
	GList* _tmp2_;
#line 165 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->input_sources;
#line 166 "../src/InputSources/SourceSettings.vala"
	if (g_list_length (_tmp0_) == ((guint) 0)) {
#line 167 "../src/InputSources/SourceSettings.vala"
		return;
#line 833 "SourceSettings.c"
	}
#line 170 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = self->priv->_active_index;
#line 170 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = self->priv->input_sources;
#line 170 "../src/InputSources/SourceSettings.vala"
	if (_tmp1_ < (g_list_length (_tmp2_) - 1)) {
#line 841 "SourceSettings.c"
		guint _tmp3_;
#line 171 "../src/InputSources/SourceSettings.vala"
		_tmp3_ = self->priv->_active_index;
#line 171 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_switch_items (self, _tmp3_, FALSE);
#line 847 "SourceSettings.c"
	}
}

void
keyboard_source_settings_foreach_layout (KeyboardSourceSettings* self,
                                         GFunc func,
                                         gpointer func_target)
{
	GList* _tmp0_;
#line 175 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->input_sources;
#line 176 "../src/InputSources/SourceSettings.vala"
	g_list_foreach (_tmp0_, func, func_target);
#line 863 "SourceSettings.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 179 "../src/InputSources/SourceSettings.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 179 "../src/InputSources/SourceSettings.vala"
	return _data16_;
#line 873 "SourceSettings.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 179 "../src/InputSources/SourceSettings.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 883 "SourceSettings.c"
		KeyboardSourceSettings* self;
#line 179 "../src/InputSources/SourceSettings.vala"
		self = _data16_->self;
#line 179 "../src/InputSources/SourceSettings.vala"
		_g_object_unref0 (self);
#line 179 "../src/InputSources/SourceSettings.vala"
		g_slice_free (Block16Data, _data16_);
#line 891 "SourceSettings.c"
	}
}

static void
__lambda7_ (Block16Data* _data16_,
            KeyboardInputSource* source)
{
	KeyboardSourceSettings* self;
	KeyboardLayoutType _tmp0_;
	KeyboardLayoutType _tmp1_;
#line 181 "../src/InputSources/SourceSettings.vala"
	self = _data16_->self;
#line 181 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (source != NULL);
#line 182 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_input_source_get_layout_type (source);
#line 182 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/InputSources/SourceSettings.vala"
	if (_tmp1_ == KEYBOARD_LAYOUT_TYPE_XKB) {
#line 183 "../src/InputSources/SourceSettings.vala"
		_data16_->have_xkb = TRUE;
#line 914 "SourceSettings.c"
	}
}

static void
___lambda7__gfunc (gconstpointer data,
                   gpointer self)
{
#line 181 "../src/InputSources/SourceSettings.vala"
	__lambda7_ (self, (KeyboardInputSource*) data);
#line 924 "SourceSettings.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 943 "SourceSettings.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 965 "SourceSettings.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 969 "SourceSettings.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 975 "SourceSettings.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 979 "SourceSettings.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 983 "SourceSettings.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 991 "SourceSettings.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1019 "SourceSettings.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1028 "SourceSettings.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1042 "SourceSettings.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1051 "SourceSettings.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1065 "SourceSettings.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1074 "SourceSettings.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1083 "SourceSettings.c"
}

static void
keyboard_source_settings_add_default_keyboard_if_required (KeyboardSourceSettings* self)
{
	Block16Data* _data16_;
	GList* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 179 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/InputSources/SourceSettings.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 179 "../src/InputSources/SourceSettings.vala"
	_data16_->_ref_count_ = 1;
#line 179 "../src/InputSources/SourceSettings.vala"
	_data16_->self = g_object_ref (self);
#line 180 "../src/InputSources/SourceSettings.vala"
	_data16_->have_xkb = FALSE;
#line 181 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->input_sources;
#line 181 "../src/InputSources/SourceSettings.vala"
	g_list_foreach (_tmp0_, ___lambda7__gfunc, _data16_);
#line 187 "../src/InputSources/SourceSettings.vala"
	if (!_data16_->have_xkb) {
#line 1108 "SourceSettings.c"
		GFile* file = NULL;
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* xkb_layout = NULL;
		gchar* _tmp6_;
		gchar* xkb_variant = NULL;
		gchar* _tmp7_;
		gchar** variants = NULL;
		const gchar* _tmp34_;
		gchar** _tmp35_;
		gchar** _tmp36_;
		gint variants_length1;
		gint _variants_size_;
		gchar** xkb_layouts = NULL;
		const gchar* _tmp37_;
		gchar** _tmp38_;
		gchar** _tmp39_;
		gint xkb_layouts_length1;
		gint _xkb_layouts_size_;
#line 188 "../src/InputSources/SourceSettings.vala"
		_tmp1_ = g_file_new_for_path ("/etc/default/keyboard");
#line 188 "../src/InputSources/SourceSettings.vala"
		file = _tmp1_;
#line 190 "../src/InputSources/SourceSettings.vala"
		_tmp2_ = file;
#line 190 "../src/InputSources/SourceSettings.vala"
		if (!g_file_query_exists (_tmp2_, NULL)) {
#line 1136 "SourceSettings.c"
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 191 "../src/InputSources/SourceSettings.vala"
			_tmp3_ = file;
#line 191 "../src/InputSources/SourceSettings.vala"
			_tmp4_ = g_file_get_path (_tmp3_);
#line 191 "../src/InputSources/SourceSettings.vala"
			_tmp5_ = _tmp4_;
#line 191 "../src/InputSources/SourceSettings.vala"
			g_warning ("SourceSettings.vala:191: File '%s' doesn't exist.\n", _tmp5_);
#line 191 "../src/InputSources/SourceSettings.vala"
			_g_free0 (_tmp5_);
#line 192 "../src/InputSources/SourceSettings.vala"
			_g_object_unref0 (file);
#line 192 "../src/InputSources/SourceSettings.vala"
			block16_data_unref (_data16_);
#line 192 "../src/InputSources/SourceSettings.vala"
			_data16_ = NULL;
#line 192 "../src/InputSources/SourceSettings.vala"
			return;
#line 1158 "SourceSettings.c"
		}
#line 195 "../src/InputSources/SourceSettings.vala"
		_tmp6_ = g_strdup ("");
#line 195 "../src/InputSources/SourceSettings.vala"
		xkb_layout = _tmp6_;
#line 196 "../src/InputSources/SourceSettings.vala"
		_tmp7_ = g_strdup ("");
#line 196 "../src/InputSources/SourceSettings.vala"
		xkb_variant = _tmp7_;
#line 1168 "SourceSettings.c"
		{
			GFileInputStream* _tmp8_ = NULL;
			GFile* _tmp9_;
			GFileInputStream* _tmp10_;
			GDataInputStream* dis = NULL;
			GDataInputStream* _tmp11_;
			gchar* line = NULL;
#line 199 "../src/InputSources/SourceSettings.vala"
			_tmp9_ = file;
#line 199 "../src/InputSources/SourceSettings.vala"
			_tmp10_ = g_file_read (_tmp9_, NULL, &_inner_error0_);
#line 199 "../src/InputSources/SourceSettings.vala"
			_tmp8_ = _tmp10_;
#line 199 "../src/InputSources/SourceSettings.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1184 "SourceSettings.c"
				goto __catch0_g_error;
			}
#line 199 "../src/InputSources/SourceSettings.vala"
			_tmp11_ = g_data_input_stream_new ((GInputStream*) _tmp8_);
#line 199 "../src/InputSources/SourceSettings.vala"
			dis = _tmp11_;
#line 203 "../src/InputSources/SourceSettings.vala"
			while (TRUE) {
#line 1193 "SourceSettings.c"
				gchar* _tmp12_ = NULL;
				GDataInputStream* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
#line 203 "../src/InputSources/SourceSettings.vala"
				_tmp13_ = dis;
#line 203 "../src/InputSources/SourceSettings.vala"
				_tmp14_ = g_data_input_stream_read_line (_tmp13_, NULL, NULL, &_inner_error0_);
#line 203 "../src/InputSources/SourceSettings.vala"
				_tmp12_ = _tmp14_;
#line 203 "../src/InputSources/SourceSettings.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/InputSources/SourceSettings.vala"
					_g_free0 (line);
#line 203 "../src/InputSources/SourceSettings.vala"
					_g_object_unref0 (dis);
#line 203 "../src/InputSources/SourceSettings.vala"
					_g_object_unref0 (_tmp8_);
#line 1214 "SourceSettings.c"
					goto __catch0_g_error;
				}
#line 203 "../src/InputSources/SourceSettings.vala"
				_tmp15_ = _tmp12_;
#line 203 "../src/InputSources/SourceSettings.vala"
				_tmp12_ = NULL;
#line 203 "../src/InputSources/SourceSettings.vala"
				_g_free0 (line);
#line 203 "../src/InputSources/SourceSettings.vala"
				line = _tmp15_;
#line 203 "../src/InputSources/SourceSettings.vala"
				_tmp16_ = line;
#line 203 "../src/InputSources/SourceSettings.vala"
				if (!(_tmp16_ != NULL)) {
#line 203 "../src/InputSources/SourceSettings.vala"
					_g_free0 (_tmp12_);
#line 203 "../src/InputSources/SourceSettings.vala"
					break;
#line 1233 "SourceSettings.c"
				}
#line 204 "../src/InputSources/SourceSettings.vala"
				_tmp17_ = line;
#line 204 "../src/InputSources/SourceSettings.vala"
				if (string_contains (_tmp17_, "XKBLAYOUT=")) {
#line 1239 "SourceSettings.c"
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
#line 205 "../src/InputSources/SourceSettings.vala"
					_tmp18_ = line;
#line 205 "../src/InputSources/SourceSettings.vala"
					_tmp19_ = string_replace (_tmp18_, "XKBLAYOUT=", "");
#line 205 "../src/InputSources/SourceSettings.vala"
					_tmp20_ = _tmp19_;
#line 205 "../src/InputSources/SourceSettings.vala"
					_tmp21_ = string_replace (_tmp20_, "\"", "");
#line 205 "../src/InputSources/SourceSettings.vala"
					_g_free0 (xkb_layout);
#line 205 "../src/InputSources/SourceSettings.vala"
					xkb_layout = _tmp21_;
#line 205 "../src/InputSources/SourceSettings.vala"
					_g_free0 (_tmp20_);
#line 207 "../src/InputSources/SourceSettings.vala"
					while (TRUE) {
#line 1260 "SourceSettings.c"
						gchar* _tmp22_ = NULL;
						GDataInputStream* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						const gchar* _tmp26_;
						const gchar* _tmp27_;
#line 207 "../src/InputSources/SourceSettings.vala"
						_tmp23_ = dis;
#line 207 "../src/InputSources/SourceSettings.vala"
						_tmp24_ = g_data_input_stream_read_line (_tmp23_, NULL, NULL, &_inner_error0_);
#line 207 "../src/InputSources/SourceSettings.vala"
						_tmp22_ = _tmp24_;
#line 207 "../src/InputSources/SourceSettings.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/InputSources/SourceSettings.vala"
							_g_free0 (_tmp12_);
#line 207 "../src/InputSources/SourceSettings.vala"
							_g_free0 (line);
#line 207 "../src/InputSources/SourceSettings.vala"
							_g_object_unref0 (dis);
#line 207 "../src/InputSources/SourceSettings.vala"
							_g_object_unref0 (_tmp8_);
#line 1283 "SourceSettings.c"
							goto __catch0_g_error;
						}
#line 207 "../src/InputSources/SourceSettings.vala"
						_tmp25_ = _tmp22_;
#line 207 "../src/InputSources/SourceSettings.vala"
						_tmp22_ = NULL;
#line 207 "../src/InputSources/SourceSettings.vala"
						_g_free0 (line);
#line 207 "../src/InputSources/SourceSettings.vala"
						line = _tmp25_;
#line 207 "../src/InputSources/SourceSettings.vala"
						_tmp26_ = line;
#line 207 "../src/InputSources/SourceSettings.vala"
						if (!(_tmp26_ != NULL)) {
#line 207 "../src/InputSources/SourceSettings.vala"
							_g_free0 (_tmp22_);
#line 207 "../src/InputSources/SourceSettings.vala"
							break;
#line 1302 "SourceSettings.c"
						}
#line 208 "../src/InputSources/SourceSettings.vala"
						_tmp27_ = line;
#line 208 "../src/InputSources/SourceSettings.vala"
						if (string_contains (_tmp27_, "XKBVARIANT=")) {
#line 1308 "SourceSettings.c"
							const gchar* _tmp28_;
							gchar* _tmp29_;
							gchar* _tmp30_;
							gchar* _tmp31_;
#line 209 "../src/InputSources/SourceSettings.vala"
							_tmp28_ = line;
#line 209 "../src/InputSources/SourceSettings.vala"
							_tmp29_ = string_replace (_tmp28_, "XKBVARIANT=", "");
#line 209 "../src/InputSources/SourceSettings.vala"
							_tmp30_ = _tmp29_;
#line 209 "../src/InputSources/SourceSettings.vala"
							_tmp31_ = string_replace (_tmp30_, "\"", "");
#line 209 "../src/InputSources/SourceSettings.vala"
							_g_free0 (xkb_variant);
#line 209 "../src/InputSources/SourceSettings.vala"
							xkb_variant = _tmp31_;
#line 209 "../src/InputSources/SourceSettings.vala"
							_g_free0 (_tmp30_);
#line 1327 "SourceSettings.c"
						}
#line 207 "../src/InputSources/SourceSettings.vala"
						_g_free0 (_tmp22_);
#line 1331 "SourceSettings.c"
					}
#line 213 "../src/InputSources/SourceSettings.vala"
					_g_free0 (_tmp12_);
#line 213 "../src/InputSources/SourceSettings.vala"
					break;
#line 1337 "SourceSettings.c"
				}
#line 203 "../src/InputSources/SourceSettings.vala"
				_g_free0 (_tmp12_);
#line 1341 "SourceSettings.c"
			}
#line 198 "../src/InputSources/SourceSettings.vala"
			_g_free0 (line);
#line 198 "../src/InputSources/SourceSettings.vala"
			_g_object_unref0 (dis);
#line 198 "../src/InputSources/SourceSettings.vala"
			_g_object_unref0 (_tmp8_);
#line 1349 "SourceSettings.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp32_;
			const gchar* _tmp33_;
#line 198 "../src/InputSources/SourceSettings.vala"
			e = _inner_error0_;
#line 198 "../src/InputSources/SourceSettings.vala"
			_inner_error0_ = NULL;
#line 218 "../src/InputSources/SourceSettings.vala"
			_tmp32_ = e;
#line 218 "../src/InputSources/SourceSettings.vala"
			_tmp33_ = _tmp32_->message;
#line 218 "../src/InputSources/SourceSettings.vala"
			g_warning ("SourceSettings.vala:218: %s", _tmp33_);
#line 219 "../src/InputSources/SourceSettings.vala"
			_g_error_free0 (e);
#line 219 "../src/InputSources/SourceSettings.vala"
			_g_free0 (xkb_variant);
#line 219 "../src/InputSources/SourceSettings.vala"
			_g_free0 (xkb_layout);
#line 219 "../src/InputSources/SourceSettings.vala"
			_g_object_unref0 (file);
#line 219 "../src/InputSources/SourceSettings.vala"
			block16_data_unref (_data16_);
#line 219 "../src/InputSources/SourceSettings.vala"
			_data16_ = NULL;
#line 219 "../src/InputSources/SourceSettings.vala"
			return;
#line 1381 "SourceSettings.c"
		}
		__finally0:
#line 198 "../src/InputSources/SourceSettings.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/InputSources/SourceSettings.vala"
			_g_free0 (xkb_variant);
#line 198 "../src/InputSources/SourceSettings.vala"
			_g_free0 (xkb_layout);
#line 198 "../src/InputSources/SourceSettings.vala"
			_g_object_unref0 (file);
#line 198 "../src/InputSources/SourceSettings.vala"
			block16_data_unref (_data16_);
#line 198 "../src/InputSources/SourceSettings.vala"
			_data16_ = NULL;
#line 198 "../src/InputSources/SourceSettings.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 198 "../src/InputSources/SourceSettings.vala"
			g_clear_error (&_inner_error0_);
#line 198 "../src/InputSources/SourceSettings.vala"
			return;
#line 1402 "SourceSettings.c"
		}
#line 222 "../src/InputSources/SourceSettings.vala"
		_tmp34_ = xkb_variant;
#line 222 "../src/InputSources/SourceSettings.vala"
		_tmp36_ = _tmp35_ = g_strsplit (_tmp34_, ",", 0);
#line 222 "../src/InputSources/SourceSettings.vala"
		variants = _tmp36_;
#line 222 "../src/InputSources/SourceSettings.vala"
		variants_length1 = _vala_array_length (_tmp35_);
#line 222 "../src/InputSources/SourceSettings.vala"
		_variants_size_ = variants_length1;
#line 223 "../src/InputSources/SourceSettings.vala"
		_tmp37_ = xkb_layout;
#line 223 "../src/InputSources/SourceSettings.vala"
		_tmp39_ = _tmp38_ = g_strsplit (_tmp37_, ",", 0);
#line 223 "../src/InputSources/SourceSettings.vala"
		xkb_layouts = _tmp39_;
#line 223 "../src/InputSources/SourceSettings.vala"
		xkb_layouts_length1 = _vala_array_length (_tmp38_);
#line 223 "../src/InputSources/SourceSettings.vala"
		_xkb_layouts_size_ = xkb_layouts_length1;
#line 1424 "SourceSettings.c"
		{
			gint i = 0;
#line 225 "../src/InputSources/SourceSettings.vala"
			i = 0;
#line 1429 "SourceSettings.c"
			{
				gboolean _tmp40_ = FALSE;
#line 225 "../src/InputSources/SourceSettings.vala"
				_tmp40_ = TRUE;
#line 225 "../src/InputSources/SourceSettings.vala"
				while (TRUE) {
#line 1436 "SourceSettings.c"
					gchar** _tmp42_;
					gint _tmp42__length1;
					gboolean _tmp43_ = FALSE;
					gchar** _tmp44_;
					gint _tmp44__length1;
					const gchar* _tmp45_;
#line 225 "../src/InputSources/SourceSettings.vala"
					if (!_tmp40_) {
#line 1445 "SourceSettings.c"
						gint _tmp41_;
#line 225 "../src/InputSources/SourceSettings.vala"
						_tmp41_ = i;
#line 225 "../src/InputSources/SourceSettings.vala"
						i = _tmp41_ + 1;
#line 1451 "SourceSettings.c"
					}
#line 225 "../src/InputSources/SourceSettings.vala"
					_tmp40_ = FALSE;
#line 225 "../src/InputSources/SourceSettings.vala"
					_tmp42_ = xkb_layouts;
#line 225 "../src/InputSources/SourceSettings.vala"
					_tmp42__length1 = xkb_layouts_length1;
#line 225 "../src/InputSources/SourceSettings.vala"
					if (!(i < _tmp42__length1)) {
#line 225 "../src/InputSources/SourceSettings.vala"
						break;
#line 1463 "SourceSettings.c"
					}
#line 226 "../src/InputSources/SourceSettings.vala"
					_tmp44_ = variants;
#line 226 "../src/InputSources/SourceSettings.vala"
					_tmp44__length1 = variants_length1;
#line 226 "../src/InputSources/SourceSettings.vala"
					_tmp45_ = _tmp44_[i];
#line 226 "../src/InputSources/SourceSettings.vala"
					if (_tmp45_ != NULL) {
#line 1473 "SourceSettings.c"
						gchar** _tmp46_;
						gint _tmp46__length1;
						const gchar* _tmp47_;
#line 226 "../src/InputSources/SourceSettings.vala"
						_tmp46_ = variants;
#line 226 "../src/InputSources/SourceSettings.vala"
						_tmp46__length1 = variants_length1;
#line 226 "../src/InputSources/SourceSettings.vala"
						_tmp47_ = _tmp46_[i];
#line 226 "../src/InputSources/SourceSettings.vala"
						_tmp43_ = g_strcmp0 (_tmp47_, "") != 0;
#line 1485 "SourceSettings.c"
					} else {
#line 226 "../src/InputSources/SourceSettings.vala"
						_tmp43_ = FALSE;
#line 1489 "SourceSettings.c"
					}
#line 226 "../src/InputSources/SourceSettings.vala"
					if (_tmp43_) {
#line 1493 "SourceSettings.c"
						gchar** _tmp48_;
						gint _tmp48__length1;
						const gchar* _tmp49_;
						gchar** _tmp50_;
						gint _tmp50__length1;
						const gchar* _tmp51_;
						KeyboardInputSource* _tmp52_;
						KeyboardInputSource* _tmp53_;
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp48_ = xkb_layouts;
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp48__length1 = xkb_layouts_length1;
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp49_ = _tmp48_[i];
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp50_ = variants;
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp50__length1 = variants_length1;
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp51_ = _tmp50_[i];
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp52_ = keyboard_input_source_new_xkb (_tmp49_, _tmp51_);
#line 227 "../src/InputSources/SourceSettings.vala"
						_tmp53_ = _tmp52_;
#line 227 "../src/InputSources/SourceSettings.vala"
						keyboard_source_settings_add_layout_internal (self, _tmp53_);
#line 227 "../src/InputSources/SourceSettings.vala"
						_g_object_unref0 (_tmp53_);
#line 1522 "SourceSettings.c"
					} else {
						gchar** _tmp54_;
						gint _tmp54__length1;
						const gchar* _tmp55_;
						KeyboardInputSource* _tmp56_;
						KeyboardInputSource* _tmp57_;
#line 229 "../src/InputSources/SourceSettings.vala"
						_tmp54_ = xkb_layouts;
#line 229 "../src/InputSources/SourceSettings.vala"
						_tmp54__length1 = xkb_layouts_length1;
#line 229 "../src/InputSources/SourceSettings.vala"
						_tmp55_ = _tmp54_[i];
#line 229 "../src/InputSources/SourceSettings.vala"
						_tmp56_ = keyboard_input_source_new_xkb (_tmp55_, NULL);
#line 229 "../src/InputSources/SourceSettings.vala"
						_tmp57_ = _tmp56_;
#line 229 "../src/InputSources/SourceSettings.vala"
						keyboard_source_settings_add_layout_internal (self, _tmp57_);
#line 229 "../src/InputSources/SourceSettings.vala"
						_g_object_unref0 (_tmp57_);
#line 1543 "SourceSettings.c"
					}
				}
			}
		}
#line 233 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_write_to_gsettings (self);
#line 187 "../src/InputSources/SourceSettings.vala"
		xkb_layouts = (_vala_array_free (xkb_layouts, xkb_layouts_length1, (GDestroyNotify) g_free), NULL);
#line 187 "../src/InputSources/SourceSettings.vala"
		variants = (_vala_array_free (variants, variants_length1, (GDestroyNotify) g_free), NULL);
#line 187 "../src/InputSources/SourceSettings.vala"
		_g_free0 (xkb_variant);
#line 187 "../src/InputSources/SourceSettings.vala"
		_g_free0 (xkb_layout);
#line 187 "../src/InputSources/SourceSettings.vala"
		_g_object_unref0 (file);
#line 1560 "SourceSettings.c"
	}
#line 179 "../src/InputSources/SourceSettings.vala"
	block16_data_unref (_data16_);
#line 179 "../src/InputSources/SourceSettings.vala"
	_data16_ = NULL;
#line 1566 "SourceSettings.c"
}

gboolean
keyboard_source_settings_add_layout (KeyboardSourceSettings* self,
                                     KeyboardInputSource* new_layout)
{
	gboolean result;
#line 237 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 238 "../src/InputSources/SourceSettings.vala"
	if (keyboard_source_settings_add_layout_internal (self, new_layout)) {
#line 239 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_write_to_gsettings (self);
#line 240 "../src/InputSources/SourceSettings.vala"
		result = TRUE;
#line 240 "../src/InputSources/SourceSettings.vala"
		return result;
#line 1584 "SourceSettings.c"
	}
#line 243 "../src/InputSources/SourceSettings.vala"
	result = FALSE;
#line 243 "../src/InputSources/SourceSettings.vala"
	return result;
#line 1590 "SourceSettings.c"
}

gboolean
keyboard_source_settings_add_layout_internal (KeyboardSourceSettings* self,
                                              KeyboardInputSource* new_layout)
{
	gint i = 0;
	GList* _tmp0_;
	KeyboardInputSource* _tmp4_;
	gboolean result;
#line 246 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "../src/InputSources/SourceSettings.vala"
	if (new_layout == NULL) {
#line 248 "../src/InputSources/SourceSettings.vala"
		result = FALSE;
#line 248 "../src/InputSources/SourceSettings.vala"
		return result;
#line 1609 "SourceSettings.c"
	}
#line 251 "../src/InputSources/SourceSettings.vala"
	i = 0;
#line 252 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->input_sources;
#line 1615 "SourceSettings.c"
	{
		GList* l_collection = NULL;
		GList* l_it = NULL;
#line 252 "../src/InputSources/SourceSettings.vala"
		l_collection = _tmp0_;
#line 252 "../src/InputSources/SourceSettings.vala"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
#line 1623 "SourceSettings.c"
			KeyboardInputSource* _tmp1_;
			KeyboardInputSource* l = NULL;
#line 252 "../src/InputSources/SourceSettings.vala"
			_tmp1_ = _g_object_ref0 ((KeyboardInputSource*) l_it->data);
#line 252 "../src/InputSources/SourceSettings.vala"
			l = _tmp1_;
#line 1630 "SourceSettings.c"
			{
				KeyboardInputSource* _tmp2_;
				gint _tmp3_;
#line 253 "../src/InputSources/SourceSettings.vala"
				_tmp2_ = l;
#line 253 "../src/InputSources/SourceSettings.vala"
				if (keyboard_input_source_equal (_tmp2_, new_layout)) {
#line 254 "../src/InputSources/SourceSettings.vala"
					result = FALSE;
#line 254 "../src/InputSources/SourceSettings.vala"
					_g_object_unref0 (l);
#line 254 "../src/InputSources/SourceSettings.vala"
					return result;
#line 1644 "SourceSettings.c"
				}
#line 257 "../src/InputSources/SourceSettings.vala"
				_tmp3_ = i;
#line 257 "../src/InputSources/SourceSettings.vala"
				i = _tmp3_ + 1;
#line 252 "../src/InputSources/SourceSettings.vala"
				_g_object_unref0 (l);
#line 1652 "SourceSettings.c"
			}
		}
	}
#line 260 "../src/InputSources/SourceSettings.vala"
	_tmp4_ = _g_object_ref0 (new_layout);
#line 260 "../src/InputSources/SourceSettings.vala"
	self->priv->input_sources = g_list_append (self->priv->input_sources, _tmp4_);
#line 261 "../src/InputSources/SourceSettings.vala"
	result = TRUE;
#line 261 "../src/InputSources/SourceSettings.vala"
	return result;
#line 1664 "SourceSettings.c"
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5178 "glib-2.0.vapi"
	l = self;
#line 5179 "glib-2.0.vapi"
	while (TRUE) {
#line 1678 "SourceSettings.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5179 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5179 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5179 "glib-2.0.vapi"
			break;
#line 1688 "SourceSettings.c"
		}
#line 5180 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5180 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5180 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 1696 "SourceSettings.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5181 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5181 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5181 "glib-2.0.vapi"
			l = _tmp4_;
#line 1705 "SourceSettings.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5183 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5183 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5183 "glib-2.0.vapi"
			func (_tmp6_);
#line 5184 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5184 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5185 "glib-2.0.vapi"
			break;
#line 1722 "SourceSettings.c"
		}
	}
#line 5188 "glib-2.0.vapi"
	result = self;
#line 5188 "glib-2.0.vapi"
	return result;
#line 1729 "SourceSettings.c"
}

void
keyboard_source_settings_remove_active_layout (KeyboardSourceSettings* self)
{
	KeyboardInputSource* _tmp0_;
	KeyboardInputSource* _tmp1_;
	guint _tmp2_;
#line 264 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_source_settings_get_active_input_source (self);
#line 265 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = _tmp0_;
#line 265 "../src/InputSources/SourceSettings.vala"
	self->priv->input_sources = vala_g_list_remove_full (self->priv->input_sources, _tmp1_, _g_object_unref0_);
#line 267 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = self->priv->_active_index;
#line 267 "../src/InputSources/SourceSettings.vala"
	if (_tmp2_ >= ((guint) 1)) {
#line 1750 "SourceSettings.c"
		GList* _tmp3_;
#line 268 "../src/InputSources/SourceSettings.vala"
		_tmp3_ = self->priv->input_sources;
#line 268 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_set_active_index (self, g_list_length (_tmp3_) - 1);
#line 1756 "SourceSettings.c"
	}
#line 271 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_add_default_keyboard_if_required (self);
#line 273 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_write_to_gsettings (self);
#line 1762 "SourceSettings.c"
}

static KeyboardLayoutType*
_keyboard_layout_type_dup (KeyboardLayoutType* self)
{
	KeyboardLayoutType* dup;
#line 276 "../src/InputSources/SourceSettings.vala"
	dup = g_new0 (KeyboardLayoutType, 1);
#line 276 "../src/InputSources/SourceSettings.vala"
	memcpy (dup, self, sizeof (KeyboardLayoutType));
#line 276 "../src/InputSources/SourceSettings.vala"
	return dup;
#line 1775 "SourceSettings.c"
}

static gpointer
__keyboard_layout_type_dup0 (gpointer self)
{
#line 276 "../src/InputSources/SourceSettings.vala"
	return self ? _keyboard_layout_type_dup (self) : NULL;
#line 1783 "SourceSettings.c"
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 276 "../src/InputSources/SourceSettings.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 276 "../src/InputSources/SourceSettings.vala"
	return _data17_;
#line 1793 "SourceSettings.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 276 "../src/InputSources/SourceSettings.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 1803 "SourceSettings.c"
		KeyboardSourceSettings* self;
#line 276 "../src/InputSources/SourceSettings.vala"
		self = _data17_->self;
#line 276 "../src/InputSources/SourceSettings.vala"
		(_data17_->remove_layouts == NULL) ? NULL : (_data17_->remove_layouts = (_g_list_free__g_object_unref0_ (_data17_->remove_layouts), NULL));
#line 276 "../src/InputSources/SourceSettings.vala"
		_g_free0 (_data17_->layout_type);
#line 276 "../src/InputSources/SourceSettings.vala"
		_g_object_unref0 (self);
#line 276 "../src/InputSources/SourceSettings.vala"
		g_slice_free (Block17Data, _data17_);
#line 1815 "SourceSettings.c"
	}
}

static gboolean
_keyboard_layout_type_equal (const KeyboardLayoutType * s1,
                             const KeyboardLayoutType * s2)
{
#line 279 "../src/InputSources/SourceSettings.vala"
	if (s1 == s2) {
#line 279 "../src/InputSources/SourceSettings.vala"
		return TRUE;
#line 1827 "SourceSettings.c"
	}
#line 279 "../src/InputSources/SourceSettings.vala"
	if (s1 == NULL) {
#line 279 "../src/InputSources/SourceSettings.vala"
		return FALSE;
#line 1833 "SourceSettings.c"
	}
#line 279 "../src/InputSources/SourceSettings.vala"
	if (s2 == NULL) {
#line 279 "../src/InputSources/SourceSettings.vala"
		return FALSE;
#line 1839 "SourceSettings.c"
	}
#line 279 "../src/InputSources/SourceSettings.vala"
	return (*s1) == (*s2);
#line 1843 "SourceSettings.c"
}

static void
__lambda5_ (Block17Data* _data17_,
            KeyboardInputSource* source)
{
	KeyboardSourceSettings* self;
	gboolean _tmp0_ = FALSE;
#line 278 "../src/InputSources/SourceSettings.vala"
	self = _data17_->self;
#line 278 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (source != NULL);
#line 279 "../src/InputSources/SourceSettings.vala"
	if (_data17_->layout_type == NULL) {
#line 279 "../src/InputSources/SourceSettings.vala"
		_tmp0_ = TRUE;
#line 1860 "SourceSettings.c"
	} else {
		KeyboardLayoutType _tmp1_;
		KeyboardLayoutType _tmp2_;
#line 279 "../src/InputSources/SourceSettings.vala"
		_tmp1_ = keyboard_input_source_get_layout_type (source);
#line 279 "../src/InputSources/SourceSettings.vala"
		_tmp2_ = _tmp1_;
#line 279 "../src/InputSources/SourceSettings.vala"
		_tmp0_ = _keyboard_layout_type_equal (_data17_->layout_type, &_tmp2_) == TRUE;
#line 1870 "SourceSettings.c"
	}
#line 279 "../src/InputSources/SourceSettings.vala"
	if (_tmp0_) {
#line 1874 "SourceSettings.c"
		KeyboardInputSource* _tmp3_;
#line 280 "../src/InputSources/SourceSettings.vala"
		_tmp3_ = _g_object_ref0 (source);
#line 280 "../src/InputSources/SourceSettings.vala"
		_data17_->remove_layouts = g_list_append (_data17_->remove_layouts, _tmp3_);
#line 1880 "SourceSettings.c"
	}
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
#line 278 "../src/InputSources/SourceSettings.vala"
	__lambda5_ (self, (KeyboardInputSource*) data);
#line 1890 "SourceSettings.c"
}

static void
__lambda6_ (KeyboardSourceSettings* self,
            KeyboardInputSource* layout)
{
#line 284 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (layout != NULL);
#line 285 "../src/InputSources/SourceSettings.vala"
	self->priv->input_sources = vala_g_list_remove_full (self->priv->input_sources, layout, _g_object_unref0_);
#line 1901 "SourceSettings.c"
}

static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
#line 284 "../src/InputSources/SourceSettings.vala"
	__lambda6_ ((KeyboardSourceSettings*) self, (KeyboardInputSource*) data);
#line 1910 "SourceSettings.c"
}

void
keyboard_source_settings_reset (KeyboardSourceSettings* self,
                                KeyboardLayoutType* layout_type,
                                gboolean signal_changed)
{
	Block17Data* _data17_;
	KeyboardLayoutType* _tmp0_;
	GList* _tmp1_;
#line 276 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/InputSources/SourceSettings.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 276 "../src/InputSources/SourceSettings.vala"
	_data17_->_ref_count_ = 1;
#line 276 "../src/InputSources/SourceSettings.vala"
	_data17_->self = g_object_ref (self);
#line 276 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = __keyboard_layout_type_dup0 (layout_type);
#line 276 "../src/InputSources/SourceSettings.vala"
	_g_free0 (_data17_->layout_type);
#line 276 "../src/InputSources/SourceSettings.vala"
	_data17_->layout_type = _tmp0_;
#line 277 "../src/InputSources/SourceSettings.vala"
	_data17_->remove_layouts = NULL;
#line 278 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = self->priv->input_sources;
#line 278 "../src/InputSources/SourceSettings.vala"
	g_list_foreach (_tmp1_, ___lambda5__gfunc, _data17_);
#line 284 "../src/InputSources/SourceSettings.vala"
	g_list_foreach (_data17_->remove_layouts, ___lambda6__gfunc, self);
#line 276 "../src/InputSources/SourceSettings.vala"
	block17_data_unref (_data17_);
#line 276 "../src/InputSources/SourceSettings.vala"
	_data17_ = NULL;
#line 1947 "SourceSettings.c"
}

static void
keyboard_source_settings_update_input_sources_ibus (KeyboardSourceSettings* self)
{
	KeyboardLayoutType _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 289 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = KEYBOARD_LAYOUT_TYPE_IBUS;
#line 290 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_reset (self, &_tmp0_, FALSE);
#line 291 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = keyboard_source_settings_get_active_engines (self, &_tmp2_);
#line 291 "../src/InputSources/SourceSettings.vala"
	_tmp1__length1 = _tmp2_;
#line 291 "../src/InputSources/SourceSettings.vala"
	_tmp3_ = _tmp1_;
#line 291 "../src/InputSources/SourceSettings.vala"
	_tmp3__length1 = _tmp1__length1;
#line 1973 "SourceSettings.c"
	{
		gchar** engine_name_collection = NULL;
		gint engine_name_collection_length1 = 0;
		gint _engine_name_collection_size_ = 0;
		gint engine_name_it = 0;
#line 291 "../src/InputSources/SourceSettings.vala"
		engine_name_collection = _tmp3_;
#line 291 "../src/InputSources/SourceSettings.vala"
		engine_name_collection_length1 = _tmp3__length1;
#line 291 "../src/InputSources/SourceSettings.vala"
		for (engine_name_it = 0; engine_name_it < engine_name_collection_length1; engine_name_it = engine_name_it + 1) {
#line 1985 "SourceSettings.c"
			gchar* _tmp4_;
			gchar* engine_name = NULL;
#line 291 "../src/InputSources/SourceSettings.vala"
			_tmp4_ = g_strdup (engine_name_collection[engine_name_it]);
#line 291 "../src/InputSources/SourceSettings.vala"
			engine_name = _tmp4_;
#line 1992 "SourceSettings.c"
			{
				const gchar* _tmp5_;
				KeyboardInputSource* _tmp6_;
				KeyboardInputSource* _tmp7_;
#line 292 "../src/InputSources/SourceSettings.vala"
				_tmp5_ = engine_name;
#line 292 "../src/InputSources/SourceSettings.vala"
				_tmp6_ = keyboard_input_source_new_ibus (_tmp5_);
#line 292 "../src/InputSources/SourceSettings.vala"
				_tmp7_ = _tmp6_;
#line 292 "../src/InputSources/SourceSettings.vala"
				keyboard_source_settings_add_layout (self, _tmp7_);
#line 292 "../src/InputSources/SourceSettings.vala"
				_g_object_unref0 (_tmp7_);
#line 291 "../src/InputSources/SourceSettings.vala"
				_g_free0 (engine_name);
#line 2009 "SourceSettings.c"
			}
		}
	}
#line 295 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_write_to_gsettings (self);
#line 2015 "SourceSettings.c"
}

static gchar**
_vala_array_dup11 (gchar** self,
                   gssize length)
{
#line 306 "../src/InputSources/SourceSettings.vala"
	if (length >= 0) {
#line 2024 "SourceSettings.c"
		gchar** result;
		gssize i;
#line 306 "../src/InputSources/SourceSettings.vala"
		result = g_new0 (gchar*, length + 1);
#line 306 "../src/InputSources/SourceSettings.vala"
		for (i = 0; i < length; i++) {
#line 2031 "SourceSettings.c"
			gchar* _tmp0_;
#line 306 "../src/InputSources/SourceSettings.vala"
			_tmp0_ = g_strdup (self[i]);
#line 306 "../src/InputSources/SourceSettings.vala"
			result[i] = _tmp0_;
#line 2037 "SourceSettings.c"
		}
#line 306 "../src/InputSources/SourceSettings.vala"
		return result;
#line 2041 "SourceSettings.c"
	}
#line 306 "../src/InputSources/SourceSettings.vala"
	return NULL;
#line 2045 "SourceSettings.c"
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 307 "../src/InputSources/SourceSettings.vala"
	if ((*length) == (*size)) {
#line 307 "../src/InputSources/SourceSettings.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 307 "../src/InputSources/SourceSettings.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2060 "SourceSettings.c"
	}
#line 307 "../src/InputSources/SourceSettings.vala"
	(*array)[(*length)++] = value;
#line 307 "../src/InputSources/SourceSettings.vala"
	(*array)[*length] = NULL;
#line 2066 "SourceSettings.c"
}

gboolean
keyboard_source_settings_add_active_engine (KeyboardSourceSettings* self,
                                            const gchar* engine_name)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** new_engine_list = NULL;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint _tmp6_ = 0;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gint new_engine_list_length1;
	gint _new_engine_list_size_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gboolean result;
#line 298 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 298 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (engine_name != NULL, FALSE);
#line 299 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_source_settings_get_active_engines (self, &_tmp1_);
#line 299 "../src/InputSources/SourceSettings.vala"
	_tmp0__length1 = _tmp1_;
#line 299 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = _tmp0_;
#line 299 "../src/InputSources/SourceSettings.vala"
	_tmp2__length1 = _tmp0__length1;
#line 2104 "SourceSettings.c"
	{
		gchar** active_engine_collection = NULL;
		gint active_engine_collection_length1 = 0;
		gint _active_engine_collection_size_ = 0;
		gint active_engine_it = 0;
#line 299 "../src/InputSources/SourceSettings.vala"
		active_engine_collection = _tmp2_;
#line 299 "../src/InputSources/SourceSettings.vala"
		active_engine_collection_length1 = _tmp2__length1;
#line 299 "../src/InputSources/SourceSettings.vala"
		for (active_engine_it = 0; active_engine_it < active_engine_collection_length1; active_engine_it = active_engine_it + 1) {
#line 2116 "SourceSettings.c"
			gchar* _tmp3_;
			gchar* active_engine = NULL;
#line 299 "../src/InputSources/SourceSettings.vala"
			_tmp3_ = g_strdup (active_engine_collection[active_engine_it]);
#line 299 "../src/InputSources/SourceSettings.vala"
			active_engine = _tmp3_;
#line 2123 "SourceSettings.c"
			{
				const gchar* _tmp4_;
#line 300 "../src/InputSources/SourceSettings.vala"
				_tmp4_ = active_engine;
#line 300 "../src/InputSources/SourceSettings.vala"
				if (g_strcmp0 (engine_name, _tmp4_) == 0) {
#line 301 "../src/InputSources/SourceSettings.vala"
					result = FALSE;
#line 301 "../src/InputSources/SourceSettings.vala"
					_g_free0 (active_engine);
#line 301 "../src/InputSources/SourceSettings.vala"
					return result;
#line 2136 "SourceSettings.c"
				}
#line 299 "../src/InputSources/SourceSettings.vala"
				_g_free0 (active_engine);
#line 2140 "SourceSettings.c"
			}
		}
	}
#line 306 "../src/InputSources/SourceSettings.vala"
	_tmp5_ = keyboard_source_settings_get_active_engines (self, &_tmp6_);
#line 306 "../src/InputSources/SourceSettings.vala"
	_tmp5__length1 = _tmp6_;
#line 306 "../src/InputSources/SourceSettings.vala"
	_tmp7_ = _tmp5_;
#line 306 "../src/InputSources/SourceSettings.vala"
	_tmp7__length1 = _tmp5__length1;
#line 306 "../src/InputSources/SourceSettings.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup11 (_tmp7_, _tmp7__length1) : _tmp7_;
#line 306 "../src/InputSources/SourceSettings.vala"
	_tmp8__length1 = _tmp7__length1;
#line 306 "../src/InputSources/SourceSettings.vala"
	new_engine_list = _tmp8_;
#line 306 "../src/InputSources/SourceSettings.vala"
	new_engine_list_length1 = _tmp8__length1;
#line 306 "../src/InputSources/SourceSettings.vala"
	_new_engine_list_size_ = new_engine_list_length1;
#line 307 "../src/InputSources/SourceSettings.vala"
	_tmp9_ = g_strdup (engine_name);
#line 307 "../src/InputSources/SourceSettings.vala"
	_vala_array_add19 (&new_engine_list, &new_engine_list_length1, &_new_engine_list_size_, _tmp9_);
#line 308 "../src/InputSources/SourceSettings.vala"
	_tmp10_ = new_engine_list;
#line 308 "../src/InputSources/SourceSettings.vala"
	_tmp10__length1 = new_engine_list_length1;
#line 308 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_set_active_engines (self, _tmp10_, _tmp10__length1);
#line 310 "../src/InputSources/SourceSettings.vala"
	result = TRUE;
#line 310 "../src/InputSources/SourceSettings.vala"
	new_engine_list = (_vala_array_free (new_engine_list, new_engine_list_length1, (GDestroyNotify) g_free), NULL);
#line 310 "../src/InputSources/SourceSettings.vala"
	return result;
#line 2178 "SourceSettings.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 313 "../src/InputSources/SourceSettings.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 313 "../src/InputSources/SourceSettings.vala"
	return _data18_;
#line 2188 "SourceSettings.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 313 "../src/InputSources/SourceSettings.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 2198 "SourceSettings.c"
		KeyboardSourceSettings* self;
#line 313 "../src/InputSources/SourceSettings.vala"
		self = _data18_->self;
#line 313 "../src/InputSources/SourceSettings.vala"
		_g_free0 (_data18_->engine_name);
#line 313 "../src/InputSources/SourceSettings.vala"
		_g_object_unref0 (self);
#line 313 "../src/InputSources/SourceSettings.vala"
		g_slice_free (Block18Data, _data18_);
#line 2208 "SourceSettings.c"
	}
}

static void
__lambda11_ (Block18Data* _data18_,
             KeyboardInputSource* input_source)
{
	KeyboardSourceSettings* self;
	gboolean _tmp0_ = FALSE;
	KeyboardLayoutType _tmp1_;
	KeyboardLayoutType _tmp2_;
	guint _tmp5_;
#line 316 "../src/InputSources/SourceSettings.vala"
	self = _data18_->self;
#line 316 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (input_source != NULL);
#line 317 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = keyboard_input_source_get_layout_type (input_source);
#line 317 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = _tmp1_;
#line 317 "../src/InputSources/SourceSettings.vala"
	if (_tmp2_ == KEYBOARD_LAYOUT_TYPE_IBUS) {
#line 2231 "SourceSettings.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 317 "../src/InputSources/SourceSettings.vala"
		_tmp3_ = keyboard_input_source_get_name (input_source);
#line 317 "../src/InputSources/SourceSettings.vala"
		_tmp4_ = _tmp3_;
#line 317 "../src/InputSources/SourceSettings.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, _data18_->engine_name) == 0;
#line 2240 "SourceSettings.c"
	} else {
#line 317 "../src/InputSources/SourceSettings.vala"
		_tmp0_ = FALSE;
#line 2244 "SourceSettings.c"
	}
#line 317 "../src/InputSources/SourceSettings.vala"
	if (_tmp0_) {
#line 318 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_set_active_index (self, _data18_->index);
#line 319 "../src/InputSources/SourceSettings.vala"
		return;
#line 2252 "SourceSettings.c"
	}
#line 322 "../src/InputSources/SourceSettings.vala"
	_tmp5_ = _data18_->index;
#line 322 "../src/InputSources/SourceSettings.vala"
	_data18_->index = _tmp5_ + 1;
#line 2258 "SourceSettings.c"
}

static void
___lambda11__gfunc (gconstpointer data,
                    gpointer self)
{
#line 316 "../src/InputSources/SourceSettings.vala"
	__lambda11_ (self, (KeyboardInputSource*) data);
#line 2267 "SourceSettings.c"
}

void
keyboard_source_settings_set_active_engine_name (KeyboardSourceSettings* self,
                                                 const gchar* engine_name)
{
	Block18Data* _data18_;
	gchar* _tmp0_;
#line 313 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (engine_name != NULL);
#line 313 "../src/InputSources/SourceSettings.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 313 "../src/InputSources/SourceSettings.vala"
	_data18_->_ref_count_ = 1;
#line 313 "../src/InputSources/SourceSettings.vala"
	_data18_->self = g_object_ref (self);
#line 313 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = g_strdup (engine_name);
#line 313 "../src/InputSources/SourceSettings.vala"
	_g_free0 (_data18_->engine_name);
#line 313 "../src/InputSources/SourceSettings.vala"
	_data18_->engine_name = _tmp0_;
#line 314 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_update_input_sources_ibus (self);
#line 315 "../src/InputSources/SourceSettings.vala"
	_data18_->index = (guint) 0;
#line 316 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_foreach_layout (self, ___lambda11__gfunc, _data18_);
#line 313 "../src/InputSources/SourceSettings.vala"
	block18_data_unref (_data18_);
#line 313 "../src/InputSources/SourceSettings.vala"
	_data18_ = NULL;
#line 2302 "SourceSettings.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 328 "../src/InputSources/SourceSettings.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 328 "../src/InputSources/SourceSettings.vala"
	return _data19_;
#line 2312 "SourceSettings.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 328 "../src/InputSources/SourceSettings.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 2322 "SourceSettings.c"
		KeyboardSourceSettings* self;
#line 328 "../src/InputSources/SourceSettings.vala"
		self = _data19_->self;
#line 328 "../src/InputSources/SourceSettings.vala"
		(_data19_->ibus_sources == NULL) ? NULL : (_data19_->ibus_sources = (_g_list_free__g_object_unref0_ (_data19_->ibus_sources), NULL));
#line 328 "../src/InputSources/SourceSettings.vala"
		(_data19_->xkb_sources == NULL) ? NULL : (_data19_->xkb_sources = (_g_list_free__g_object_unref0_ (_data19_->xkb_sources), NULL));
#line 328 "../src/InputSources/SourceSettings.vala"
		_data19_->elements = (_vala_array_free (_data19_->elements, _data19_->elements_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 328 "../src/InputSources/SourceSettings.vala"
		_g_object_unref0 (self);
#line 328 "../src/InputSources/SourceSettings.vala"
		g_slice_free (Block19Data, _data19_);
#line 2336 "SourceSettings.c"
	}
}

static void
___lambda8_ (Block19Data* _data19_,
             KeyboardInputSource* input_source)
{
	KeyboardSourceSettings* self;
	KeyboardLayoutType _tmp0_;
	KeyboardLayoutType _tmp1_;
#line 332 "../src/InputSources/SourceSettings.vala"
	self = _data19_->self;
#line 332 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (input_source != NULL);
#line 333 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_input_source_get_layout_type (input_source);
#line 333 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = _tmp0_;
#line 333 "../src/InputSources/SourceSettings.vala"
	if (_tmp1_ == KEYBOARD_LAYOUT_TYPE_XKB) {
#line 2357 "SourceSettings.c"
		KeyboardInputSource* _tmp2_;
#line 334 "../src/InputSources/SourceSettings.vala"
		_tmp2_ = _g_object_ref0 (input_source);
#line 334 "../src/InputSources/SourceSettings.vala"
		_data19_->xkb_sources = g_list_append (_data19_->xkb_sources, _tmp2_);
#line 2363 "SourceSettings.c"
	} else {
		KeyboardInputSource* _tmp3_;
#line 336 "../src/InputSources/SourceSettings.vala"
		_tmp3_ = _g_object_ref0 (input_source);
#line 336 "../src/InputSources/SourceSettings.vala"
		_data19_->ibus_sources = g_list_append (_data19_->ibus_sources, _tmp3_);
#line 2370 "SourceSettings.c"
	}
}

static void
____lambda8__gfunc (gconstpointer data,
                    gpointer self)
{
#line 332 "../src/InputSources/SourceSettings.vala"
	___lambda8_ (self, (KeyboardInputSource*) data);
#line 2380 "SourceSettings.c"
}

static void
_vala_array_add20 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 343 "../src/InputSources/SourceSettings.vala"
	if ((*length) == (*size)) {
#line 343 "../src/InputSources/SourceSettings.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 343 "../src/InputSources/SourceSettings.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 2395 "SourceSettings.c"
	}
#line 343 "../src/InputSources/SourceSettings.vala"
	(*array)[(*length)++] = value;
#line 343 "../src/InputSources/SourceSettings.vala"
	(*array)[*length] = NULL;
#line 2401 "SourceSettings.c"
}

static void
___lambda9_ (Block19Data* _data19_,
             KeyboardInputSource* input_source)
{
	KeyboardSourceSettings* self;
	GVariant* _tmp0_;
#line 343 "../src/InputSources/SourceSettings.vala"
	self = _data19_->self;
#line 343 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (input_source != NULL);
#line 343 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_input_source_to_variant (input_source);
#line 343 "../src/InputSources/SourceSettings.vala"
	_vala_array_add20 (&_data19_->elements, &_data19_->elements_length1, &_data19_->_elements_size_, _tmp0_);
#line 2418 "SourceSettings.c"
}

static void
____lambda9__gfunc (gconstpointer data,
                    gpointer self)
{
#line 343 "../src/InputSources/SourceSettings.vala"
	___lambda9_ (self, (KeyboardInputSource*) data);
#line 2427 "SourceSettings.c"
}

static void
_vala_array_add21 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 344 "../src/InputSources/SourceSettings.vala"
	if ((*length) == (*size)) {
#line 344 "../src/InputSources/SourceSettings.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 344 "../src/InputSources/SourceSettings.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 2442 "SourceSettings.c"
	}
#line 344 "../src/InputSources/SourceSettings.vala"
	(*array)[(*length)++] = value;
#line 344 "../src/InputSources/SourceSettings.vala"
	(*array)[*length] = NULL;
#line 2448 "SourceSettings.c"
}

static void
___lambda10_ (Block19Data* _data19_,
              KeyboardInputSource* input_source)
{
	KeyboardSourceSettings* self;
	GVariant* _tmp0_;
#line 344 "../src/InputSources/SourceSettings.vala"
	self = _data19_->self;
#line 344 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (input_source != NULL);
#line 344 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_input_source_to_variant (input_source);
#line 344 "../src/InputSources/SourceSettings.vala"
	_vala_array_add21 (&_data19_->elements, &_data19_->elements_length1, &_data19_->_elements_size_, _tmp0_);
#line 2465 "SourceSettings.c"
}

static void
____lambda10__gfunc (gconstpointer data,
                     gpointer self)
{
#line 344 "../src/InputSources/SourceSettings.vala"
	___lambda10_ (self, (KeyboardInputSource*) data);
#line 2474 "SourceSettings.c"
}

static void
keyboard_source_settings_write_to_gsettings (KeyboardSourceSettings* self)
{
	GError* _inner_error0_ = NULL;
#line 326 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/InputSources/SourceSettings.vala"
	self->priv->currently_writing = TRUE;
#line 2485 "SourceSettings.c"
	{
		Block19Data* _data19_;
		GVariant** _tmp0_;
		GList* _tmp1_;
		GVariant* list = NULL;
		GVariantType* _tmp2_;
		GVariantType* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GSettings* _tmp6_;
#line 328 "../src/InputSources/SourceSettings.vala"
		_data19_ = g_slice_new0 (Block19Data);
#line 328 "../src/InputSources/SourceSettings.vala"
		_data19_->_ref_count_ = 1;
#line 328 "../src/InputSources/SourceSettings.vala"
		_data19_->self = g_object_ref (self);
#line 329 "../src/InputSources/SourceSettings.vala"
		_tmp0_ = g_new0 (GVariant*, 0 + 1);
#line 329 "../src/InputSources/SourceSettings.vala"
		_data19_->elements = _tmp0_;
#line 329 "../src/InputSources/SourceSettings.vala"
		_data19_->elements_length1 = 0;
#line 329 "../src/InputSources/SourceSettings.vala"
		_data19_->_elements_size_ = _data19_->elements_length1;
#line 330 "../src/InputSources/SourceSettings.vala"
		_data19_->xkb_sources = NULL;
#line 331 "../src/InputSources/SourceSettings.vala"
		_data19_->ibus_sources = NULL;
#line 332 "../src/InputSources/SourceSettings.vala"
		_tmp1_ = self->priv->input_sources;
#line 332 "../src/InputSources/SourceSettings.vala"
		g_list_foreach (_tmp1_, ____lambda8__gfunc, _data19_);
#line 343 "../src/InputSources/SourceSettings.vala"
		g_list_foreach (_data19_->xkb_sources, ____lambda9__gfunc, _data19_);
#line 344 "../src/InputSources/SourceSettings.vala"
		g_list_foreach (_data19_->ibus_sources, ____lambda10__gfunc, _data19_);
#line 346 "../src/InputSources/SourceSettings.vala"
		_tmp2_ = g_variant_type_new ("(ss)");
#line 346 "../src/InputSources/SourceSettings.vala"
		_tmp3_ = _tmp2_;
#line 346 "../src/InputSources/SourceSettings.vala"
		_tmp4_ = g_variant_new_array (_tmp3_, _data19_->elements, _data19_->elements_length1);
#line 346 "../src/InputSources/SourceSettings.vala"
		g_variant_ref_sink (_tmp4_);
#line 346 "../src/InputSources/SourceSettings.vala"
		_tmp5_ = _tmp4_;
#line 346 "../src/InputSources/SourceSettings.vala"
		_g_variant_type_free0 (_tmp3_);
#line 346 "../src/InputSources/SourceSettings.vala"
		list = _tmp5_;
#line 347 "../src/InputSources/SourceSettings.vala"
		_tmp6_ = self->priv->settings;
#line 347 "../src/InputSources/SourceSettings.vala"
		g_settings_set_value (_tmp6_, "sources", list);
#line 328 "../src/InputSources/SourceSettings.vala"
		_g_variant_unref0 (list);
#line 328 "../src/InputSources/SourceSettings.vala"
		block19_data_unref (_data19_);
#line 328 "../src/InputSources/SourceSettings.vala"
		_data19_ = NULL;
#line 2546 "SourceSettings.c"
	}
	__finally0:
	{
#line 349 "../src/InputSources/SourceSettings.vala"
		self->priv->currently_writing = FALSE;
#line 2552 "SourceSettings.c"
	}
#line 328 "../src/InputSources/SourceSettings.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 328 "../src/InputSources/SourceSettings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 328 "../src/InputSources/SourceSettings.vala"
		g_clear_error (&_inner_error0_);
#line 328 "../src/InputSources/SourceSettings.vala"
		return;
#line 2562 "SourceSettings.c"
	}
}

guint
keyboard_source_settings_get_active_index (KeyboardSourceSettings* self)
{
	guint result;
#line 23 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 23 "../src/InputSources/SourceSettings.vala"
	result = self->priv->_active_index;
#line 23 "../src/InputSources/SourceSettings.vala"
	return result;
#line 2576 "SourceSettings.c"
}

void
keyboard_source_settings_set_active_index (KeyboardSourceSettings* self,
                                           guint value)
{
	guint old_value;
#line 23 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/InputSources/SourceSettings.vala"
	old_value = keyboard_source_settings_get_active_index (self);
#line 23 "../src/InputSources/SourceSettings.vala"
	if (old_value != value) {
#line 23 "../src/InputSources/SourceSettings.vala"
		self->priv->_active_index = value;
#line 23 "../src/InputSources/SourceSettings.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_source_settings_properties[KEYBOARD_SOURCE_SETTINGS_ACTIVE_INDEX_PROPERTY]);
#line 2594 "SourceSettings.c"
	}
}

KeyboardInputSource*
keyboard_source_settings_get_active_input_source (KeyboardSourceSettings* self)
{
	KeyboardInputSource* result;
	guint _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	guint _tmp3_;
	gconstpointer _tmp4_;
#line 26 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = self->priv->_active_index;
#line 27 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = self->priv->input_sources;
#line 27 "../src/InputSources/SourceSettings.vala"
	if (_tmp0_ >= g_list_length (_tmp1_)) {
#line 28 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_set_active_index (self, (guint) 0);
#line 2617 "SourceSettings.c"
	}
#line 31 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = self->priv->input_sources;
#line 31 "../src/InputSources/SourceSettings.vala"
	_tmp3_ = self->priv->_active_index;
#line 31 "../src/InputSources/SourceSettings.vala"
	_tmp4_ = g_list_nth_data (_tmp2_, _tmp3_);
#line 31 "../src/InputSources/SourceSettings.vala"
	result = (KeyboardInputSource*) _tmp4_;
#line 31 "../src/InputSources/SourceSettings.vala"
	return result;
#line 2629 "SourceSettings.c"
}

gchar**
keyboard_source_settings_get_active_engines (KeyboardSourceSettings* self,
                                             gint* result_length1)
{
	gchar** result;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 39 "../src/InputSources/SourceSettings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_plug_ibus_general_settings;
#line 40 "../src/InputSources/SourceSettings.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "preload-engines");
#line 40 "../src/InputSources/SourceSettings.vala"
	self->priv->_active_engines = (_vala_array_free (self->priv->_active_engines, self->priv->_active_engines_length1, (GDestroyNotify) g_free), NULL);
#line 40 "../src/InputSources/SourceSettings.vala"
	self->priv->_active_engines = _tmp2_;
#line 40 "../src/InputSources/SourceSettings.vala"
	self->priv->_active_engines_length1 = _vala_array_length (_tmp1_);
#line 40 "../src/InputSources/SourceSettings.vala"
	self->priv->__active_engines_size_ = self->priv->_active_engines_length1;
#line 41 "../src/InputSources/SourceSettings.vala"
	_tmp3_ = self->priv->_active_engines;
#line 41 "../src/InputSources/SourceSettings.vala"
	_tmp3__length1 = self->priv->_active_engines_length1;
#line 41 "../src/InputSources/SourceSettings.vala"
	_tmp4_ = _tmp3_;
#line 41 "../src/InputSources/SourceSettings.vala"
	_tmp4__length1 = _tmp3__length1;
#line 41 "../src/InputSources/SourceSettings.vala"
	if (result_length1) {
#line 41 "../src/InputSources/SourceSettings.vala"
		*result_length1 = _tmp4__length1;
#line 2670 "SourceSettings.c"
	}
#line 41 "../src/InputSources/SourceSettings.vala"
	result = _tmp4_;
#line 41 "../src/InputSources/SourceSettings.vala"
	return result;
#line 2676 "SourceSettings.c"
}

void
keyboard_source_settings_set_active_engines (KeyboardSourceSettings* self,
                                             gchar** value,
                                             gint value_length1)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 44 "../src/InputSources/SourceSettings.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/InputSources/SourceSettings.vala"
	_tmp0_ = keyboard_plug_ibus_general_settings;
#line 45 "../src/InputSources/SourceSettings.vala"
	g_settings_set_strv (_tmp0_, "preload-engines", value);
#line 46 "../src/InputSources/SourceSettings.vala"
	_tmp1_ = keyboard_plug_ibus_general_settings;
#line 46 "../src/InputSources/SourceSettings.vala"
	g_settings_set_strv (_tmp1_, "engines-order", value);
#line 47 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_update_input_sources_ibus (self);
#line 44 "../src/InputSources/SourceSettings.vala"
	g_object_notify_by_pspec ((GObject *) self, keyboard_source_settings_properties[KEYBOARD_SOURCE_SETTINGS_ACTIVE_ENGINES_PROPERTY]);
#line 2700 "SourceSettings.c"
}

static GObject *
keyboard_source_settings_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KeyboardSourceSettings * self;
#line 70 "../src/InputSources/SourceSettings.vala"
	parent_class = G_OBJECT_CLASS (keyboard_source_settings_parent_class);
#line 70 "../src/InputSources/SourceSettings.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 70 "../src/InputSources/SourceSettings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings);
#line 71 "../src/InputSources/SourceSettings.vala"
	(self->priv->input_sources == NULL) ? NULL : (self->priv->input_sources = (_g_list_free__g_object_unref0_ (self->priv->input_sources), NULL));
#line 71 "../src/InputSources/SourceSettings.vala"
	self->priv->input_sources = NULL;
#line 70 "../src/InputSources/SourceSettings.vala"
	return obj;
#line 2723 "SourceSettings.c"
}

static void
keyboard_source_settings_class_init (KeyboardSourceSettingsClass * klass,
                                     gpointer klass_data)
{
#line 20 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/InputSources/SourceSettings.vala"
	g_type_class_adjust_private_offset (klass, &KeyboardSourceSettings_private_offset);
#line 20 "../src/InputSources/SourceSettings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_keyboard_source_settings_get_property;
#line 20 "../src/InputSources/SourceSettings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_keyboard_source_settings_set_property;
#line 20 "../src/InputSources/SourceSettings.vala"
	G_OBJECT_CLASS (klass)->constructor = keyboard_source_settings_constructor;
#line 20 "../src/InputSources/SourceSettings.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_source_settings_finalize;
#line 20 "../src/InputSources/SourceSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_SOURCE_SETTINGS_ACTIVE_INDEX_PROPERTY, keyboard_source_settings_properties[KEYBOARD_SOURCE_SETTINGS_ACTIVE_INDEX_PROPERTY] = g_param_spec_uint ("active-index", "active-index", "active-index", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/InputSources/SourceSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_SOURCE_SETTINGS_ACTIVE_INPUT_SOURCE_PROPERTY, keyboard_source_settings_properties[KEYBOARD_SOURCE_SETTINGS_ACTIVE_INPUT_SOURCE_PROPERTY] = g_param_spec_object ("active-input-source", "active-input-source", "active-input-source", KEYBOARD_TYPE_INPUT_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/InputSources/SourceSettings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_SOURCE_SETTINGS_ACTIVE_ENGINES_PROPERTY, keyboard_source_settings_properties[KEYBOARD_SOURCE_SETTINGS_ACTIVE_ENGINES_PROPERTY] = g_param_spec_boxed ("active-engines", "active-engines", "active-engines", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/InputSources/SourceSettings.vala"
	keyboard_source_settings_signals[KEYBOARD_SOURCE_SETTINGS_EXTERNAL_LAYOUT_CHANGE_SIGNAL] = g_signal_new ("external-layout-change", KEYBOARD_TYPE_SOURCE_SETTINGS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2750 "SourceSettings.c"
}

static void
keyboard_source_settings_instance_init (KeyboardSourceSettings * self,
                                        gpointer klass)
{
#line 20 "../src/InputSources/SourceSettings.vala"
	self->priv = keyboard_source_settings_get_instance_private (self);
#line 2759 "SourceSettings.c"
}

static void
keyboard_source_settings_finalize (GObject * obj)
{
	KeyboardSourceSettings * self;
#line 20 "../src/InputSources/SourceSettings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings);
#line 37 "../src/InputSources/SourceSettings.vala"
	self->priv->_active_engines = (_vala_array_free (self->priv->_active_engines, self->priv->_active_engines_length1, (GDestroyNotify) g_free), NULL);
#line 51 "../src/InputSources/SourceSettings.vala"
	(self->priv->input_sources == NULL) ? NULL : (self->priv->input_sources = (_g_list_free__g_object_unref0_ (self->priv->input_sources), NULL));
#line 53 "../src/InputSources/SourceSettings.vala"
	self->priv->xkb_options_modifiers = (_vala_array_free (self->priv->xkb_options_modifiers, self->priv->xkb_options_modifiers_length1, (GDestroyNotify) g_object_unref), NULL);
#line 54 "../src/InputSources/SourceSettings.vala"
	_g_object_unref0 (self->priv->settings);
#line 20 "../src/InputSources/SourceSettings.vala"
	G_OBJECT_CLASS (keyboard_source_settings_parent_class)->finalize (obj);
#line 2778 "SourceSettings.c"
}

static GType
keyboard_source_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardSourceSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_source_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardSourceSettings), 0, (GInstanceInitFunc) keyboard_source_settings_instance_init, NULL };
	GType keyboard_source_settings_type_id;
	keyboard_source_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "KeyboardSourceSettings", &g_define_type_info, 0);
	KeyboardSourceSettings_private_offset = g_type_add_instance_private (keyboard_source_settings_type_id, sizeof (KeyboardSourceSettingsPrivate));
	return keyboard_source_settings_type_id;
}

GType
keyboard_source_settings_get_type (void)
{
	static volatile gsize keyboard_source_settings_type_id__once = 0;
	if (g_once_init_enter (&keyboard_source_settings_type_id__once)) {
		GType keyboard_source_settings_type_id;
		keyboard_source_settings_type_id = keyboard_source_settings_get_type_once ();
		g_once_init_leave (&keyboard_source_settings_type_id__once, keyboard_source_settings_type_id);
	}
	return keyboard_source_settings_type_id__once;
}

static void
_vala_keyboard_source_settings_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	KeyboardSourceSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings);
#line 20 "../src/InputSources/SourceSettings.vala"
	switch (property_id) {
#line 20 "../src/InputSources/SourceSettings.vala"
		case KEYBOARD_SOURCE_SETTINGS_ACTIVE_INDEX_PROPERTY:
#line 20 "../src/InputSources/SourceSettings.vala"
		g_value_set_uint (value, keyboard_source_settings_get_active_index (self));
#line 20 "../src/InputSources/SourceSettings.vala"
		break;
#line 20 "../src/InputSources/SourceSettings.vala"
		case KEYBOARD_SOURCE_SETTINGS_ACTIVE_INPUT_SOURCE_PROPERTY:
#line 20 "../src/InputSources/SourceSettings.vala"
		g_value_set_object (value, keyboard_source_settings_get_active_input_source (self));
#line 20 "../src/InputSources/SourceSettings.vala"
		break;
#line 20 "../src/InputSources/SourceSettings.vala"
		case KEYBOARD_SOURCE_SETTINGS_ACTIVE_ENGINES_PROPERTY:
#line 2827 "SourceSettings.c"
		{
			int length;
#line 20 "../src/InputSources/SourceSettings.vala"
			g_value_set_boxed (value, keyboard_source_settings_get_active_engines (self, &length));
#line 2832 "SourceSettings.c"
		}
#line 20 "../src/InputSources/SourceSettings.vala"
		break;
#line 2836 "SourceSettings.c"
		default:
#line 20 "../src/InputSources/SourceSettings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/InputSources/SourceSettings.vala"
		break;
#line 2842 "SourceSettings.c"
	}
}

static void
_vala_keyboard_source_settings_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	KeyboardSourceSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings);
#line 20 "../src/InputSources/SourceSettings.vala"
	switch (property_id) {
#line 20 "../src/InputSources/SourceSettings.vala"
		case KEYBOARD_SOURCE_SETTINGS_ACTIVE_INDEX_PROPERTY:
#line 20 "../src/InputSources/SourceSettings.vala"
		keyboard_source_settings_set_active_index (self, g_value_get_uint (value));
#line 20 "../src/InputSources/SourceSettings.vala"
		break;
#line 20 "../src/InputSources/SourceSettings.vala"
		case KEYBOARD_SOURCE_SETTINGS_ACTIVE_ENGINES_PROPERTY:
#line 2864 "SourceSettings.c"
		{
			gpointer boxed;
#line 20 "../src/InputSources/SourceSettings.vala"
			boxed = g_value_get_boxed (value);
#line 20 "../src/InputSources/SourceSettings.vala"
			keyboard_source_settings_set_active_engines (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2871 "SourceSettings.c"
		}
#line 20 "../src/InputSources/SourceSettings.vala"
		break;
#line 2875 "SourceSettings.c"
		default:
#line 20 "../src/InputSources/SourceSettings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/InputSources/SourceSettings.vala"
		break;
#line 2881 "SourceSettings.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

