/* List.c generated by valac 0.56.10, the Vala compiler
 * generated from List.vala, do not modify */

/*
* Copyright (c) 2017-2018 elementary, LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "keyboard.h"
#include <glib/gi18n-lib.h>

#define KEYBOARD_SHORTCUTS_TYPE_GROUP (keyboard_shortcuts_group_get_type ())
typedef struct _KeyboardShortcutsGroup KeyboardShortcutsGroup;
typedef enum  {
	KEYBOARD_SHORTCUTS_SCHEMA_WM,
	KEYBOARD_SHORTCUTS_SCHEMA_MUTTER,
	KEYBOARD_SHORTCUTS_SCHEMA_GALA,
	KEYBOARD_SHORTCUTS_SCHEMA_MEDIA,
	KEYBOARD_SHORTCUTS_SCHEMA_COUNT
} KeyboardShortcutsSchema;

#define KEYBOARD_SHORTCUTS_TYPE_SCHEMA (keyboard_shortcuts_schema_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define KEYBOARD_SHORTCUTS_TYPE_LIST (keyboard_shortcuts_list_get_type ())
#define KEYBOARD_SHORTCUTS_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEYBOARD_SHORTCUTS_TYPE_LIST, KeyboardShortcutsList))
#define KEYBOARD_SHORTCUTS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEYBOARD_SHORTCUTS_TYPE_LIST, KeyboardShortcutsListClass))
#define KEYBOARD_SHORTCUTS_IS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEYBOARD_SHORTCUTS_TYPE_LIST))
#define KEYBOARD_SHORTCUTS_IS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEYBOARD_SHORTCUTS_TYPE_LIST))
#define KEYBOARD_SHORTCUTS_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEYBOARD_SHORTCUTS_TYPE_LIST, KeyboardShortcutsListClass))

typedef struct _KeyboardShortcutsList KeyboardShortcutsList;
typedef struct _KeyboardShortcutsListClass KeyboardShortcutsListClass;
typedef struct _KeyboardShortcutsListPrivate KeyboardShortcutsListPrivate;
enum  {
	KEYBOARD_SHORTCUTS_LIST_0_PROPERTY,
	KEYBOARD_SHORTCUTS_LIST_NUM_PROPERTIES
};
static GParamSpec* keyboard_shortcuts_list_properties[KEYBOARD_SHORTCUTS_LIST_NUM_PROPERTIES];

struct _KeyboardShortcutsGroup {
	gchar* icon_name;
	gchar* label;
	gchar** actions;
	gint actions_length1;
	gint _actions_size_;
	KeyboardShortcutsSchema* schemas;
	gint schemas_length1;
	gint _schemas_size_;
	gchar** keys;
	gint keys_length1;
	gint _keys_size_;
};

struct _KeyboardShortcutsList {
	GObject parent_instance;
	KeyboardShortcutsListPrivate * priv;
	KeyboardShortcutsGroup* groups;
	gint groups_length1;
	gint _groups_size_;
	KeyboardShortcutsGroup windows_group;
	KeyboardShortcutsGroup workspaces_group;
	KeyboardShortcutsGroup screenshot_group;
	KeyboardShortcutsGroup launchers_group;
	KeyboardShortcutsGroup media_group;
	KeyboardShortcutsGroup a11y_group;
	KeyboardShortcutsGroup system_group;
	KeyboardShortcutsGroup custom_group;
};

struct _KeyboardShortcutsListClass {
	GObjectClass parent_class;
};

static gpointer keyboard_shortcuts_list_parent_class = NULL;

VALA_EXTERN GType keyboard_shortcuts_group_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType keyboard_shortcuts_schema_get_type (void) G_GNUC_CONST ;
VALA_EXTERN KeyboardShortcutsGroup* keyboard_shortcuts_group_dup (const KeyboardShortcutsGroup* self);
VALA_EXTERN void keyboard_shortcuts_group_free (KeyboardShortcutsGroup* self);
VALA_EXTERN void keyboard_shortcuts_group_copy (const KeyboardShortcutsGroup* self,
                                    KeyboardShortcutsGroup* dest);
VALA_EXTERN void keyboard_shortcuts_group_destroy (KeyboardShortcutsGroup* self);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
static KeyboardShortcutsSchema* _vala_array_dup6 (KeyboardShortcutsSchema* self,
                                           gssize length);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
VALA_EXTERN GType keyboard_shortcuts_list_get_type (void) G_GNUC_CONST ;
static void _vala_KeyboardShortcutsGroup_array_free (KeyboardShortcutsGroup * array,
                                              gssize array_length);
VALA_EXTERN void keyboard_shortcuts_list_get_group (KeyboardShortcutsList* self,
                                        KeyboardShortcutsSectionID group,
                                        gchar*** a,
                                        gint* a_length1,
                                        KeyboardShortcutsSchema** s,
                                        gint* s_length1,
                                        gchar*** k,
                                        gint* k_length1);
static gchar** _vala_array_dup8 (gchar** self,
                          gssize length);
static KeyboardShortcutsSchema* _vala_array_dup9 (KeyboardShortcutsSchema* self,
                                           gssize length);
static gchar** _vala_array_dup10 (gchar** self,
                           gssize length);
VALA_EXTERN void keyboard_shortcuts_list_add_action (KeyboardShortcutsList* self,
                                         KeyboardShortcutsGroup* group,
                                         KeyboardShortcutsSchema schema,
                                         const gchar* action,
                                         const gchar* key);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add10 (KeyboardShortcutsSchema* * array,
                        gint* length,
                        gint* size,
                        KeyboardShortcutsSchema value);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN KeyboardShortcutsList* keyboard_shortcuts_list_new (void);
VALA_EXTERN KeyboardShortcutsList* keyboard_shortcuts_list_construct (GType object_type);
static GObject * keyboard_shortcuts_list_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void keyboard_shortcuts_list_finalize (GObject * obj);
static GType keyboard_shortcuts_list_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
#line 21 "../src/Shortcuts/List.vala"
	if (length >= 0) {
#line 165 "List.c"
		gchar** result;
		gssize i;
#line 21 "../src/Shortcuts/List.vala"
		result = g_new0 (gchar*, length + 1);
#line 21 "../src/Shortcuts/List.vala"
		for (i = 0; i < length; i++) {
#line 172 "List.c"
			gchar* _tmp0_;
#line 21 "../src/Shortcuts/List.vala"
			_tmp0_ = g_strdup (self[i]);
#line 21 "../src/Shortcuts/List.vala"
			result[i] = _tmp0_;
#line 178 "List.c"
		}
#line 21 "../src/Shortcuts/List.vala"
		return result;
#line 182 "List.c"
	}
#line 21 "../src/Shortcuts/List.vala"
	return NULL;
#line 186 "List.c"
}

static KeyboardShortcutsSchema*
_vala_array_dup6 (KeyboardShortcutsSchema* self,
                  gssize length)
{
#line 21 "../src/Shortcuts/List.vala"
	if (length > 0) {
#line 21 "../src/Shortcuts/List.vala"
		return _vala_memdup2 (self, length * sizeof (KeyboardShortcutsSchema));
#line 197 "List.c"
	}
#line 21 "../src/Shortcuts/List.vala"
	return NULL;
#line 201 "List.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 21 "../src/Shortcuts/List.vala"
	if (length >= 0) {
#line 210 "List.c"
		gchar** result;
		gssize i;
#line 21 "../src/Shortcuts/List.vala"
		result = g_new0 (gchar*, length + 1);
#line 21 "../src/Shortcuts/List.vala"
		for (i = 0; i < length; i++) {
#line 217 "List.c"
			gchar* _tmp0_;
#line 21 "../src/Shortcuts/List.vala"
			_tmp0_ = g_strdup (self[i]);
#line 21 "../src/Shortcuts/List.vala"
			result[i] = _tmp0_;
#line 223 "List.c"
		}
#line 21 "../src/Shortcuts/List.vala"
		return result;
#line 227 "List.c"
	}
#line 21 "../src/Shortcuts/List.vala"
	return NULL;
#line 231 "List.c"
}

void
keyboard_shortcuts_group_copy (const KeyboardShortcutsGroup* self,
                               KeyboardShortcutsGroup* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	KeyboardShortcutsSchema* _tmp6_;
	gint _tmp6__length1;
	KeyboardShortcutsSchema* _tmp7_;
	gint _tmp7__length1;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
#line 21 "../src/Shortcuts/List.vala"
	_tmp0_ = (*self).icon_name;
#line 21 "../src/Shortcuts/List.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 21 "../src/Shortcuts/List.vala"
	_g_free0 ((*dest).icon_name);
#line 21 "../src/Shortcuts/List.vala"
	(*dest).icon_name = _tmp1_;
#line 21 "../src/Shortcuts/List.vala"
	_tmp2_ = (*self).label;
#line 21 "../src/Shortcuts/List.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 21 "../src/Shortcuts/List.vala"
	_g_free0 ((*dest).label);
#line 21 "../src/Shortcuts/List.vala"
	(*dest).label = _tmp3_;
#line 21 "../src/Shortcuts/List.vala"
	_tmp4_ = (*self).actions;
#line 21 "../src/Shortcuts/List.vala"
	_tmp4__length1 = (*self).actions_length1;
#line 21 "../src/Shortcuts/List.vala"
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup5 (_tmp4_, _tmp4__length1) : _tmp4_;
#line 21 "../src/Shortcuts/List.vala"
	_tmp5__length1 = _tmp4__length1;
#line 21 "../src/Shortcuts/List.vala"
	(*dest).actions = (_vala_array_free ((*dest).actions, (*dest).actions_length1, (GDestroyNotify) g_free), NULL);
#line 21 "../src/Shortcuts/List.vala"
	(*dest).actions = _tmp5_;
#line 21 "../src/Shortcuts/List.vala"
	(*dest).actions_length1 = _tmp5__length1;
#line 21 "../src/Shortcuts/List.vala"
	(*dest)._actions_size_ = (*dest).actions_length1;
#line 21 "../src/Shortcuts/List.vala"
	_tmp6_ = (*self).schemas;
#line 21 "../src/Shortcuts/List.vala"
	_tmp6__length1 = (*self).schemas_length1;
#line 21 "../src/Shortcuts/List.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup6 (_tmp6_, _tmp6__length1) : _tmp6_;
#line 21 "../src/Shortcuts/List.vala"
	_tmp7__length1 = _tmp6__length1;
#line 21 "../src/Shortcuts/List.vala"
	(*dest).schemas = (g_free ((*dest).schemas), NULL);
#line 21 "../src/Shortcuts/List.vala"
	(*dest).schemas = _tmp7_;
#line 21 "../src/Shortcuts/List.vala"
	(*dest).schemas_length1 = _tmp7__length1;
#line 21 "../src/Shortcuts/List.vala"
	(*dest)._schemas_size_ = (*dest).schemas_length1;
#line 21 "../src/Shortcuts/List.vala"
	_tmp8_ = (*self).keys;
#line 21 "../src/Shortcuts/List.vala"
	_tmp8__length1 = (*self).keys_length1;
#line 21 "../src/Shortcuts/List.vala"
	_tmp9_ = (_tmp8_ != NULL) ? _vala_array_dup7 (_tmp8_, _tmp8__length1) : _tmp8_;
#line 21 "../src/Shortcuts/List.vala"
	_tmp9__length1 = _tmp8__length1;
#line 21 "../src/Shortcuts/List.vala"
	(*dest).keys = (_vala_array_free ((*dest).keys, (*dest).keys_length1, (GDestroyNotify) g_free), NULL);
#line 21 "../src/Shortcuts/List.vala"
	(*dest).keys = _tmp9_;
#line 21 "../src/Shortcuts/List.vala"
	(*dest).keys_length1 = _tmp9__length1;
#line 21 "../src/Shortcuts/List.vala"
	(*dest)._keys_size_ = (*dest).keys_length1;
#line 318 "List.c"
}

void
keyboard_shortcuts_group_destroy (KeyboardShortcutsGroup* self)
{
#line 22 "../src/Shortcuts/List.vala"
	_g_free0 ((*self).icon_name);
#line 23 "../src/Shortcuts/List.vala"
	_g_free0 ((*self).label);
#line 24 "../src/Shortcuts/List.vala"
	(*self).actions = (_vala_array_free ((*self).actions, (*self).actions_length1, (GDestroyNotify) g_free), NULL);
#line 25 "../src/Shortcuts/List.vala"
	(*self).schemas = (g_free ((*self).schemas), NULL);
#line 26 "../src/Shortcuts/List.vala"
	(*self).keys = (_vala_array_free ((*self).keys, (*self).keys_length1, (GDestroyNotify) g_free), NULL);
#line 334 "List.c"
}

KeyboardShortcutsGroup*
keyboard_shortcuts_group_dup (const KeyboardShortcutsGroup* self)
{
	KeyboardShortcutsGroup* dup;
#line 21 "../src/Shortcuts/List.vala"
	dup = g_new0 (KeyboardShortcutsGroup, 1);
#line 21 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (self, dup);
#line 21 "../src/Shortcuts/List.vala"
	return dup;
#line 347 "List.c"
}

void
keyboard_shortcuts_group_free (KeyboardShortcutsGroup* self)
{
#line 21 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (self);
#line 21 "../src/Shortcuts/List.vala"
	g_free (self);
#line 357 "List.c"
}

static GType
keyboard_shortcuts_group_get_type_once (void)
{
	GType keyboard_shortcuts_group_type_id;
	keyboard_shortcuts_group_type_id = g_boxed_type_register_static ("KeyboardShortcutsGroup", (GBoxedCopyFunc) keyboard_shortcuts_group_dup, (GBoxedFreeFunc) keyboard_shortcuts_group_free);
	return keyboard_shortcuts_group_type_id;
}

GType
keyboard_shortcuts_group_get_type (void)
{
	static volatile gsize keyboard_shortcuts_group_type_id__once = 0;
	if (g_once_init_enter (&keyboard_shortcuts_group_type_id__once)) {
		GType keyboard_shortcuts_group_type_id;
		keyboard_shortcuts_group_type_id = keyboard_shortcuts_group_get_type_once ();
		g_once_init_leave (&keyboard_shortcuts_group_type_id__once, keyboard_shortcuts_group_type_id);
	}
	return keyboard_shortcuts_group_type_id__once;
}

static void
_vala_KeyboardShortcutsGroup_array_free (KeyboardShortcutsGroup * array,
                                         gssize array_length)
{
#line 30 "../src/Shortcuts/List.vala"
	if (array != NULL) {
#line 386 "List.c"
		gssize i;
#line 30 "../src/Shortcuts/List.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 30 "../src/Shortcuts/List.vala"
			keyboard_shortcuts_group_destroy (&array[i]);
#line 392 "List.c"
		}
	}
#line 30 "../src/Shortcuts/List.vala"
	g_free (array);
#line 397 "List.c"
}

static gchar**
_vala_array_dup8 (gchar** self,
                  gssize length)
{
#line 164 "../src/Shortcuts/List.vala"
	if (length >= 0) {
#line 406 "List.c"
		gchar** result;
		gssize i;
#line 164 "../src/Shortcuts/List.vala"
		result = g_new0 (gchar*, length + 1);
#line 164 "../src/Shortcuts/List.vala"
		for (i = 0; i < length; i++) {
#line 413 "List.c"
			gchar* _tmp0_;
#line 164 "../src/Shortcuts/List.vala"
			_tmp0_ = g_strdup (self[i]);
#line 164 "../src/Shortcuts/List.vala"
			result[i] = _tmp0_;
#line 419 "List.c"
		}
#line 164 "../src/Shortcuts/List.vala"
		return result;
#line 423 "List.c"
	}
#line 164 "../src/Shortcuts/List.vala"
	return NULL;
#line 427 "List.c"
}

static KeyboardShortcutsSchema*
_vala_array_dup9 (KeyboardShortcutsSchema* self,
                  gssize length)
{
#line 165 "../src/Shortcuts/List.vala"
	if (length > 0) {
#line 165 "../src/Shortcuts/List.vala"
		return _vala_memdup2 (self, length * sizeof (KeyboardShortcutsSchema));
#line 438 "List.c"
	}
#line 165 "../src/Shortcuts/List.vala"
	return NULL;
#line 442 "List.c"
}

static gchar**
_vala_array_dup10 (gchar** self,
                   gssize length)
{
#line 166 "../src/Shortcuts/List.vala"
	if (length >= 0) {
#line 451 "List.c"
		gchar** result;
		gssize i;
#line 166 "../src/Shortcuts/List.vala"
		result = g_new0 (gchar*, length + 1);
#line 166 "../src/Shortcuts/List.vala"
		for (i = 0; i < length; i++) {
#line 458 "List.c"
			gchar* _tmp0_;
#line 166 "../src/Shortcuts/List.vala"
			_tmp0_ = g_strdup (self[i]);
#line 166 "../src/Shortcuts/List.vala"
			result[i] = _tmp0_;
#line 464 "List.c"
		}
#line 166 "../src/Shortcuts/List.vala"
		return result;
#line 468 "List.c"
	}
#line 166 "../src/Shortcuts/List.vala"
	return NULL;
#line 472 "List.c"
}

void
keyboard_shortcuts_list_get_group (KeyboardShortcutsList* self,
                                   KeyboardShortcutsSectionID group,
                                   gchar*** a,
                                   gint* a_length1,
                                   KeyboardShortcutsSchema** s,
                                   gint* s_length1,
                                   gchar*** k,
                                   gint* k_length1)
{
	gchar** _vala_a = NULL;
	gint _vala_a_length1 = 0;
	KeyboardShortcutsSchema* _vala_s = NULL;
	gint _vala_s_length1 = 0;
	gchar** _vala_k = NULL;
	gint _vala_k_length1 = 0;
	KeyboardShortcutsGroup* _tmp0_;
	gint _tmp0__length1;
	KeyboardShortcutsGroup _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
	KeyboardShortcutsGroup* _tmp4_;
	gint _tmp4__length1;
	KeyboardShortcutsGroup _tmp5_;
	KeyboardShortcutsSchema* _tmp6_;
	gint _tmp6__length1;
	KeyboardShortcutsSchema* _tmp7_;
	gint _tmp7__length1;
	KeyboardShortcutsGroup* _tmp8_;
	gint _tmp8__length1;
	KeyboardShortcutsGroup _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
#line 163 "../src/Shortcuts/List.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Shortcuts/List.vala"
	_tmp0_ = self->groups;
#line 164 "../src/Shortcuts/List.vala"
	_tmp0__length1 = self->groups_length1;
#line 164 "../src/Shortcuts/List.vala"
	_tmp1_ = _tmp0_[group];
#line 164 "../src/Shortcuts/List.vala"
	_tmp2_ = _tmp1_.actions;
#line 164 "../src/Shortcuts/List.vala"
	_tmp2__length1 = _tmp1_.actions_length1;
#line 164 "../src/Shortcuts/List.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup8 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 164 "../src/Shortcuts/List.vala"
	_tmp3__length1 = _tmp2__length1;
#line 164 "../src/Shortcuts/List.vala"
	_vala_a = (_vala_array_free (_vala_a, _vala_a_length1, (GDestroyNotify) g_free), NULL);
#line 164 "../src/Shortcuts/List.vala"
	_vala_a = _tmp3_;
#line 164 "../src/Shortcuts/List.vala"
	_vala_a_length1 = _tmp3__length1;
#line 165 "../src/Shortcuts/List.vala"
	_tmp4_ = self->groups;
#line 165 "../src/Shortcuts/List.vala"
	_tmp4__length1 = self->groups_length1;
#line 165 "../src/Shortcuts/List.vala"
	_tmp5_ = _tmp4_[group];
#line 165 "../src/Shortcuts/List.vala"
	_tmp6_ = _tmp5_.schemas;
#line 165 "../src/Shortcuts/List.vala"
	_tmp6__length1 = _tmp5_.schemas_length1;
#line 165 "../src/Shortcuts/List.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup9 (_tmp6_, _tmp6__length1) : _tmp6_;
#line 165 "../src/Shortcuts/List.vala"
	_tmp7__length1 = _tmp6__length1;
#line 165 "../src/Shortcuts/List.vala"
	_vala_s = (g_free (_vala_s), NULL);
#line 165 "../src/Shortcuts/List.vala"
	_vala_s = _tmp7_;
#line 165 "../src/Shortcuts/List.vala"
	_vala_s_length1 = _tmp7__length1;
#line 166 "../src/Shortcuts/List.vala"
	_tmp8_ = self->groups;
#line 166 "../src/Shortcuts/List.vala"
	_tmp8__length1 = self->groups_length1;
#line 166 "../src/Shortcuts/List.vala"
	_tmp9_ = _tmp8_[group];
#line 166 "../src/Shortcuts/List.vala"
	_tmp10_ = _tmp9_.keys;
#line 166 "../src/Shortcuts/List.vala"
	_tmp10__length1 = _tmp9_.keys_length1;
#line 166 "../src/Shortcuts/List.vala"
	_tmp11_ = (_tmp10_ != NULL) ? _vala_array_dup10 (_tmp10_, _tmp10__length1) : _tmp10_;
#line 166 "../src/Shortcuts/List.vala"
	_tmp11__length1 = _tmp10__length1;
#line 166 "../src/Shortcuts/List.vala"
	_vala_k = (_vala_array_free (_vala_k, _vala_k_length1, (GDestroyNotify) g_free), NULL);
#line 166 "../src/Shortcuts/List.vala"
	_vala_k = _tmp11_;
#line 166 "../src/Shortcuts/List.vala"
	_vala_k_length1 = _tmp11__length1;
#line 167 "../src/Shortcuts/List.vala"
	if (a) {
#line 167 "../src/Shortcuts/List.vala"
		*a = _vala_a;
#line 578 "List.c"
	} else {
#line 167 "../src/Shortcuts/List.vala"
		_vala_a = (_vala_array_free (_vala_a, _vala_a_length1, (GDestroyNotify) g_free), NULL);
#line 582 "List.c"
	}
#line 167 "../src/Shortcuts/List.vala"
	if (a_length1) {
#line 167 "../src/Shortcuts/List.vala"
		*a_length1 = _vala_a_length1;
#line 588 "List.c"
	}
#line 167 "../src/Shortcuts/List.vala"
	if (s) {
#line 167 "../src/Shortcuts/List.vala"
		*s = _vala_s;
#line 594 "List.c"
	} else {
#line 167 "../src/Shortcuts/List.vala"
		_vala_s = (g_free (_vala_s), NULL);
#line 598 "List.c"
	}
#line 167 "../src/Shortcuts/List.vala"
	if (s_length1) {
#line 167 "../src/Shortcuts/List.vala"
		*s_length1 = _vala_s_length1;
#line 604 "List.c"
	}
#line 167 "../src/Shortcuts/List.vala"
	if (k) {
#line 167 "../src/Shortcuts/List.vala"
		*k = _vala_k;
#line 610 "List.c"
	} else {
#line 167 "../src/Shortcuts/List.vala"
		_vala_k = (_vala_array_free (_vala_k, _vala_k_length1, (GDestroyNotify) g_free), NULL);
#line 614 "List.c"
	}
#line 167 "../src/Shortcuts/List.vala"
	if (k_length1) {
#line 167 "../src/Shortcuts/List.vala"
		*k_length1 = _vala_k_length1;
#line 620 "List.c"
	}
#line 167 "../src/Shortcuts/List.vala"
	return;
#line 624 "List.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 171 "../src/Shortcuts/List.vala"
	if ((*length) == (*size)) {
#line 171 "../src/Shortcuts/List.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 171 "../src/Shortcuts/List.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 639 "List.c"
	}
#line 171 "../src/Shortcuts/List.vala"
	(*array)[(*length)++] = value;
#line 171 "../src/Shortcuts/List.vala"
	(*array)[*length] = NULL;
#line 645 "List.c"
}

static void
_vala_array_add10 (KeyboardShortcutsSchema* * array,
                   gint* length,
                   gint* size,
                   KeyboardShortcutsSchema value)
{
#line 172 "../src/Shortcuts/List.vala"
	if ((*length) == (*size)) {
#line 172 "../src/Shortcuts/List.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 172 "../src/Shortcuts/List.vala"
		*array = g_renew (KeyboardShortcutsSchema, *array, *size);
#line 660 "List.c"
	}
#line 172 "../src/Shortcuts/List.vala"
	(*array)[(*length)++] = value;
#line 664 "List.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 173 "../src/Shortcuts/List.vala"
	if ((*length) == (*size)) {
#line 173 "../src/Shortcuts/List.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 173 "../src/Shortcuts/List.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 679 "List.c"
	}
#line 173 "../src/Shortcuts/List.vala"
	(*array)[(*length)++] = value;
#line 173 "../src/Shortcuts/List.vala"
	(*array)[*length] = NULL;
#line 685 "List.c"
}

void
keyboard_shortcuts_list_add_action (KeyboardShortcutsList* self,
                                    KeyboardShortcutsGroup* group,
                                    KeyboardShortcutsSchema schema,
                                    const gchar* action,
                                    const gchar* key)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 170 "../src/Shortcuts/List.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Shortcuts/List.vala"
	g_return_if_fail (group != NULL);
#line 170 "../src/Shortcuts/List.vala"
	g_return_if_fail (action != NULL);
#line 170 "../src/Shortcuts/List.vala"
	g_return_if_fail (key != NULL);
#line 171 "../src/Shortcuts/List.vala"
	_tmp0_ = g_strdup (key);
#line 171 "../src/Shortcuts/List.vala"
	_vala_array_add9 (&(*group).keys, &(*group).keys_length1, &(*group)._keys_size_, _tmp0_);
#line 172 "../src/Shortcuts/List.vala"
	_vala_array_add10 (&(*group).schemas, &(*group).schemas_length1, &(*group)._schemas_size_, schema);
#line 173 "../src/Shortcuts/List.vala"
	_tmp1_ = g_strdup (action);
#line 173 "../src/Shortcuts/List.vala"
	_vala_array_add11 (&(*group).actions, &(*group).actions_length1, &(*group)._actions_size_, _tmp1_);
#line 715 "List.c"
}

KeyboardShortcutsList*
keyboard_shortcuts_list_construct (GType object_type)
{
	KeyboardShortcutsList * self = NULL;
#line 29 "../src/Shortcuts/List.vala"
	self = (KeyboardShortcutsList*) g_object_new (object_type, NULL);
#line 29 "../src/Shortcuts/List.vala"
	return self;
#line 726 "List.c"
}

KeyboardShortcutsList*
keyboard_shortcuts_list_new (void)
{
#line 29 "../src/Shortcuts/List.vala"
	return keyboard_shortcuts_list_construct (KEYBOARD_SHORTCUTS_TYPE_LIST);
#line 734 "List.c"
}

static GObject *
keyboard_shortcuts_list_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KeyboardShortcutsList * self;
	KeyboardShortcutsGroup _tmp0_ = {0};
	gchar* _tmp1_;
	gchar* _tmp2_;
	KeyboardShortcutsGroup _tmp3_ = {0};
	gchar* _tmp4_;
	gchar* _tmp5_;
	KeyboardShortcutsGroup _tmp6_ = {0};
	gchar* _tmp7_;
	gchar* _tmp8_;
	KeyboardShortcutsGroup _tmp9_ = {0};
	gchar* _tmp10_;
	gchar* _tmp11_;
	KeyboardShortcutsGroup _tmp12_ = {0};
	gchar* _tmp13_;
	gchar* _tmp14_;
	KeyboardShortcutsGroup _tmp15_ = {0};
	gchar* _tmp16_;
	gchar* _tmp17_;
	KeyboardShortcutsGroup _tmp18_ = {0};
	gchar* _tmp19_;
	gchar* _tmp20_;
	KeyboardShortcutsGroup _tmp21_ = {0};
	gchar* _tmp22_;
	gchar* _tmp23_;
	KeyboardShortcutsGroup _tmp24_;
	KeyboardShortcutsGroup _tmp25_;
	KeyboardShortcutsGroup _tmp26_ = {0};
	KeyboardShortcutsGroup _tmp27_;
	KeyboardShortcutsGroup _tmp28_;
	KeyboardShortcutsGroup _tmp29_ = {0};
	KeyboardShortcutsGroup _tmp30_;
	KeyboardShortcutsGroup _tmp31_;
	KeyboardShortcutsGroup _tmp32_ = {0};
	KeyboardShortcutsGroup _tmp33_;
	KeyboardShortcutsGroup _tmp34_;
	KeyboardShortcutsGroup _tmp35_ = {0};
	KeyboardShortcutsGroup _tmp36_;
	KeyboardShortcutsGroup _tmp37_;
	KeyboardShortcutsGroup _tmp38_ = {0};
	KeyboardShortcutsGroup _tmp39_;
	KeyboardShortcutsGroup _tmp40_;
	KeyboardShortcutsGroup _tmp41_ = {0};
	KeyboardShortcutsGroup _tmp42_;
	KeyboardShortcutsGroup _tmp43_;
	KeyboardShortcutsGroup _tmp44_ = {0};
	KeyboardShortcutsGroup* _tmp45_;
#line 40 "../src/Shortcuts/List.vala"
	parent_class = G_OBJECT_CLASS (keyboard_shortcuts_list_parent_class);
#line 40 "../src/Shortcuts/List.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/Shortcuts/List.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_SHORTCUTS_TYPE_LIST, KeyboardShortcutsList);
#line 41 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->windows_group);
#line 41 "../src/Shortcuts/List.vala"
	self->windows_group = _tmp0_;
#line 42 "../src/Shortcuts/List.vala"
	_tmp1_ = g_strdup ("io.elementary.switchboard.keyboard.windows");
#line 42 "../src/Shortcuts/List.vala"
	_g_free0 (self->windows_group.icon_name);
#line 42 "../src/Shortcuts/List.vala"
	self->windows_group.icon_name = _tmp1_;
#line 43 "../src/Shortcuts/List.vala"
	_tmp2_ = g_strdup (_ ("Windows"));
#line 43 "../src/Shortcuts/List.vala"
	_g_free0 (self->windows_group.label);
#line 43 "../src/Shortcuts/List.vala"
	self->windows_group.label = _tmp2_;
#line 44 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Close"), "close");
#line 45 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Lower"), "lower");
#line 46 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Maximize"), "maximize");
#line 47 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Unmaximize"), "unmaximize");
#line 48 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Toggle Maximized"), "toggle-maximized");
#line 49 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Hide"), "minimize");
#line 50 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Toggle Fullscreen"), "toggle-fullscreen");
#line 51 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Toggle on all Workspaces"), "toggle-on-all-workspaces");
#line 52 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Toggle always on Top"), "toggle-above");
#line 53 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Cycle Windows"), "switch-windows");
#line 54 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Cycle Windows backwards"), "switch-windows-backward");
#line 55 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Cycle Windows of application"), "switch-group");
#line 56 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Cycle Windows of application backwards"), "switch-group-backward");
#line 57 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_MUTTER, _ ("Tile Left"), "toggle-tiled-left");
#line 58 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_MUTTER, _ ("Tile Right"), "toggle-tiled-right");
#line 59 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Window Overview"), "expose-windows");
#line 60 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Show All Windows"), "expose-all-windows");
#line 61 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Picture in Picture Mode"), "pip");
#line 62 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to display above"), "move-to-monitor-up");
#line 63 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to display below"), "move-to-monitor-down");
#line 64 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to right display"), "move-to-monitor-right");
#line 65 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->windows_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to left display"), "move-to-monitor-left");
#line 67 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->workspaces_group);
#line 67 "../src/Shortcuts/List.vala"
	self->workspaces_group = _tmp3_;
#line 68 "../src/Shortcuts/List.vala"
	_tmp4_ = g_strdup ("preferences-desktop-workspaces");
#line 68 "../src/Shortcuts/List.vala"
	_g_free0 (self->workspaces_group.icon_name);
#line 68 "../src/Shortcuts/List.vala"
	self->workspaces_group.icon_name = _tmp4_;
#line 69 "../src/Shortcuts/List.vala"
	_tmp5_ = g_strdup (_ ("Workspaces"));
#line 69 "../src/Shortcuts/List.vala"
	_g_free0 (self->workspaces_group.label);
#line 69 "../src/Shortcuts/List.vala"
	self->workspaces_group.label = _tmp5_;
#line 70 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Multitasking View"), "show-desktop");
#line 71 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch left"), "switch-to-workspace-left");
#line 72 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch right"), "switch-to-workspace-right");
#line 73 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Switch to first"), "switch-to-workspace-first");
#line 74 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Switch to new"), "switch-to-workspace-last");
#line 75 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 1"), "switch-to-workspace-1");
#line 76 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 2"), "switch-to-workspace-2");
#line 77 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 3"), "switch-to-workspace-3");
#line 78 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 4"), "switch-to-workspace-4");
#line 79 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 5"), "switch-to-workspace-5");
#line 80 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 6"), "switch-to-workspace-6");
#line 81 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 7"), "switch-to-workspace-7");
#line 82 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 8"), "switch-to-workspace-8");
#line 83 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Switch to workspace 9"), "switch-to-workspace-9");
#line 84 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Cycle workspaces"), "cycle-workspaces-next");
#line 85 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Cycle workspaces backwards"), "cycle-workspaces-previous");
#line 86 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 1"), "move-to-workspace-1");
#line 87 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 2"), "move-to-workspace-2");
#line 88 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 3"), "move-to-workspace-3");
#line 89 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 4"), "move-to-workspace-4");
#line 90 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 5"), "move-to-workspace-5");
#line 91 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 6"), "move-to-workspace-6");
#line 92 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 7"), "move-to-workspace-7");
#line 93 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 8"), "move-to-workspace-8");
#line 94 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to workspace 9"), "move-to-workspace-9");
#line 95 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to left workspace"), "move-to-workspace-left");
#line 96 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->workspaces_group, KEYBOARD_SHORTCUTS_SCHEMA_WM, _ ("Move to right workspace"), "move-to-workspace-right");
#line 98 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->screenshot_group);
#line 98 "../src/Shortcuts/List.vala"
	self->screenshot_group = _tmp6_;
#line 99 "../src/Shortcuts/List.vala"
	_tmp7_ = g_strdup ("io.elementary.switchboard.keyboard.screenshots");
#line 99 "../src/Shortcuts/List.vala"
	_g_free0 (self->screenshot_group.icon_name);
#line 99 "../src/Shortcuts/List.vala"
	self->screenshot_group.icon_name = _tmp7_;
#line 100 "../src/Shortcuts/List.vala"
	_tmp8_ = g_strdup (_ ("Screenshots"));
#line 100 "../src/Shortcuts/List.vala"
	_g_free0 (self->screenshot_group.label);
#line 100 "../src/Shortcuts/List.vala"
	self->screenshot_group.label = _tmp8_;
#line 101 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->screenshot_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Grab the whole screen"), "screenshot");
#line 102 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->screenshot_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Copy the whole screen to clipboard"), "screenshot-clip");
#line 103 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->screenshot_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Grab the current window"), "window-screenshot");
#line 104 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->screenshot_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Copy the current window to clipboard"), "window-screenshot-clip");
#line 105 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->screenshot_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Select an area to grab"), "area-screenshot");
#line 106 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->screenshot_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Copy an area to clipboard"), "area-screenshot-clip");
#line 108 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->launchers_group);
#line 108 "../src/Shortcuts/List.vala"
	self->launchers_group = _tmp9_;
#line 109 "../src/Shortcuts/List.vala"
	_tmp10_ = g_strdup ("preferences-desktop-applications");
#line 109 "../src/Shortcuts/List.vala"
	_g_free0 (self->launchers_group.icon_name);
#line 109 "../src/Shortcuts/List.vala"
	self->launchers_group.icon_name = _tmp10_;
#line 110 "../src/Shortcuts/List.vala"
	_tmp11_ = g_strdup (_ ("Applications"));
#line 110 "../src/Shortcuts/List.vala"
	_g_free0 (self->launchers_group.label);
#line 110 "../src/Shortcuts/List.vala"
	self->launchers_group.label = _tmp11_;
#line 111 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->launchers_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Email"), "email");
#line 112 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->launchers_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Home Folder"), "home");
#line 113 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->launchers_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Music"), "media");
#line 114 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->launchers_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Terminal"), "terminal");
#line 115 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->launchers_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Internet Browser"), "www");
#line 117 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->media_group);
#line 117 "../src/Shortcuts/List.vala"
	self->media_group = _tmp12_;
#line 118 "../src/Shortcuts/List.vala"
	_tmp13_ = g_strdup ("applications-multimedia");
#line 118 "../src/Shortcuts/List.vala"
	_g_free0 (self->media_group.icon_name);
#line 118 "../src/Shortcuts/List.vala"
	self->media_group.icon_name = _tmp13_;
#line 119 "../src/Shortcuts/List.vala"
	_tmp14_ = g_strdup (_ ("Media"));
#line 119 "../src/Shortcuts/List.vala"
	_g_free0 (self->media_group.label);
#line 119 "../src/Shortcuts/List.vala"
	self->media_group.label = _tmp14_;
#line 120 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Volume Up"), "volume-up");
#line 121 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Volume Down"), "volume-down");
#line 122 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Mute"), "volume-mute");
#line 123 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Play/Pause"), "play");
#line 124 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Pause"), "pause");
#line 125 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Stop"), "stop");
#line 126 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Previous Track"), "previous");
#line 127 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Next Track"), "next");
#line 128 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->media_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Eject"), "eject");
#line 130 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->a11y_group);
#line 130 "../src/Shortcuts/List.vala"
	self->a11y_group = _tmp15_;
#line 131 "../src/Shortcuts/List.vala"
	_tmp16_ = g_strdup ("preferences-desktop-accessibility");
#line 131 "../src/Shortcuts/List.vala"
	_g_free0 (self->a11y_group.icon_name);
#line 131 "../src/Shortcuts/List.vala"
	self->a11y_group.icon_name = _tmp16_;
#line 132 "../src/Shortcuts/List.vala"
	_tmp17_ = g_strdup (_ ("Universal Access"));
#line 132 "../src/Shortcuts/List.vala"
	_g_free0 (self->a11y_group.label);
#line 132 "../src/Shortcuts/List.vala"
	self->a11y_group.label = _tmp17_;
#line 133 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->a11y_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Decrease Text Size"), "decrease-text-size");
#line 134 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->a11y_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Increase Text Size"), "increase-text-size");
#line 135 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->a11y_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Magnifier Zoom in"), "zoom-in");
#line 136 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->a11y_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Magnifier Zoom out"), "zoom-out");
#line 137 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->a11y_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Toggle On Screen Keyboard"), "on-screen-keyboard");
#line 138 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->a11y_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Toggle Screenreader"), "screenreader");
#line 140 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->system_group);
#line 140 "../src/Shortcuts/List.vala"
	self->system_group = _tmp18_;
#line 141 "../src/Shortcuts/List.vala"
	_tmp19_ = g_strdup ("preferences-system");
#line 141 "../src/Shortcuts/List.vala"
	_g_free0 (self->system_group.icon_name);
#line 141 "../src/Shortcuts/List.vala"
	self->system_group.icon_name = _tmp19_;
#line 142 "../src/Shortcuts/List.vala"
	_tmp20_ = g_strdup (_ ("System"));
#line 142 "../src/Shortcuts/List.vala"
	_g_free0 (self->system_group.label);
#line 142 "../src/Shortcuts/List.vala"
	self->system_group.label = _tmp20_;
#line 143 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->system_group, KEYBOARD_SHORTCUTS_SCHEMA_GALA, _ ("Applications Menu"), "panel-main-menu");
#line 144 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->system_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Lock"), "screensaver");
#line 145 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->system_group, KEYBOARD_SHORTCUTS_SCHEMA_MEDIA, _ ("Log Out"), "logout");
#line 146 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_add_action (self, &self->system_group, KEYBOARD_SHORTCUTS_SCHEMA_MUTTER, _ ("Cycle display mode"), "switch-monitor");
#line 148 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->custom_group);
#line 148 "../src/Shortcuts/List.vala"
	self->custom_group = _tmp21_;
#line 149 "../src/Shortcuts/List.vala"
	_tmp22_ = g_strdup ("applications-other");
#line 149 "../src/Shortcuts/List.vala"
	_g_free0 (self->custom_group.icon_name);
#line 149 "../src/Shortcuts/List.vala"
	self->custom_group.icon_name = _tmp22_;
#line 150 "../src/Shortcuts/List.vala"
	_tmp23_ = g_strdup (_ ("Custom"));
#line 150 "../src/Shortcuts/List.vala"
	_g_free0 (self->custom_group.label);
#line 150 "../src/Shortcuts/List.vala"
	self->custom_group.label = _tmp23_;
#line 152 "../src/Shortcuts/List.vala"
	_tmp24_ = self->windows_group;
#line 152 "../src/Shortcuts/List.vala"
	_tmp25_ = _tmp24_;
#line 152 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (&_tmp25_, &_tmp26_);
#line 152 "../src/Shortcuts/List.vala"
	_tmp27_ = self->workspaces_group;
#line 152 "../src/Shortcuts/List.vala"
	_tmp28_ = _tmp27_;
#line 152 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (&_tmp28_, &_tmp29_);
#line 152 "../src/Shortcuts/List.vala"
	_tmp30_ = self->screenshot_group;
#line 152 "../src/Shortcuts/List.vala"
	_tmp31_ = _tmp30_;
#line 152 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (&_tmp31_, &_tmp32_);
#line 152 "../src/Shortcuts/List.vala"
	_tmp33_ = self->launchers_group;
#line 152 "../src/Shortcuts/List.vala"
	_tmp34_ = _tmp33_;
#line 152 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (&_tmp34_, &_tmp35_);
#line 152 "../src/Shortcuts/List.vala"
	_tmp36_ = self->media_group;
#line 152 "../src/Shortcuts/List.vala"
	_tmp37_ = _tmp36_;
#line 152 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (&_tmp37_, &_tmp38_);
#line 152 "../src/Shortcuts/List.vala"
	_tmp39_ = self->a11y_group;
#line 152 "../src/Shortcuts/List.vala"
	_tmp40_ = _tmp39_;
#line 152 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (&_tmp40_, &_tmp41_);
#line 152 "../src/Shortcuts/List.vala"
	_tmp42_ = self->system_group;
#line 152 "../src/Shortcuts/List.vala"
	_tmp43_ = _tmp42_;
#line 152 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_copy (&_tmp43_, &_tmp44_);
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_ = g_new0 (KeyboardShortcutsGroup, 7);
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_[0] = _tmp26_;
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_[1] = _tmp29_;
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_[2] = _tmp32_;
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_[3] = _tmp35_;
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_[4] = _tmp38_;
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_[5] = _tmp41_;
#line 152 "../src/Shortcuts/List.vala"
	_tmp45_[6] = _tmp44_;
#line 152 "../src/Shortcuts/List.vala"
	self->groups = (_vala_KeyboardShortcutsGroup_array_free (self->groups, self->groups_length1), NULL);
#line 152 "../src/Shortcuts/List.vala"
	self->groups = _tmp45_;
#line 152 "../src/Shortcuts/List.vala"
	self->groups_length1 = 7;
#line 152 "../src/Shortcuts/List.vala"
	self->_groups_size_ = self->groups_length1;
#line 40 "../src/Shortcuts/List.vala"
	return obj;
#line 1151 "List.c"
}

static void
keyboard_shortcuts_list_class_init (KeyboardShortcutsListClass * klass,
                                    gpointer klass_data)
{
#line 29 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_list_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Shortcuts/List.vala"
	G_OBJECT_CLASS (klass)->constructor = keyboard_shortcuts_list_constructor;
#line 29 "../src/Shortcuts/List.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_shortcuts_list_finalize;
#line 1164 "List.c"
}

static void
keyboard_shortcuts_list_instance_init (KeyboardShortcutsList * self,
                                       gpointer klass)
{
}

static void
keyboard_shortcuts_list_finalize (GObject * obj)
{
	KeyboardShortcutsList * self;
#line 29 "../src/Shortcuts/List.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_SHORTCUTS_TYPE_LIST, KeyboardShortcutsList);
#line 30 "../src/Shortcuts/List.vala"
	self->groups = (_vala_KeyboardShortcutsGroup_array_free (self->groups, self->groups_length1), NULL);
#line 31 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->windows_group);
#line 32 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->workspaces_group);
#line 33 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->screenshot_group);
#line 34 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->launchers_group);
#line 35 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->media_group);
#line 36 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->a11y_group);
#line 37 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->system_group);
#line 38 "../src/Shortcuts/List.vala"
	keyboard_shortcuts_group_destroy (&self->custom_group);
#line 29 "../src/Shortcuts/List.vala"
	G_OBJECT_CLASS (keyboard_shortcuts_list_parent_class)->finalize (obj);
#line 1199 "List.c"
}

static GType
keyboard_shortcuts_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardShortcutsListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_shortcuts_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardShortcutsList), 0, (GInstanceInitFunc) keyboard_shortcuts_list_instance_init, NULL };
	GType keyboard_shortcuts_list_type_id;
	keyboard_shortcuts_list_type_id = g_type_register_static (G_TYPE_OBJECT, "KeyboardShortcutsList", &g_define_type_info, 0);
	return keyboard_shortcuts_list_type_id;
}

GType
keyboard_shortcuts_list_get_type (void)
{
	static volatile gsize keyboard_shortcuts_list_type_id__once = 0;
	if (g_once_init_enter (&keyboard_shortcuts_list_type_id__once)) {
		GType keyboard_shortcuts_list_type_id;
		keyboard_shortcuts_list_type_id = keyboard_shortcuts_list_get_type_once ();
		g_once_init_leave (&keyboard_shortcuts_list_type_id__once, keyboard_shortcuts_list_type_id);
	}
	return keyboard_shortcuts_list_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

