/* Shortcut.c generated by valac 0.56.10, the Vala compiler
 * generated from Shortcut.vala, do not modify */

/*
* Copyright (c) 2017 elementary, LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* stores a shortcut, converts to gsettings format and readable format*/
/* and checks for validity*/

#include "keyboard.h"
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#define KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR " + "

enum  {
	KEYBOARD_SHORTCUTS_SHORTCUT_0_PROPERTY,
	KEYBOARD_SHORTCUTS_SHORTCUT_MODIFIERS_PROPERTY,
	KEYBOARD_SHORTCUTS_SHORTCUT_ACCEL_KEY_PROPERTY,
	KEYBOARD_SHORTCUTS_SHORTCUT_NUM_PROPERTIES
};
static GParamSpec* keyboard_shortcuts_shortcut_properties[KEYBOARD_SHORTCUTS_SHORTCUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _KeyboardShortcutsShortcutPrivate {
	GdkModifierType _modifiers;
	guint _accel_key;
};

static gint KeyboardShortcutsShortcut_private_offset;
static gpointer keyboard_shortcuts_shortcut_parent_class = NULL;

static gboolean keyboard_shortcuts_shortcut_valid (KeyboardShortcutsShortcut* self);
static void keyboard_shortcuts_shortcut_finalize (GObject * obj);
static GType keyboard_shortcuts_shortcut_get_type_once (void);
static void _vala_keyboard_shortcuts_shortcut_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_keyboard_shortcuts_shortcut_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
keyboard_shortcuts_shortcut_get_instance_private (KeyboardShortcutsShortcut* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardShortcutsShortcut_private_offset);
}

KeyboardShortcutsShortcut*
keyboard_shortcuts_shortcut_construct (GType object_type,
                                       guint key,
                                       GdkModifierType mod)
{
	KeyboardShortcutsShortcut * self = NULL;
#line 29 "../src/Shortcuts/Shortcut.vala"
	self = (KeyboardShortcutsShortcut*) g_object_new (object_type, "accel-key", key, "modifiers", mod, NULL);
#line 28 "../src/Shortcuts/Shortcut.vala"
	return self;
#line 82 "Shortcut.c"
}

KeyboardShortcutsShortcut*
keyboard_shortcuts_shortcut_new (guint key,
                                 GdkModifierType mod)
{
#line 28 "../src/Shortcuts/Shortcut.vala"
	return keyboard_shortcuts_shortcut_construct (KEYBOARD_SHORTCUTS_TYPE_SHORTCUT, key, mod);
#line 91 "Shortcut.c"
}

KeyboardShortcutsShortcut*
keyboard_shortcuts_shortcut_construct_parse (GType object_type,
                                             const gchar* str)
{
	KeyboardShortcutsShortcut * self = NULL;
	guint key = 0U;
	GdkModifierType mod = 0U;
#line 36 "../src/Shortcuts/Shortcut.vala"
	key = (guint) 0;
#line 37 "../src/Shortcuts/Shortcut.vala"
	mod = (GdkModifierType) 0;
#line 38 "../src/Shortcuts/Shortcut.vala"
	if (str != NULL) {
#line 107 "Shortcut.c"
		guint _tmp0_ = 0U;
		GdkModifierType _tmp1_ = 0U;
#line 39 "../src/Shortcuts/Shortcut.vala"
		gtk_accelerator_parse (str, &_tmp0_, &_tmp1_);
#line 39 "../src/Shortcuts/Shortcut.vala"
		key = _tmp0_;
#line 39 "../src/Shortcuts/Shortcut.vala"
		mod = _tmp1_;
#line 116 "Shortcut.c"
	}
#line 42 "../src/Shortcuts/Shortcut.vala"
	self = (KeyboardShortcutsShortcut*) keyboard_shortcuts_shortcut_construct (object_type, key, mod);
#line 35 "../src/Shortcuts/Shortcut.vala"
	return self;
#line 122 "Shortcut.c"
}

KeyboardShortcutsShortcut*
keyboard_shortcuts_shortcut_new_parse (const gchar* str)
{
#line 35 "../src/Shortcuts/Shortcut.vala"
	return keyboard_shortcuts_shortcut_construct_parse (KEYBOARD_SHORTCUTS_TYPE_SHORTCUT, str);
#line 130 "Shortcut.c"
}

gchar*
keyboard_shortcuts_shortcut_to_gsettings (KeyboardShortcutsShortcut* self)
{
	guint _tmp1_;
	GdkModifierType _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 46 "../src/Shortcuts/Shortcut.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/Shortcuts/Shortcut.vala"
	if (!keyboard_shortcuts_shortcut_valid (self)) {
#line 144 "Shortcut.c"
		gchar* _tmp0_;
#line 48 "../src/Shortcuts/Shortcut.vala"
		_tmp0_ = g_strdup ("");
#line 48 "../src/Shortcuts/Shortcut.vala"
		result = _tmp0_;
#line 48 "../src/Shortcuts/Shortcut.vala"
		return result;
#line 152 "Shortcut.c"
	}
#line 50 "../src/Shortcuts/Shortcut.vala"
	_tmp1_ = self->priv->_accel_key;
#line 50 "../src/Shortcuts/Shortcut.vala"
	_tmp2_ = self->priv->_modifiers;
#line 50 "../src/Shortcuts/Shortcut.vala"
	_tmp3_ = gtk_accelerator_name (_tmp1_, _tmp2_);
#line 50 "../src/Shortcuts/Shortcut.vala"
	result = _tmp3_;
#line 50 "../src/Shortcuts/Shortcut.vala"
	return result;
#line 164 "Shortcut.c"
}

gchar*
keyboard_shortcuts_shortcut_to_readable (KeyboardShortcutsShortcut* self)
{
	gchar* tmp = NULL;
	gchar* _tmp1_;
	GdkModifierType _tmp2_;
	GdkModifierType _tmp7_;
	GdkModifierType _tmp10_;
	GdkModifierType _tmp15_;
	GdkModifierType _tmp20_;
	GdkModifierType _tmp23_;
	GdkModifierType _tmp26_;
	guint _tmp29_;
	gchar* result;
#line 53 "../src/Shortcuts/Shortcut.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/Shortcuts/Shortcut.vala"
	if (!keyboard_shortcuts_shortcut_valid (self)) {
#line 185 "Shortcut.c"
		gchar* _tmp0_;
#line 55 "../src/Shortcuts/Shortcut.vala"
		_tmp0_ = g_strdup (_ ("Disabled"));
#line 55 "../src/Shortcuts/Shortcut.vala"
		result = _tmp0_;
#line 55 "../src/Shortcuts/Shortcut.vala"
		return result;
#line 193 "Shortcut.c"
	}
#line 58 "../src/Shortcuts/Shortcut.vala"
	_tmp1_ = g_strdup ("");
#line 58 "../src/Shortcuts/Shortcut.vala"
	tmp = _tmp1_;
#line 60 "../src/Shortcuts/Shortcut.vala"
	_tmp2_ = self->priv->_modifiers;
#line 60 "../src/Shortcuts/Shortcut.vala"
	if ((_tmp2_ & GDK_SHIFT_MASK) > 0) {
#line 203 "Shortcut.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 61 "../src/Shortcuts/Shortcut.vala"
		_tmp3_ = tmp;
#line 61 "../src/Shortcuts/Shortcut.vala"
		_tmp4_ = g_strconcat (_ ("Shift"), KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR, NULL);
#line 61 "../src/Shortcuts/Shortcut.vala"
		_tmp5_ = _tmp4_;
#line 61 "../src/Shortcuts/Shortcut.vala"
		_tmp6_ = g_strconcat (_tmp3_, _tmp5_, NULL);
#line 61 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (tmp);
#line 61 "../src/Shortcuts/Shortcut.vala"
		tmp = _tmp6_;
#line 61 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (_tmp5_);
#line 222 "Shortcut.c"
	}
#line 64 "../src/Shortcuts/Shortcut.vala"
	_tmp7_ = self->priv->_modifiers;
#line 64 "../src/Shortcuts/Shortcut.vala"
	if ((_tmp7_ & GDK_SUPER_MASK) > 0) {
#line 228 "Shortcut.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 65 "../src/Shortcuts/Shortcut.vala"
		_tmp8_ = tmp;
#line 65 "../src/Shortcuts/Shortcut.vala"
		_tmp9_ = g_strconcat (_tmp8_, "⌘" KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR, NULL);
#line 65 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (tmp);
#line 65 "../src/Shortcuts/Shortcut.vala"
		tmp = _tmp9_;
#line 239 "Shortcut.c"
	}
#line 68 "../src/Shortcuts/Shortcut.vala"
	_tmp10_ = self->priv->_modifiers;
#line 68 "../src/Shortcuts/Shortcut.vala"
	if ((_tmp10_ & GDK_CONTROL_MASK) > 0) {
#line 245 "Shortcut.c"
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 69 "../src/Shortcuts/Shortcut.vala"
		_tmp11_ = tmp;
#line 69 "../src/Shortcuts/Shortcut.vala"
		_tmp12_ = g_strconcat (_ ("Ctrl"), KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR, NULL);
#line 69 "../src/Shortcuts/Shortcut.vala"
		_tmp13_ = _tmp12_;
#line 69 "../src/Shortcuts/Shortcut.vala"
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 69 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (tmp);
#line 69 "../src/Shortcuts/Shortcut.vala"
		tmp = _tmp14_;
#line 69 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (_tmp13_);
#line 264 "Shortcut.c"
	}
#line 72 "../src/Shortcuts/Shortcut.vala"
	_tmp15_ = self->priv->_modifiers;
#line 72 "../src/Shortcuts/Shortcut.vala"
	if ((_tmp15_ & GDK_MOD1_MASK) > 0) {
#line 270 "Shortcut.c"
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 73 "../src/Shortcuts/Shortcut.vala"
		_tmp16_ = tmp;
#line 73 "../src/Shortcuts/Shortcut.vala"
		_tmp17_ = g_strconcat (_ ("Alt"), KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR, NULL);
#line 73 "../src/Shortcuts/Shortcut.vala"
		_tmp18_ = _tmp17_;
#line 73 "../src/Shortcuts/Shortcut.vala"
		_tmp19_ = g_strconcat (_tmp16_, _tmp18_, NULL);
#line 73 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (tmp);
#line 73 "../src/Shortcuts/Shortcut.vala"
		tmp = _tmp19_;
#line 73 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (_tmp18_);
#line 289 "Shortcut.c"
	}
#line 76 "../src/Shortcuts/Shortcut.vala"
	_tmp20_ = self->priv->_modifiers;
#line 76 "../src/Shortcuts/Shortcut.vala"
	if ((_tmp20_ & GDK_MOD2_MASK) > 0) {
#line 295 "Shortcut.c"
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 77 "../src/Shortcuts/Shortcut.vala"
		_tmp21_ = tmp;
#line 77 "../src/Shortcuts/Shortcut.vala"
		_tmp22_ = g_strconcat (_tmp21_, "Mod2" KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR, NULL);
#line 77 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (tmp);
#line 77 "../src/Shortcuts/Shortcut.vala"
		tmp = _tmp22_;
#line 306 "Shortcut.c"
	}
#line 80 "../src/Shortcuts/Shortcut.vala"
	_tmp23_ = self->priv->_modifiers;
#line 80 "../src/Shortcuts/Shortcut.vala"
	if ((_tmp23_ & GDK_MOD3_MASK) > 0) {
#line 312 "Shortcut.c"
		const gchar* _tmp24_;
		gchar* _tmp25_;
#line 81 "../src/Shortcuts/Shortcut.vala"
		_tmp24_ = tmp;
#line 81 "../src/Shortcuts/Shortcut.vala"
		_tmp25_ = g_strconcat (_tmp24_, "Mod3" KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR, NULL);
#line 81 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (tmp);
#line 81 "../src/Shortcuts/Shortcut.vala"
		tmp = _tmp25_;
#line 323 "Shortcut.c"
	}
#line 84 "../src/Shortcuts/Shortcut.vala"
	_tmp26_ = self->priv->_modifiers;
#line 84 "../src/Shortcuts/Shortcut.vala"
	if ((_tmp26_ & GDK_MOD4_MASK) > 0) {
#line 329 "Shortcut.c"
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 85 "../src/Shortcuts/Shortcut.vala"
		_tmp27_ = tmp;
#line 85 "../src/Shortcuts/Shortcut.vala"
		_tmp28_ = g_strconcat (_tmp27_, "Mod4" KEYBOARD_SHORTCUTS_SHORTCUT_SEPARATOR, NULL);
#line 85 "../src/Shortcuts/Shortcut.vala"
		_g_free0 (tmp);
#line 85 "../src/Shortcuts/Shortcut.vala"
		tmp = _tmp28_;
#line 340 "Shortcut.c"
	}
#line 88 "../src/Shortcuts/Shortcut.vala"
	_tmp29_ = self->priv->_accel_key;
#line 88 "../src/Shortcuts/Shortcut.vala"
	switch (_tmp29_) {
#line 88 "../src/Shortcuts/Shortcut.vala"
		case GDK_KEY_Up:
#line 348 "Shortcut.c"
		{
			const gchar* _tmp30_;
			gchar* _tmp31_;
#line 90 "../src/Shortcuts/Shortcut.vala"
			_tmp30_ = tmp;
#line 90 "../src/Shortcuts/Shortcut.vala"
			_tmp31_ = g_strconcat (_tmp30_, "↑", NULL);
#line 90 "../src/Shortcuts/Shortcut.vala"
			_g_free0 (tmp);
#line 90 "../src/Shortcuts/Shortcut.vala"
			tmp = _tmp31_;
#line 91 "../src/Shortcuts/Shortcut.vala"
			break;
#line 362 "Shortcut.c"
		}
#line 88 "../src/Shortcuts/Shortcut.vala"
		case GDK_KEY_Down:
#line 366 "Shortcut.c"
		{
			const gchar* _tmp32_;
			gchar* _tmp33_;
#line 93 "../src/Shortcuts/Shortcut.vala"
			_tmp32_ = tmp;
#line 93 "../src/Shortcuts/Shortcut.vala"
			_tmp33_ = g_strconcat (_tmp32_, "↓", NULL);
#line 93 "../src/Shortcuts/Shortcut.vala"
			_g_free0 (tmp);
#line 93 "../src/Shortcuts/Shortcut.vala"
			tmp = _tmp33_;
#line 94 "../src/Shortcuts/Shortcut.vala"
			break;
#line 380 "Shortcut.c"
		}
#line 88 "../src/Shortcuts/Shortcut.vala"
		case GDK_KEY_Left:
#line 384 "Shortcut.c"
		{
			const gchar* _tmp34_;
			gchar* _tmp35_;
#line 96 "../src/Shortcuts/Shortcut.vala"
			_tmp34_ = tmp;
#line 96 "../src/Shortcuts/Shortcut.vala"
			_tmp35_ = g_strconcat (_tmp34_, "←", NULL);
#line 96 "../src/Shortcuts/Shortcut.vala"
			_g_free0 (tmp);
#line 96 "../src/Shortcuts/Shortcut.vala"
			tmp = _tmp35_;
#line 97 "../src/Shortcuts/Shortcut.vala"
			break;
#line 398 "Shortcut.c"
		}
#line 88 "../src/Shortcuts/Shortcut.vala"
		case GDK_KEY_Right:
#line 402 "Shortcut.c"
		{
			const gchar* _tmp36_;
			gchar* _tmp37_;
#line 99 "../src/Shortcuts/Shortcut.vala"
			_tmp36_ = tmp;
#line 99 "../src/Shortcuts/Shortcut.vala"
			_tmp37_ = g_strconcat (_tmp36_, "→", NULL);
#line 99 "../src/Shortcuts/Shortcut.vala"
			_g_free0 (tmp);
#line 99 "../src/Shortcuts/Shortcut.vala"
			tmp = _tmp37_;
#line 100 "../src/Shortcuts/Shortcut.vala"
			break;
#line 416 "Shortcut.c"
		}
		default:
		{
			const gchar* _tmp38_;
			guint _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 102 "../src/Shortcuts/Shortcut.vala"
			_tmp38_ = tmp;
#line 102 "../src/Shortcuts/Shortcut.vala"
			_tmp39_ = self->priv->_accel_key;
#line 102 "../src/Shortcuts/Shortcut.vala"
			_tmp40_ = gtk_accelerator_get_label (_tmp39_, 0);
#line 102 "../src/Shortcuts/Shortcut.vala"
			_tmp41_ = _tmp40_;
#line 102 "../src/Shortcuts/Shortcut.vala"
			_tmp42_ = g_strconcat (_tmp38_, _tmp41_, NULL);
#line 102 "../src/Shortcuts/Shortcut.vala"
			_g_free0 (tmp);
#line 102 "../src/Shortcuts/Shortcut.vala"
			tmp = _tmp42_;
#line 102 "../src/Shortcuts/Shortcut.vala"
			_g_free0 (_tmp41_);
#line 103 "../src/Shortcuts/Shortcut.vala"
			break;
#line 443 "Shortcut.c"
		}
	}
#line 106 "../src/Shortcuts/Shortcut.vala"
	result = tmp;
#line 106 "../src/Shortcuts/Shortcut.vala"
	return result;
#line 450 "Shortcut.c"
}

gboolean
keyboard_shortcuts_shortcut_is_equal (KeyboardShortcutsShortcut* self,
                                      KeyboardShortcutsShortcut* shortcut)
{
	gboolean _tmp0_ = FALSE;
	GdkModifierType _tmp1_;
	GdkModifierType _tmp2_;
	gboolean result;
#line 109 "../src/Shortcuts/Shortcut.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "../src/Shortcuts/Shortcut.vala"
	g_return_val_if_fail (shortcut != NULL, FALSE);
#line 110 "../src/Shortcuts/Shortcut.vala"
	_tmp1_ = shortcut->priv->_modifiers;
#line 110 "../src/Shortcuts/Shortcut.vala"
	_tmp2_ = self->priv->_modifiers;
#line 110 "../src/Shortcuts/Shortcut.vala"
	if (_tmp1_ == _tmp2_) {
#line 471 "Shortcut.c"
		guint _tmp3_;
		guint _tmp4_;
#line 110 "../src/Shortcuts/Shortcut.vala"
		_tmp3_ = shortcut->priv->_accel_key;
#line 110 "../src/Shortcuts/Shortcut.vala"
		_tmp4_ = self->priv->_accel_key;
#line 110 "../src/Shortcuts/Shortcut.vala"
		_tmp0_ = _tmp3_ == _tmp4_;
#line 480 "Shortcut.c"
	} else {
#line 110 "../src/Shortcuts/Shortcut.vala"
		_tmp0_ = FALSE;
#line 484 "Shortcut.c"
	}
#line 110 "../src/Shortcuts/Shortcut.vala"
	if (_tmp0_) {
#line 111 "../src/Shortcuts/Shortcut.vala"
		result = TRUE;
#line 111 "../src/Shortcuts/Shortcut.vala"
		return result;
#line 492 "Shortcut.c"
	}
#line 114 "../src/Shortcuts/Shortcut.vala"
	result = FALSE;
#line 114 "../src/Shortcuts/Shortcut.vala"
	return result;
#line 498 "Shortcut.c"
}

static gboolean
keyboard_shortcuts_shortcut_valid (KeyboardShortcutsShortcut* self)
{
	guint _tmp0_;
	gboolean _tmp1_ = FALSE;
	GdkModifierType _tmp2_;
	GdkModifierType _tmp61_;
	gboolean result;
#line 118 "../src/Shortcuts/Shortcut.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 119 "../src/Shortcuts/Shortcut.vala"
	_tmp0_ = self->priv->_accel_key;
#line 119 "../src/Shortcuts/Shortcut.vala"
	if (_tmp0_ == ((guint) 0)) {
#line 120 "../src/Shortcuts/Shortcut.vala"
		result = FALSE;
#line 120 "../src/Shortcuts/Shortcut.vala"
		return result;
#line 519 "Shortcut.c"
	}
#line 123 "../src/Shortcuts/Shortcut.vala"
	_tmp2_ = self->priv->_modifiers;
#line 123 "../src/Shortcuts/Shortcut.vala"
	if (_tmp2_ == ((GdkModifierType) 0)) {
#line 123 "../src/Shortcuts/Shortcut.vala"
		_tmp1_ = TRUE;
#line 527 "Shortcut.c"
	} else {
		GdkModifierType _tmp3_;
#line 123 "../src/Shortcuts/Shortcut.vala"
		_tmp3_ = self->priv->_modifiers;
#line 123 "../src/Shortcuts/Shortcut.vala"
		_tmp1_ = _tmp3_ == GDK_SHIFT_MASK;
#line 534 "Shortcut.c"
	}
#line 123 "../src/Shortcuts/Shortcut.vala"
	if (_tmp1_) {
#line 538 "Shortcut.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		guint _tmp22_;
#line 124 "../src/Shortcuts/Shortcut.vala"
		_tmp22_ = self->priv->_accel_key;
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp22_ >= GDK_KEY_a) {
#line 562 "Shortcut.c"
			guint _tmp23_;
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp23_ = self->priv->_accel_key;
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp21_ = _tmp23_ <= GDK_KEY_z;
#line 568 "Shortcut.c"
		} else {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp21_ = FALSE;
#line 572 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp21_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp20_ = TRUE;
#line 578 "Shortcut.c"
		} else {
			gboolean _tmp24_ = FALSE;
			guint _tmp25_;
#line 125 "../src/Shortcuts/Shortcut.vala"
			_tmp25_ = self->priv->_accel_key;
#line 125 "../src/Shortcuts/Shortcut.vala"
			if (_tmp25_ >= GDK_KEY_A) {
#line 586 "Shortcut.c"
				guint _tmp26_;
#line 125 "../src/Shortcuts/Shortcut.vala"
				_tmp26_ = self->priv->_accel_key;
#line 125 "../src/Shortcuts/Shortcut.vala"
				_tmp24_ = _tmp26_ <= GDK_KEY_Z;
#line 592 "Shortcut.c"
			} else {
#line 125 "../src/Shortcuts/Shortcut.vala"
				_tmp24_ = FALSE;
#line 596 "Shortcut.c"
			}
#line 125 "../src/Shortcuts/Shortcut.vala"
			_tmp20_ = _tmp24_;
#line 600 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp20_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp19_ = TRUE;
#line 606 "Shortcut.c"
		} else {
			gboolean _tmp27_ = FALSE;
			guint _tmp28_;
#line 126 "../src/Shortcuts/Shortcut.vala"
			_tmp28_ = self->priv->_accel_key;
#line 126 "../src/Shortcuts/Shortcut.vala"
			if (_tmp28_ >= GDK_KEY_0) {
#line 614 "Shortcut.c"
				guint _tmp29_;
#line 126 "../src/Shortcuts/Shortcut.vala"
				_tmp29_ = self->priv->_accel_key;
#line 126 "../src/Shortcuts/Shortcut.vala"
				_tmp27_ = _tmp29_ <= GDK_KEY_9;
#line 620 "Shortcut.c"
			} else {
#line 126 "../src/Shortcuts/Shortcut.vala"
				_tmp27_ = FALSE;
#line 624 "Shortcut.c"
			}
#line 126 "../src/Shortcuts/Shortcut.vala"
			_tmp19_ = _tmp27_;
#line 628 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp19_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp18_ = TRUE;
#line 634 "Shortcut.c"
		} else {
			gboolean _tmp30_ = FALSE;
			guint _tmp31_;
#line 127 "../src/Shortcuts/Shortcut.vala"
			_tmp31_ = self->priv->_accel_key;
#line 127 "../src/Shortcuts/Shortcut.vala"
			if (_tmp31_ >= GDK_KEY_kana_fullstop) {
#line 642 "Shortcut.c"
				guint _tmp32_;
#line 127 "../src/Shortcuts/Shortcut.vala"
				_tmp32_ = self->priv->_accel_key;
#line 127 "../src/Shortcuts/Shortcut.vala"
				_tmp30_ = _tmp32_ <= GDK_KEY_semivoicedsound;
#line 648 "Shortcut.c"
			} else {
#line 127 "../src/Shortcuts/Shortcut.vala"
				_tmp30_ = FALSE;
#line 652 "Shortcut.c"
			}
#line 127 "../src/Shortcuts/Shortcut.vala"
			_tmp18_ = _tmp30_;
#line 656 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp18_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp17_ = TRUE;
#line 662 "Shortcut.c"
		} else {
			gboolean _tmp33_ = FALSE;
			guint _tmp34_;
#line 128 "../src/Shortcuts/Shortcut.vala"
			_tmp34_ = self->priv->_accel_key;
#line 128 "../src/Shortcuts/Shortcut.vala"
			if (_tmp34_ >= GDK_KEY_Arabic_comma) {
#line 670 "Shortcut.c"
				guint _tmp35_;
#line 128 "../src/Shortcuts/Shortcut.vala"
				_tmp35_ = self->priv->_accel_key;
#line 128 "../src/Shortcuts/Shortcut.vala"
				_tmp33_ = _tmp35_ <= GDK_KEY_Arabic_sukun;
#line 676 "Shortcut.c"
			} else {
#line 128 "../src/Shortcuts/Shortcut.vala"
				_tmp33_ = FALSE;
#line 680 "Shortcut.c"
			}
#line 128 "../src/Shortcuts/Shortcut.vala"
			_tmp17_ = _tmp33_;
#line 684 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp17_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp16_ = TRUE;
#line 690 "Shortcut.c"
		} else {
			gboolean _tmp36_ = FALSE;
			guint _tmp37_;
#line 129 "../src/Shortcuts/Shortcut.vala"
			_tmp37_ = self->priv->_accel_key;
#line 129 "../src/Shortcuts/Shortcut.vala"
			if (_tmp37_ >= GDK_KEY_Serbian_dje) {
#line 698 "Shortcut.c"
				guint _tmp38_;
#line 129 "../src/Shortcuts/Shortcut.vala"
				_tmp38_ = self->priv->_accel_key;
#line 129 "../src/Shortcuts/Shortcut.vala"
				_tmp36_ = _tmp38_ <= GDK_KEY_Cyrillic_HARDSIGN;
#line 704 "Shortcut.c"
			} else {
#line 129 "../src/Shortcuts/Shortcut.vala"
				_tmp36_ = FALSE;
#line 708 "Shortcut.c"
			}
#line 129 "../src/Shortcuts/Shortcut.vala"
			_tmp16_ = _tmp36_;
#line 712 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp16_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp15_ = TRUE;
#line 718 "Shortcut.c"
		} else {
			gboolean _tmp39_ = FALSE;
			guint _tmp40_;
#line 130 "../src/Shortcuts/Shortcut.vala"
			_tmp40_ = self->priv->_accel_key;
#line 130 "../src/Shortcuts/Shortcut.vala"
			if (_tmp40_ >= GDK_KEY_Greek_ALPHAaccent) {
#line 726 "Shortcut.c"
				guint _tmp41_;
#line 130 "../src/Shortcuts/Shortcut.vala"
				_tmp41_ = self->priv->_accel_key;
#line 130 "../src/Shortcuts/Shortcut.vala"
				_tmp39_ = _tmp41_ <= GDK_KEY_Greek_omega;
#line 732 "Shortcut.c"
			} else {
#line 130 "../src/Shortcuts/Shortcut.vala"
				_tmp39_ = FALSE;
#line 736 "Shortcut.c"
			}
#line 130 "../src/Shortcuts/Shortcut.vala"
			_tmp15_ = _tmp39_;
#line 740 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp15_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp14_ = TRUE;
#line 746 "Shortcut.c"
		} else {
			gboolean _tmp42_ = FALSE;
			guint _tmp43_;
#line 131 "../src/Shortcuts/Shortcut.vala"
			_tmp43_ = self->priv->_accel_key;
#line 131 "../src/Shortcuts/Shortcut.vala"
			if (_tmp43_ >= GDK_KEY_hebrew_doublelowline) {
#line 754 "Shortcut.c"
				guint _tmp44_;
#line 131 "../src/Shortcuts/Shortcut.vala"
				_tmp44_ = self->priv->_accel_key;
#line 131 "../src/Shortcuts/Shortcut.vala"
				_tmp42_ = _tmp44_ <= GDK_KEY_hebrew_taf;
#line 760 "Shortcut.c"
			} else {
#line 131 "../src/Shortcuts/Shortcut.vala"
				_tmp42_ = FALSE;
#line 764 "Shortcut.c"
			}
#line 131 "../src/Shortcuts/Shortcut.vala"
			_tmp14_ = _tmp42_;
#line 768 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp14_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp13_ = TRUE;
#line 774 "Shortcut.c"
		} else {
			gboolean _tmp45_ = FALSE;
			guint _tmp46_;
#line 132 "../src/Shortcuts/Shortcut.vala"
			_tmp46_ = self->priv->_accel_key;
#line 132 "../src/Shortcuts/Shortcut.vala"
			if (_tmp46_ >= GDK_KEY_Thai_kokai) {
#line 782 "Shortcut.c"
				guint _tmp47_;
#line 132 "../src/Shortcuts/Shortcut.vala"
				_tmp47_ = self->priv->_accel_key;
#line 132 "../src/Shortcuts/Shortcut.vala"
				_tmp45_ = _tmp47_ <= GDK_KEY_Thai_lekkao;
#line 788 "Shortcut.c"
			} else {
#line 132 "../src/Shortcuts/Shortcut.vala"
				_tmp45_ = FALSE;
#line 792 "Shortcut.c"
			}
#line 132 "../src/Shortcuts/Shortcut.vala"
			_tmp13_ = _tmp45_;
#line 796 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp13_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp12_ = TRUE;
#line 802 "Shortcut.c"
		} else {
			gboolean _tmp48_ = FALSE;
			guint _tmp49_;
#line 133 "../src/Shortcuts/Shortcut.vala"
			_tmp49_ = self->priv->_accel_key;
#line 133 "../src/Shortcuts/Shortcut.vala"
			if (_tmp49_ >= GDK_KEY_Hangul) {
#line 810 "Shortcut.c"
				guint _tmp50_;
#line 133 "../src/Shortcuts/Shortcut.vala"
				_tmp50_ = self->priv->_accel_key;
#line 133 "../src/Shortcuts/Shortcut.vala"
				_tmp48_ = _tmp50_ <= GDK_KEY_Hangul_Special;
#line 816 "Shortcut.c"
			} else {
#line 133 "../src/Shortcuts/Shortcut.vala"
				_tmp48_ = FALSE;
#line 820 "Shortcut.c"
			}
#line 133 "../src/Shortcuts/Shortcut.vala"
			_tmp12_ = _tmp48_;
#line 824 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp12_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp11_ = TRUE;
#line 830 "Shortcut.c"
		} else {
			gboolean _tmp51_ = FALSE;
			guint _tmp52_;
#line 134 "../src/Shortcuts/Shortcut.vala"
			_tmp52_ = self->priv->_accel_key;
#line 134 "../src/Shortcuts/Shortcut.vala"
			if (_tmp52_ >= GDK_KEY_Hangul_Kiyeog) {
#line 838 "Shortcut.c"
				guint _tmp53_;
#line 134 "../src/Shortcuts/Shortcut.vala"
				_tmp53_ = self->priv->_accel_key;
#line 134 "../src/Shortcuts/Shortcut.vala"
				_tmp51_ = _tmp53_ <= GDK_KEY_Hangul_J_YeorinHieuh;
#line 844 "Shortcut.c"
			} else {
#line 134 "../src/Shortcuts/Shortcut.vala"
				_tmp51_ = FALSE;
#line 848 "Shortcut.c"
			}
#line 134 "../src/Shortcuts/Shortcut.vala"
			_tmp11_ = _tmp51_;
#line 852 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp11_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp10_ = TRUE;
#line 858 "Shortcut.c"
		} else {
			guint _tmp54_;
#line 135 "../src/Shortcuts/Shortcut.vala"
			_tmp54_ = self->priv->_accel_key;
#line 135 "../src/Shortcuts/Shortcut.vala"
			_tmp10_ = _tmp54_ == GDK_KEY_Left;
#line 865 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp10_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp9_ = TRUE;
#line 871 "Shortcut.c"
		} else {
			guint _tmp55_;
#line 136 "../src/Shortcuts/Shortcut.vala"
			_tmp55_ = self->priv->_accel_key;
#line 136 "../src/Shortcuts/Shortcut.vala"
			_tmp9_ = _tmp55_ == GDK_KEY_Up;
#line 878 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp9_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp8_ = TRUE;
#line 884 "Shortcut.c"
		} else {
			guint _tmp56_;
#line 137 "../src/Shortcuts/Shortcut.vala"
			_tmp56_ = self->priv->_accel_key;
#line 137 "../src/Shortcuts/Shortcut.vala"
			_tmp8_ = _tmp56_ == GDK_KEY_Right;
#line 891 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp8_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp7_ = TRUE;
#line 897 "Shortcut.c"
		} else {
			guint _tmp57_;
#line 138 "../src/Shortcuts/Shortcut.vala"
			_tmp57_ = self->priv->_accel_key;
#line 138 "../src/Shortcuts/Shortcut.vala"
			_tmp7_ = _tmp57_ == GDK_KEY_Down;
#line 904 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp7_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp6_ = TRUE;
#line 910 "Shortcut.c"
		} else {
			guint _tmp58_;
#line 139 "../src/Shortcuts/Shortcut.vala"
			_tmp58_ = self->priv->_accel_key;
#line 139 "../src/Shortcuts/Shortcut.vala"
			_tmp6_ = _tmp58_ == GDK_KEY_Tab;
#line 917 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp6_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp5_ = TRUE;
#line 923 "Shortcut.c"
		} else {
			guint _tmp59_;
#line 140 "../src/Shortcuts/Shortcut.vala"
			_tmp59_ = self->priv->_accel_key;
#line 140 "../src/Shortcuts/Shortcut.vala"
			_tmp5_ = _tmp59_ == GDK_KEY_KP_Enter;
#line 930 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp5_) {
#line 124 "../src/Shortcuts/Shortcut.vala"
			_tmp4_ = TRUE;
#line 936 "Shortcut.c"
		} else {
			guint _tmp60_;
#line 141 "../src/Shortcuts/Shortcut.vala"
			_tmp60_ = self->priv->_accel_key;
#line 141 "../src/Shortcuts/Shortcut.vala"
			_tmp4_ = _tmp60_ == GDK_KEY_Return;
#line 943 "Shortcut.c"
		}
#line 124 "../src/Shortcuts/Shortcut.vala"
		if (_tmp4_) {
#line 142 "../src/Shortcuts/Shortcut.vala"
			result = FALSE;
#line 142 "../src/Shortcuts/Shortcut.vala"
			return result;
#line 951 "Shortcut.c"
		}
	}
#line 146 "../src/Shortcuts/Shortcut.vala"
	_tmp61_ = self->priv->_modifiers;
#line 146 "../src/Shortcuts/Shortcut.vala"
	if (_tmp61_ == ((GdkModifierType) 0)) {
#line 958 "Shortcut.c"
		gboolean _tmp62_ = FALSE;
		gboolean _tmp63_ = FALSE;
		gboolean _tmp64_ = FALSE;
		gboolean _tmp65_ = FALSE;
		gboolean _tmp66_ = FALSE;
		gboolean _tmp67_ = FALSE;
		gboolean _tmp68_ = FALSE;
		gboolean _tmp69_ = FALSE;
		gboolean _tmp70_ = FALSE;
		guint _tmp71_;
#line 147 "../src/Shortcuts/Shortcut.vala"
		_tmp71_ = self->priv->_accel_key;
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp71_ == GDK_KEY_backslash) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp70_ = TRUE;
#line 975 "Shortcut.c"
		} else {
			guint _tmp72_;
#line 148 "../src/Shortcuts/Shortcut.vala"
			_tmp72_ = self->priv->_accel_key;
#line 148 "../src/Shortcuts/Shortcut.vala"
			_tmp70_ = _tmp72_ == GDK_KEY_bracketright;
#line 982 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp70_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp69_ = TRUE;
#line 988 "Shortcut.c"
		} else {
			guint _tmp73_;
#line 149 "../src/Shortcuts/Shortcut.vala"
			_tmp73_ = self->priv->_accel_key;
#line 149 "../src/Shortcuts/Shortcut.vala"
			_tmp69_ = _tmp73_ == GDK_KEY_bracketleft;
#line 995 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp69_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp68_ = TRUE;
#line 1001 "Shortcut.c"
		} else {
			guint _tmp74_;
#line 150 "../src/Shortcuts/Shortcut.vala"
			_tmp74_ = self->priv->_accel_key;
#line 150 "../src/Shortcuts/Shortcut.vala"
			_tmp68_ = _tmp74_ == GDK_KEY_apostrophe;
#line 1008 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp68_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp67_ = TRUE;
#line 1014 "Shortcut.c"
		} else {
			guint _tmp75_;
#line 151 "../src/Shortcuts/Shortcut.vala"
			_tmp75_ = self->priv->_accel_key;
#line 151 "../src/Shortcuts/Shortcut.vala"
			_tmp67_ = _tmp75_ == GDK_KEY_semicolon;
#line 1021 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp67_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp66_ = TRUE;
#line 1027 "Shortcut.c"
		} else {
			guint _tmp76_;
#line 152 "../src/Shortcuts/Shortcut.vala"
			_tmp76_ = self->priv->_accel_key;
#line 152 "../src/Shortcuts/Shortcut.vala"
			_tmp66_ = _tmp76_ == GDK_KEY_slash;
#line 1034 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp66_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp65_ = TRUE;
#line 1040 "Shortcut.c"
		} else {
			guint _tmp77_;
#line 153 "../src/Shortcuts/Shortcut.vala"
			_tmp77_ = self->priv->_accel_key;
#line 153 "../src/Shortcuts/Shortcut.vala"
			_tmp65_ = _tmp77_ == GDK_KEY_period;
#line 1047 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp65_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp64_ = TRUE;
#line 1053 "Shortcut.c"
		} else {
			guint _tmp78_;
#line 154 "../src/Shortcuts/Shortcut.vala"
			_tmp78_ = self->priv->_accel_key;
#line 154 "../src/Shortcuts/Shortcut.vala"
			_tmp64_ = _tmp78_ == GDK_KEY_comma;
#line 1060 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp64_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp63_ = TRUE;
#line 1066 "Shortcut.c"
		} else {
			guint _tmp79_;
#line 155 "../src/Shortcuts/Shortcut.vala"
			_tmp79_ = self->priv->_accel_key;
#line 155 "../src/Shortcuts/Shortcut.vala"
			_tmp63_ = _tmp79_ == GDK_KEY_space;
#line 1073 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp63_) {
#line 147 "../src/Shortcuts/Shortcut.vala"
			_tmp62_ = TRUE;
#line 1079 "Shortcut.c"
		} else {
			guint _tmp80_;
#line 156 "../src/Shortcuts/Shortcut.vala"
			_tmp80_ = self->priv->_accel_key;
#line 156 "../src/Shortcuts/Shortcut.vala"
			_tmp62_ = _tmp80_ == GDK_KEY_grave;
#line 1086 "Shortcut.c"
		}
#line 147 "../src/Shortcuts/Shortcut.vala"
		if (_tmp62_) {
#line 157 "../src/Shortcuts/Shortcut.vala"
			result = FALSE;
#line 157 "../src/Shortcuts/Shortcut.vala"
			return result;
#line 1094 "Shortcut.c"
		}
	}
#line 161 "../src/Shortcuts/Shortcut.vala"
	result = TRUE;
#line 161 "../src/Shortcuts/Shortcut.vala"
	return result;
#line 1101 "Shortcut.c"
}

GdkModifierType
keyboard_shortcuts_shortcut_get_modifiers (KeyboardShortcutsShortcut* self)
{
	GdkModifierType result;
#line 23 "../src/Shortcuts/Shortcut.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 23 "../src/Shortcuts/Shortcut.vala"
	result = self->priv->_modifiers;
#line 23 "../src/Shortcuts/Shortcut.vala"
	return result;
#line 1114 "Shortcut.c"
}

static void
keyboard_shortcuts_shortcut_set_modifiers (KeyboardShortcutsShortcut* self,
                                           GdkModifierType value)
{
	GdkModifierType old_value;
#line 23 "../src/Shortcuts/Shortcut.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Shortcuts/Shortcut.vala"
	old_value = keyboard_shortcuts_shortcut_get_modifiers (self);
#line 23 "../src/Shortcuts/Shortcut.vala"
	if (old_value != value) {
#line 23 "../src/Shortcuts/Shortcut.vala"
		self->priv->_modifiers = value;
#line 23 "../src/Shortcuts/Shortcut.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_shortcuts_shortcut_properties[KEYBOARD_SHORTCUTS_SHORTCUT_MODIFIERS_PROPERTY]);
#line 1132 "Shortcut.c"
	}
}

guint
keyboard_shortcuts_shortcut_get_accel_key (KeyboardShortcutsShortcut* self)
{
	guint result;
#line 24 "../src/Shortcuts/Shortcut.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 24 "../src/Shortcuts/Shortcut.vala"
	result = self->priv->_accel_key;
#line 24 "../src/Shortcuts/Shortcut.vala"
	return result;
#line 1146 "Shortcut.c"
}

static void
keyboard_shortcuts_shortcut_set_accel_key (KeyboardShortcutsShortcut* self,
                                           guint value)
{
	guint old_value;
#line 24 "../src/Shortcuts/Shortcut.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Shortcuts/Shortcut.vala"
	old_value = keyboard_shortcuts_shortcut_get_accel_key (self);
#line 24 "../src/Shortcuts/Shortcut.vala"
	if (old_value != value) {
#line 24 "../src/Shortcuts/Shortcut.vala"
		self->priv->_accel_key = value;
#line 24 "../src/Shortcuts/Shortcut.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_shortcuts_shortcut_properties[KEYBOARD_SHORTCUTS_SHORTCUT_ACCEL_KEY_PROPERTY]);
#line 1164 "Shortcut.c"
	}
}

static void
keyboard_shortcuts_shortcut_class_init (KeyboardShortcutsShortcutClass * klass,
                                        gpointer klass_data)
{
#line 22 "../src/Shortcuts/Shortcut.vala"
	keyboard_shortcuts_shortcut_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Shortcuts/Shortcut.vala"
	g_type_class_adjust_private_offset (klass, &KeyboardShortcutsShortcut_private_offset);
#line 22 "../src/Shortcuts/Shortcut.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_keyboard_shortcuts_shortcut_get_property;
#line 22 "../src/Shortcuts/Shortcut.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_keyboard_shortcuts_shortcut_set_property;
#line 22 "../src/Shortcuts/Shortcut.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_shortcuts_shortcut_finalize;
#line 22 "../src/Shortcuts/Shortcut.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_SHORTCUTS_SHORTCUT_MODIFIERS_PROPERTY, keyboard_shortcuts_shortcut_properties[KEYBOARD_SHORTCUTS_SHORTCUT_MODIFIERS_PROPERTY] = g_param_spec_flags ("modifiers", "modifiers", "modifiers", gdk_modifier_type_get_type (), 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Shortcuts/Shortcut.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_SHORTCUTS_SHORTCUT_ACCEL_KEY_PROPERTY, keyboard_shortcuts_shortcut_properties[KEYBOARD_SHORTCUTS_SHORTCUT_ACCEL_KEY_PROPERTY] = g_param_spec_uint ("accel-key", "accel-key", "accel-key", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1186 "Shortcut.c"
}

static void
keyboard_shortcuts_shortcut_instance_init (KeyboardShortcutsShortcut * self,
                                           gpointer klass)
{
#line 22 "../src/Shortcuts/Shortcut.vala"
	self->priv = keyboard_shortcuts_shortcut_get_instance_private (self);
#line 1195 "Shortcut.c"
}

static void
keyboard_shortcuts_shortcut_finalize (GObject * obj)
{
	KeyboardShortcutsShortcut * self;
#line 22 "../src/Shortcuts/Shortcut.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_SHORTCUTS_TYPE_SHORTCUT, KeyboardShortcutsShortcut);
#line 22 "../src/Shortcuts/Shortcut.vala"
	G_OBJECT_CLASS (keyboard_shortcuts_shortcut_parent_class)->finalize (obj);
#line 1206 "Shortcut.c"
}

static GType
keyboard_shortcuts_shortcut_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardShortcutsShortcutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_shortcuts_shortcut_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardShortcutsShortcut), 0, (GInstanceInitFunc) keyboard_shortcuts_shortcut_instance_init, NULL };
	GType keyboard_shortcuts_shortcut_type_id;
	keyboard_shortcuts_shortcut_type_id = g_type_register_static (G_TYPE_OBJECT, "KeyboardShortcutsShortcut", &g_define_type_info, 0);
	KeyboardShortcutsShortcut_private_offset = g_type_add_instance_private (keyboard_shortcuts_shortcut_type_id, sizeof (KeyboardShortcutsShortcutPrivate));
	return keyboard_shortcuts_shortcut_type_id;
}

GType
keyboard_shortcuts_shortcut_get_type (void)
{
	static volatile gsize keyboard_shortcuts_shortcut_type_id__once = 0;
	if (g_once_init_enter (&keyboard_shortcuts_shortcut_type_id__once)) {
		GType keyboard_shortcuts_shortcut_type_id;
		keyboard_shortcuts_shortcut_type_id = keyboard_shortcuts_shortcut_get_type_once ();
		g_once_init_leave (&keyboard_shortcuts_shortcut_type_id__once, keyboard_shortcuts_shortcut_type_id);
	}
	return keyboard_shortcuts_shortcut_type_id__once;
}

static void
_vala_keyboard_shortcuts_shortcut_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	KeyboardShortcutsShortcut * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_SHORTCUTS_TYPE_SHORTCUT, KeyboardShortcutsShortcut);
#line 22 "../src/Shortcuts/Shortcut.vala"
	switch (property_id) {
#line 22 "../src/Shortcuts/Shortcut.vala"
		case KEYBOARD_SHORTCUTS_SHORTCUT_MODIFIERS_PROPERTY:
#line 22 "../src/Shortcuts/Shortcut.vala"
		g_value_set_flags (value, keyboard_shortcuts_shortcut_get_modifiers (self));
#line 22 "../src/Shortcuts/Shortcut.vala"
		break;
#line 22 "../src/Shortcuts/Shortcut.vala"
		case KEYBOARD_SHORTCUTS_SHORTCUT_ACCEL_KEY_PROPERTY:
#line 22 "../src/Shortcuts/Shortcut.vala"
		g_value_set_uint (value, keyboard_shortcuts_shortcut_get_accel_key (self));
#line 22 "../src/Shortcuts/Shortcut.vala"
		break;
#line 1253 "Shortcut.c"
		default:
#line 22 "../src/Shortcuts/Shortcut.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Shortcuts/Shortcut.vala"
		break;
#line 1259 "Shortcut.c"
	}
}

static void
_vala_keyboard_shortcuts_shortcut_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	KeyboardShortcutsShortcut * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_SHORTCUTS_TYPE_SHORTCUT, KeyboardShortcutsShortcut);
#line 22 "../src/Shortcuts/Shortcut.vala"
	switch (property_id) {
#line 22 "../src/Shortcuts/Shortcut.vala"
		case KEYBOARD_SHORTCUTS_SHORTCUT_MODIFIERS_PROPERTY:
#line 22 "../src/Shortcuts/Shortcut.vala"
		keyboard_shortcuts_shortcut_set_modifiers (self, g_value_get_flags (value));
#line 22 "../src/Shortcuts/Shortcut.vala"
		break;
#line 22 "../src/Shortcuts/Shortcut.vala"
		case KEYBOARD_SHORTCUTS_SHORTCUT_ACCEL_KEY_PROPERTY:
#line 22 "../src/Shortcuts/Shortcut.vala"
		keyboard_shortcuts_shortcut_set_accel_key (self, g_value_get_uint (value));
#line 22 "../src/Shortcuts/Shortcut.vala"
		break;
#line 1285 "Shortcut.c"
		default:
#line 22 "../src/Shortcuts/Shortcut.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Shortcuts/Shortcut.vala"
		break;
#line 1291 "Shortcut.c"
	}
}

