/* InputMethod.c generated by valac 0.56.10, the Vala compiler
 * generated from InputMethod.vala, do not modify */

/*
* 2019-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "keyboard.h"
#include <ibus.h>
#include <gio/gio.h>
#include <glib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>

#define KEYBOARD_TYPE_SOURCE_SETTINGS (keyboard_source_settings_get_type ())
#define KEYBOARD_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings))
#define KEYBOARD_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))
#define KEYBOARD_IS_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_IS_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_SOURCE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))

typedef struct _KeyboardSourceSettings KeyboardSourceSettings;
typedef struct _KeyboardSourceSettingsClass KeyboardSourceSettingsClass;
enum  {
	KEYBOARD_INPUT_METHOD_PAGE_PAGE_0_PROPERTY,
	KEYBOARD_INPUT_METHOD_PAGE_PAGE_NUM_PROPERTIES
};
static GParamSpec* keyboard_input_method_page_page_properties[KEYBOARD_INPUT_METHOD_PAGE_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _Block14Data Block14Data;
typedef struct _Block15Data Block15Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KeyboardInputMethodPagePagePrivate {
	IBusBus* bus;
	GSettings* ibus_panel_settings;
	gboolean selection_changing;
	GList* engines;
	GraniteWidgetsAlertView* spawn_failed_alert;
	GtkListBox* listbox;
	KeyboardSourceSettings* settings;
	GtkMenuButton* remove_button;
	KeyboardInputMethodPageAddEnginesPopover* add_engines_popover;
	GtkStack* stack;
	GtkEntry* entry_test;
};

struct _Block14Data {
	int _ref_count_;
	KeyboardInputMethodPagePage* self;
	gchar* engine_name;
};

struct _Block15Data {
	int _ref_count_;
	KeyboardInputMethodPagePage* self;
	GtkComboBoxText* keyboard_shortcut_combobox;
};

static gint KeyboardInputMethodPagePage_private_offset;
static gpointer keyboard_input_method_page_page_parent_class = NULL;

VALA_EXTERN GType keyboard_source_settings_get_type (void) G_GNUC_CONST ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gchar* keyboard_input_method_page_page_get_keyboard_shortcut (KeyboardInputMethodPagePage* self);
static void keyboard_input_method_page_page_set_keyboard_shortcut (KeyboardInputMethodPagePage* self,
                                                            const gchar* combobox_id);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void keyboard_input_method_page_page_update_engines_list (KeyboardInputMethodPagePage* self);
static void __lambda58_ (KeyboardInputMethodPagePage* self,
                  GtkWidget* listbox_child);
static void ___lambda58__gtk_callback (GtkWidget* widget,
                                gpointer self);
VALA_EXTERN void keyboard_source_settings_reset (KeyboardSourceSettings* self,
                                     KeyboardLayoutType* layout_type,
                                     gboolean signal_changed);
VALA_EXTERN gchar** keyboard_source_settings_get_active_engines (KeyboardSourceSettings* self,
                                                     gint* result_length1);
static gchar* keyboard_input_method_page_page_gettext_engine_longname (KeyboardInputMethodPagePage* self,
                                                                IBusEngineDesc* engine);
VALA_EXTERN gboolean keyboard_source_settings_add_layout (KeyboardSourceSettings* self,
                                              KeyboardInputSource* new_layout);
static void keyboard_input_method_page_page_write_ibus_autostart_file (KeyboardInputMethodPagePage* self,
                                                                gboolean enable);
static void keyboard_input_method_page_page_spawn_ibus_daemon (KeyboardInputMethodPagePage* self);
static void keyboard_input_method_page_page_set_visible_view (KeyboardInputMethodPagePage* self,
                                                       const gchar* error_message);
static gboolean __lambda59_ (KeyboardInputMethodPagePage* self);
static gboolean ___lambda59__gsource_func (gpointer self);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static void keyboard_input_method_page_page_update_entry_test_usable (KeyboardInputMethodPagePage* self);
VALA_EXTERN KeyboardInputSource* keyboard_source_settings_get_active_input_source (KeyboardSourceSettings* self);
static void keyboard_input_method_page_page_update_list_box_selected_row (KeyboardInputMethodPagePage* self);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void __lambda60_ (Block14Data* _data14_,
                  GtkWidget* widget);
static void ___lambda60__gtk_callback (GtkWidget* widget,
                                gpointer self);
static GObject * keyboard_input_method_page_page_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
VALA_EXTERN KeyboardSourceSettings* keyboard_source_settings_get_instance (void);
static void _keyboard_input_method_page_page___lambda61_ (KeyboardInputMethodPagePage* self);
static void __keyboard_input_method_page_page___lambda61__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                                gpointer self);
static void _keyboard_input_method_page_page___lambda62_ (KeyboardInputMethodPagePage* self,
                                                   GtkListBoxRow* row);
VALA_EXTERN void keyboard_source_settings_set_active_engine_name (KeyboardSourceSettings* self,
                                                      const gchar* engine_name);
static void __keyboard_input_method_page_page___lambda62__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                              GtkListBoxRow* row,
                                                                              gpointer self);
static void _keyboard_input_method_page_page___lambda63_ (KeyboardInputMethodPagePage* self,
                                                   const gchar* name);
static void __keyboard_input_method_page_page___lambda63__ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                                   const gchar* name,
                                                                                   gpointer self);
static void _keyboard_input_method_page_page___lambda64_ (KeyboardInputMethodPagePage* self);
static void __keyboard_input_method_page_page___lambda64__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _keyboard_input_method_page_page___lambda65_ (KeyboardInputMethodPagePage* self,
                                                   const gchar* engine);
VALA_EXTERN gboolean keyboard_source_settings_add_active_engine (KeyboardSourceSettings* self,
                                                     const gchar* engine_name);
static void __keyboard_input_method_page_page___lambda65__keyboard_input_method_page_add_engines_popover_add_engine (KeyboardInputMethodPageAddEnginesPopover* _sender,
                                                                                                              const gchar* new_engine,
                                                                                                              gpointer self);
static void _keyboard_input_method_page_page___lambda66_ (KeyboardInputMethodPagePage* self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void keyboard_source_settings_set_active_engines (KeyboardSourceSettings* self,
                                                  gchar** value,
                                                  gint value_length1);
VALA_EXTERN void keyboard_source_settings_set_active_index (KeyboardSourceSettings* self,
                                                guint value);
static void __keyboard_input_method_page_page___lambda66__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _keyboard_input_method_page_page___lambda67_ (Block15Data* _data15_);
static void __keyboard_input_method_page_page___lambda67__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                          gpointer self);
static void _keyboard_input_method_page_page___lambda68_ (KeyboardInputMethodPagePage* self);
static void __keyboard_input_method_page_page___lambda68__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void keyboard_input_method_page_page_finalize (GObject * obj);
static GType keyboard_input_method_page_page_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
keyboard_input_method_page_page_get_instance_private (KeyboardInputMethodPagePage* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardInputMethodPagePage_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 24 "../src/Views/InputMethod.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 213 "InputMethod.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 24 "../src/Views/InputMethod.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 221 "InputMethod.c"
}

static gchar*
keyboard_input_method_page_page_get_keyboard_shortcut (KeyboardInputMethodPagePage* self)
{
	gchar** keyboard_shortcuts = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint keyboard_shortcuts_length1;
	gint _keyboard_shortcuts_size_;
	gchar* keyboard_shortcut = NULL;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* result;
#line 255 "../src/Views/InputMethod.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 257 "../src/Views/InputMethod.vala"
	_tmp0_ = keyboard_plug_ibus_general_settings;
#line 257 "../src/Views/InputMethod.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "hotkey");
#line 257 "../src/Views/InputMethod.vala"
	_tmp2_ = _tmp1_;
#line 257 "../src/Views/InputMethod.vala"
	_tmp4_ = _tmp3_ = g_settings_get_strv (_tmp2_, "triggers");
#line 257 "../src/Views/InputMethod.vala"
	_tmp5_ = _tmp4_;
#line 257 "../src/Views/InputMethod.vala"
	_tmp5__length1 = _vala_array_length (_tmp3_);
#line 257 "../src/Views/InputMethod.vala"
	_g_object_unref0 (_tmp2_);
#line 257 "../src/Views/InputMethod.vala"
	keyboard_shortcuts = _tmp5_;
#line 257 "../src/Views/InputMethod.vala"
	keyboard_shortcuts_length1 = _tmp5__length1;
#line 257 "../src/Views/InputMethod.vala"
	_keyboard_shortcuts_size_ = keyboard_shortcuts_length1;
#line 259 "../src/Views/InputMethod.vala"
	_tmp6_ = g_strdup ("");
#line 259 "../src/Views/InputMethod.vala"
	keyboard_shortcut = _tmp6_;
#line 260 "../src/Views/InputMethod.vala"
	_tmp7_ = keyboard_shortcuts;
#line 260 "../src/Views/InputMethod.vala"
	_tmp7__length1 = keyboard_shortcuts_length1;
#line 272 "InputMethod.c"
	{
		gchar** ks_collection = NULL;
		gint ks_collection_length1 = 0;
		gint _ks_collection_size_ = 0;
		gint ks_it = 0;
#line 260 "../src/Views/InputMethod.vala"
		ks_collection = _tmp7_;
#line 260 "../src/Views/InputMethod.vala"
		ks_collection_length1 = _tmp7__length1;
#line 260 "../src/Views/InputMethod.vala"
		for (ks_it = 0; ks_it < ks_collection_length1; ks_it = ks_it + 1) {
#line 284 "InputMethod.c"
			gchar* _tmp8_;
			gchar* ks = NULL;
#line 260 "../src/Views/InputMethod.vala"
			_tmp8_ = g_strdup (ks_collection[ks_it]);
#line 260 "../src/Views/InputMethod.vala"
			ks = _tmp8_;
#line 291 "InputMethod.c"
			{
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GQuark _tmp12_ = 0U;
#line 261 "../src/Views/InputMethod.vala"
				static GQuark _tmp11_label0 = 0;
#line 261 "../src/Views/InputMethod.vala"
				static GQuark _tmp11_label1 = 0;
#line 261 "../src/Views/InputMethod.vala"
				static GQuark _tmp11_label2 = 0;
#line 261 "../src/Views/InputMethod.vala"
				_tmp9_ = ks;
#line 261 "../src/Views/InputMethod.vala"
				_tmp10_ = _tmp9_;
#line 261 "../src/Views/InputMethod.vala"
				_tmp12_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
#line 261 "../src/Views/InputMethod.vala"
				if (_tmp12_ == ((0 != _tmp11_label0) ? _tmp11_label0 : (_tmp11_label0 = g_quark_from_static_string ("<Alt>space")))) {
#line 261 "../src/Views/InputMethod.vala"
					switch (0) {
#line 312 "InputMethod.c"
						default:
						{
							gchar* _tmp13_;
#line 263 "../src/Views/InputMethod.vala"
							_tmp13_ = g_strdup ("alt-space");
#line 263 "../src/Views/InputMethod.vala"
							_g_free0 (keyboard_shortcut);
#line 263 "../src/Views/InputMethod.vala"
							keyboard_shortcut = _tmp13_;
#line 264 "../src/Views/InputMethod.vala"
							break;
#line 324 "InputMethod.c"
						}
					}
				} else if (_tmp12_ == ((0 != _tmp11_label1) ? _tmp11_label1 : (_tmp11_label1 = g_quark_from_static_string ("<Shift>space")))) {
#line 261 "../src/Views/InputMethod.vala"
					switch (0) {
#line 330 "InputMethod.c"
						default:
						{
							gchar* _tmp14_;
#line 266 "../src/Views/InputMethod.vala"
							_tmp14_ = g_strdup ("shift-space");
#line 266 "../src/Views/InputMethod.vala"
							_g_free0 (keyboard_shortcut);
#line 266 "../src/Views/InputMethod.vala"
							keyboard_shortcut = _tmp14_;
#line 267 "../src/Views/InputMethod.vala"
							break;
#line 342 "InputMethod.c"
						}
					}
				} else if (_tmp12_ == ((0 != _tmp11_label2) ? _tmp11_label2 : (_tmp11_label2 = g_quark_from_static_string ("<Control>space")))) {
#line 261 "../src/Views/InputMethod.vala"
					switch (0) {
#line 348 "InputMethod.c"
						default:
						{
							gchar* _tmp15_;
#line 269 "../src/Views/InputMethod.vala"
							_tmp15_ = g_strdup ("ctl-space");
#line 269 "../src/Views/InputMethod.vala"
							_g_free0 (keyboard_shortcut);
#line 269 "../src/Views/InputMethod.vala"
							keyboard_shortcut = _tmp15_;
#line 270 "../src/Views/InputMethod.vala"
							break;
#line 360 "InputMethod.c"
						}
					}
				} else {
#line 261 "../src/Views/InputMethod.vala"
					switch (0) {
#line 366 "InputMethod.c"
						default:
						{
#line 272 "../src/Views/InputMethod.vala"
							break;
#line 371 "InputMethod.c"
						}
					}
				}
#line 260 "../src/Views/InputMethod.vala"
				_g_free0 (ks);
#line 377 "InputMethod.c"
			}
		}
	}
#line 276 "../src/Views/InputMethod.vala"
	result = keyboard_shortcut;
#line 276 "../src/Views/InputMethod.vala"
	keyboard_shortcuts = (_vala_array_free (keyboard_shortcuts, keyboard_shortcuts_length1, (GDestroyNotify) g_free), NULL);
#line 276 "../src/Views/InputMethod.vala"
	return result;
#line 387 "InputMethod.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 285 "../src/Views/InputMethod.vala"
	if ((*length) == (*size)) {
#line 285 "../src/Views/InputMethod.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 285 "../src/Views/InputMethod.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 402 "InputMethod.c"
	}
#line 285 "../src/Views/InputMethod.vala"
	(*array)[(*length)++] = value;
#line 285 "../src/Views/InputMethod.vala"
	(*array)[*length] = NULL;
#line 408 "InputMethod.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 288 "../src/Views/InputMethod.vala"
	if ((*length) == (*size)) {
#line 288 "../src/Views/InputMethod.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 288 "../src/Views/InputMethod.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 423 "InputMethod.c"
	}
#line 288 "../src/Views/InputMethod.vala"
	(*array)[(*length)++] = value;
#line 288 "../src/Views/InputMethod.vala"
	(*array)[*length] = NULL;
#line 429 "InputMethod.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 291 "../src/Views/InputMethod.vala"
	if ((*length) == (*size)) {
#line 291 "../src/Views/InputMethod.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 291 "../src/Views/InputMethod.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 444 "InputMethod.c"
	}
#line 291 "../src/Views/InputMethod.vala"
	(*array)[(*length)++] = value;
#line 291 "../src/Views/InputMethod.vala"
	(*array)[*length] = NULL;
#line 450 "InputMethod.c"
}

static void
keyboard_input_method_page_page_set_keyboard_shortcut (KeyboardInputMethodPagePage* self,
                                                       const gchar* combobox_id)
{
	gchar** keyboard_shortcuts = NULL;
	gchar** _tmp0_;
	gint keyboard_shortcuts_length1;
	gint _keyboard_shortcuts_size_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 283 "../src/Views/InputMethod.vala"
	static GQuark _tmp2_label0 = 0;
#line 283 "../src/Views/InputMethod.vala"
	static GQuark _tmp2_label1 = 0;
#line 467 "InputMethod.c"
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
#line 279 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/Views/InputMethod.vala"
	g_return_if_fail (combobox_id != NULL);
#line 281 "../src/Views/InputMethod.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 281 "../src/Views/InputMethod.vala"
	keyboard_shortcuts = _tmp0_;
#line 281 "../src/Views/InputMethod.vala"
	keyboard_shortcuts_length1 = 0;
#line 281 "../src/Views/InputMethod.vala"
	_keyboard_shortcuts_size_ = keyboard_shortcuts_length1;
#line 283 "../src/Views/InputMethod.vala"
	_tmp1_ = combobox_id;
#line 283 "../src/Views/InputMethod.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 283 "../src/Views/InputMethod.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("alt-space")))) {
#line 283 "../src/Views/InputMethod.vala"
		switch (0) {
#line 493 "InputMethod.c"
			default:
			{
				gchar* _tmp4_;
#line 285 "../src/Views/InputMethod.vala"
				_tmp4_ = g_strdup ("<Alt>space");
#line 285 "../src/Views/InputMethod.vala"
				_vala_array_add3 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp4_);
#line 286 "../src/Views/InputMethod.vala"
				break;
#line 503 "InputMethod.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("shift-space")))) {
#line 283 "../src/Views/InputMethod.vala"
		switch (0) {
#line 509 "InputMethod.c"
			default:
			{
				gchar* _tmp5_;
#line 288 "../src/Views/InputMethod.vala"
				_tmp5_ = g_strdup ("<Shift>space");
#line 288 "../src/Views/InputMethod.vala"
				_vala_array_add4 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp5_);
#line 289 "../src/Views/InputMethod.vala"
				break;
#line 519 "InputMethod.c"
			}
		}
	} else {
#line 283 "../src/Views/InputMethod.vala"
		switch (0) {
#line 525 "InputMethod.c"
			default:
			{
				gchar* _tmp6_;
#line 291 "../src/Views/InputMethod.vala"
				_tmp6_ = g_strdup ("<Control>space");
#line 291 "../src/Views/InputMethod.vala"
				_vala_array_add5 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp6_);
#line 292 "../src/Views/InputMethod.vala"
				break;
#line 535 "InputMethod.c"
			}
		}
	}
#line 295 "../src/Views/InputMethod.vala"
	_tmp7_ = keyboard_plug_ibus_general_settings;
#line 295 "../src/Views/InputMethod.vala"
	_tmp8_ = g_settings_get_child (_tmp7_, "hotkey");
#line 295 "../src/Views/InputMethod.vala"
	_tmp9_ = _tmp8_;
#line 295 "../src/Views/InputMethod.vala"
	_tmp10_ = keyboard_shortcuts;
#line 295 "../src/Views/InputMethod.vala"
	_tmp10__length1 = keyboard_shortcuts_length1;
#line 295 "../src/Views/InputMethod.vala"
	g_settings_set_strv (_tmp9_, "triggers", _tmp10_);
#line 295 "../src/Views/InputMethod.vala"
	_g_object_unref0 (_tmp9_);
#line 279 "../src/Views/InputMethod.vala"
	keyboard_shortcuts = (_vala_array_free (keyboard_shortcuts, keyboard_shortcuts_length1, (GDestroyNotify) g_free), NULL);
#line 555 "InputMethod.c"
}

static void
__lambda58_ (KeyboardInputMethodPagePage* self,
             GtkWidget* listbox_child)
{
#line 301 "../src/Views/InputMethod.vala"
	g_return_if_fail (listbox_child != NULL);
#line 302 "../src/Views/InputMethod.vala"
	gtk_widget_destroy (listbox_child);
#line 566 "InputMethod.c"
}

static void
___lambda58__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 301 "../src/Views/InputMethod.vala"
	__lambda58_ ((KeyboardInputMethodPagePage*) self, widget);
#line 575 "InputMethod.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 308 "../src/Views/InputMethod.vala"
	return self ? g_object_ref (self) : NULL;
#line 583 "InputMethod.c"
}

static void
keyboard_input_method_page_page_update_engines_list (KeyboardInputMethodPagePage* self)
{
	IBusBus* _tmp0_;
	GList* _tmp1_;
	GtkListBox* _tmp2_;
	KeyboardSourceSettings* _tmp3_;
	KeyboardLayoutType _tmp4_;
	KeyboardSourceSettings* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GtkListBox* _tmp44_;
	GtkMenuButton* _tmp45_;
	GtkListBox* _tmp46_;
	GtkListBoxRow* _tmp47_;
	GtkStack* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
#line 298 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/Views/InputMethod.vala"
	_tmp0_ = self->priv->bus;
#line 299 "../src/Views/InputMethod.vala"
	_tmp1_ = ibus_bus_list_engines (_tmp0_);
#line 299 "../src/Views/InputMethod.vala"
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
#line 299 "../src/Views/InputMethod.vala"
	self->priv->engines = _tmp1_;
#line 301 "../src/Views/InputMethod.vala"
	_tmp2_ = self->priv->listbox;
#line 301 "../src/Views/InputMethod.vala"
	gtk_container_foreach ((GtkContainer*) _tmp2_, ___lambda58__gtk_callback, self);
#line 306 "../src/Views/InputMethod.vala"
	_tmp3_ = self->priv->settings;
#line 306 "../src/Views/InputMethod.vala"
	_tmp4_ = KEYBOARD_LAYOUT_TYPE_IBUS;
#line 306 "../src/Views/InputMethod.vala"
	keyboard_source_settings_reset (_tmp3_, &_tmp4_, TRUE);
#line 307 "../src/Views/InputMethod.vala"
	_tmp5_ = self->priv->settings;
#line 307 "../src/Views/InputMethod.vala"
	_tmp6_ = keyboard_source_settings_get_active_engines (_tmp5_, &_tmp7_);
#line 307 "../src/Views/InputMethod.vala"
	_tmp6__length1 = _tmp7_;
#line 307 "../src/Views/InputMethod.vala"
	_tmp8_ = _tmp6_;
#line 307 "../src/Views/InputMethod.vala"
	_tmp8__length1 = _tmp6__length1;
#line 637 "InputMethod.c"
	{
		gchar** active_engine_collection = NULL;
		gint active_engine_collection_length1 = 0;
		gint _active_engine_collection_size_ = 0;
		gint active_engine_it = 0;
#line 307 "../src/Views/InputMethod.vala"
		active_engine_collection = _tmp8_;
#line 307 "../src/Views/InputMethod.vala"
		active_engine_collection_length1 = _tmp8__length1;
#line 307 "../src/Views/InputMethod.vala"
		for (active_engine_it = 0; active_engine_it < active_engine_collection_length1; active_engine_it = active_engine_it + 1) {
#line 649 "InputMethod.c"
			gchar* _tmp9_;
			gchar* active_engine = NULL;
#line 307 "../src/Views/InputMethod.vala"
			_tmp9_ = g_strdup (active_engine_collection[active_engine_it]);
#line 307 "../src/Views/InputMethod.vala"
			active_engine = _tmp9_;
#line 656 "InputMethod.c"
			{
				GList* _tmp10_;
#line 308 "../src/Views/InputMethod.vala"
				_tmp10_ = self->priv->engines;
#line 661 "InputMethod.c"
				{
					GList* engine_collection = NULL;
					GList* engine_it = NULL;
#line 308 "../src/Views/InputMethod.vala"
					engine_collection = _tmp10_;
#line 308 "../src/Views/InputMethod.vala"
					for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 669 "InputMethod.c"
						IBusEngineDesc* _tmp11_;
						IBusEngineDesc* engine = NULL;
#line 308 "../src/Views/InputMethod.vala"
						_tmp11_ = _g_object_ref0 ((IBusEngineDesc*) engine_it->data);
#line 308 "../src/Views/InputMethod.vala"
						engine = _tmp11_;
#line 676 "InputMethod.c"
						{
							IBusEngineDesc* _tmp12_;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
							const gchar* _tmp15_;
#line 309 "../src/Views/InputMethod.vala"
							_tmp12_ = engine;
#line 309 "../src/Views/InputMethod.vala"
							_tmp13_ = ibus_engine_desc_get_name (_tmp12_);
#line 309 "../src/Views/InputMethod.vala"
							_tmp14_ = _tmp13_;
#line 309 "../src/Views/InputMethod.vala"
							_tmp15_ = active_engine;
#line 309 "../src/Views/InputMethod.vala"
							if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 692 "InputMethod.c"
								gchar* engine_full_name = NULL;
								IBusEngineDesc* _tmp16_;
								const gchar* _tmp17_;
								const gchar* _tmp18_;
								gchar* _tmp19_;
								gchar* _tmp20_;
								IBusEngineDesc* _tmp21_;
								gchar* _tmp22_;
								gchar* _tmp23_;
								gchar* _tmp24_;
								gchar* _tmp25_;
								GtkLabel* label = NULL;
								const gchar* _tmp26_;
								GtkLabel* _tmp27_ = NULL;
								GtkListBoxRow* listboxrow = NULL;
								GtkListBoxRow* _tmp28_;
								GtkListBoxRow* _tmp29_;
								IBusEngineDesc* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
								gchar* _tmp33_;
								GtkListBoxRow* _tmp34_;
								GtkLabel* _tmp35_;
								GtkListBox* _tmp36_;
								GtkListBoxRow* _tmp37_;
								KeyboardSourceSettings* _tmp38_;
								IBusEngineDesc* _tmp39_;
								const gchar* _tmp40_;
								const gchar* _tmp41_;
								KeyboardInputSource* _tmp42_;
								KeyboardInputSource* _tmp43_;
#line 310 "../src/Views/InputMethod.vala"
								_tmp16_ = engine;
#line 310 "../src/Views/InputMethod.vala"
								_tmp17_ = ibus_engine_desc_get_language (_tmp16_);
#line 310 "../src/Views/InputMethod.vala"
								_tmp18_ = _tmp17_;
#line 310 "../src/Views/InputMethod.vala"
								_tmp19_ = ibus_get_language_name (_tmp18_);
#line 310 "../src/Views/InputMethod.vala"
								_tmp20_ = _tmp19_;
#line 310 "../src/Views/InputMethod.vala"
								_tmp21_ = engine;
#line 310 "../src/Views/InputMethod.vala"
								_tmp22_ = keyboard_input_method_page_page_gettext_engine_longname (self, _tmp21_);
#line 310 "../src/Views/InputMethod.vala"
								_tmp23_ = _tmp22_;
#line 310 "../src/Views/InputMethod.vala"
								_tmp24_ = g_strdup_printf ("%s - %s", _tmp20_, _tmp23_);
#line 310 "../src/Views/InputMethod.vala"
								_tmp25_ = _tmp24_;
#line 310 "../src/Views/InputMethod.vala"
								_g_free0 (_tmp23_);
#line 310 "../src/Views/InputMethod.vala"
								_g_free0 (_tmp20_);
#line 310 "../src/Views/InputMethod.vala"
								engine_full_name = _tmp25_;
#line 314 "../src/Views/InputMethod.vala"
								_tmp26_ = engine_full_name;
#line 314 "../src/Views/InputMethod.vala"
								_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
#line 314 "../src/Views/InputMethod.vala"
								gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_START);
#line 314 "../src/Views/InputMethod.vala"
								g_object_set ((GtkWidget*) _tmp27_, "margin", 6, NULL);
#line 314 "../src/Views/InputMethod.vala"
								g_object_ref_sink (_tmp27_);
#line 314 "../src/Views/InputMethod.vala"
								label = _tmp27_;
#line 319 "../src/Views/InputMethod.vala"
								_tmp28_ = (GtkListBoxRow*) gtk_list_box_row_new ();
#line 319 "../src/Views/InputMethod.vala"
								g_object_ref_sink (_tmp28_);
#line 319 "../src/Views/InputMethod.vala"
								listboxrow = _tmp28_;
#line 320 "../src/Views/InputMethod.vala"
								_tmp29_ = listboxrow;
#line 320 "../src/Views/InputMethod.vala"
								_tmp30_ = engine;
#line 320 "../src/Views/InputMethod.vala"
								_tmp31_ = ibus_engine_desc_get_name (_tmp30_);
#line 320 "../src/Views/InputMethod.vala"
								_tmp32_ = _tmp31_;
#line 320 "../src/Views/InputMethod.vala"
								_tmp33_ = g_strdup (_tmp32_);
#line 320 "../src/Views/InputMethod.vala"
								g_object_set_data_full ((GObject*) _tmp29_, "engine-name", _tmp33_, g_free);
#line 321 "../src/Views/InputMethod.vala"
								_tmp34_ = listboxrow;
#line 321 "../src/Views/InputMethod.vala"
								_tmp35_ = label;
#line 321 "../src/Views/InputMethod.vala"
								gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 323 "../src/Views/InputMethod.vala"
								_tmp36_ = self->priv->listbox;
#line 323 "../src/Views/InputMethod.vala"
								_tmp37_ = listboxrow;
#line 323 "../src/Views/InputMethod.vala"
								gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 324 "../src/Views/InputMethod.vala"
								_tmp38_ = self->priv->settings;
#line 324 "../src/Views/InputMethod.vala"
								_tmp39_ = engine;
#line 324 "../src/Views/InputMethod.vala"
								_tmp40_ = ibus_engine_desc_get_name (_tmp39_);
#line 324 "../src/Views/InputMethod.vala"
								_tmp41_ = _tmp40_;
#line 324 "../src/Views/InputMethod.vala"
								_tmp42_ = keyboard_input_source_new_ibus (_tmp41_);
#line 324 "../src/Views/InputMethod.vala"
								_tmp43_ = _tmp42_;
#line 324 "../src/Views/InputMethod.vala"
								keyboard_source_settings_add_layout (_tmp38_, _tmp43_);
#line 324 "../src/Views/InputMethod.vala"
								_g_object_unref0 (_tmp43_);
#line 309 "../src/Views/InputMethod.vala"
								_g_object_unref0 (listboxrow);
#line 309 "../src/Views/InputMethod.vala"
								_g_object_unref0 (label);
#line 309 "../src/Views/InputMethod.vala"
								_g_free0 (engine_full_name);
#line 814 "InputMethod.c"
							}
#line 308 "../src/Views/InputMethod.vala"
							_g_object_unref0 (engine);
#line 818 "InputMethod.c"
						}
					}
				}
#line 307 "../src/Views/InputMethod.vala"
				_g_free0 (active_engine);
#line 824 "InputMethod.c"
			}
		}
	}
#line 329 "../src/Views/InputMethod.vala"
	_tmp44_ = self->priv->listbox;
#line 329 "../src/Views/InputMethod.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp44_);
#line 331 "../src/Views/InputMethod.vala"
	_tmp45_ = self->priv->remove_button;
#line 331 "../src/Views/InputMethod.vala"
	_tmp46_ = self->priv->listbox;
#line 331 "../src/Views/InputMethod.vala"
	_tmp47_ = gtk_list_box_get_selected_row (_tmp46_);
#line 331 "../src/Views/InputMethod.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp45_, _tmp47_ != NULL);
#line 333 "../src/Views/InputMethod.vala"
	_tmp48_ = self->priv->stack;
#line 333 "../src/Views/InputMethod.vala"
	_tmp49_ = gtk_stack_get_visible_child_name (_tmp48_);
#line 333 "../src/Views/InputMethod.vala"
	_tmp50_ = _tmp49_;
#line 333 "../src/Views/InputMethod.vala"
	if (g_strcmp0 (_tmp50_, "main_view") == 0) {
#line 848 "InputMethod.c"
		GtkListBox* _tmp51_;
		GList* _tmp52_;
		GList* _tmp53_;
#line 334 "../src/Views/InputMethod.vala"
		_tmp51_ = self->priv->listbox;
#line 334 "../src/Views/InputMethod.vala"
		_tmp52_ = gtk_container_get_children ((GtkContainer*) _tmp51_);
#line 334 "../src/Views/InputMethod.vala"
		_tmp53_ = _tmp52_;
#line 334 "../src/Views/InputMethod.vala"
		keyboard_input_method_page_page_write_ibus_autostart_file (self, g_list_length (_tmp53_) > ((guint) 0));
#line 334 "../src/Views/InputMethod.vala"
		(_tmp53_ == NULL) ? NULL : (_tmp53_ = (g_list_free (_tmp53_), NULL));
#line 862 "InputMethod.c"
	}
}

static gboolean
__lambda59_ (KeyboardInputMethodPagePage* self)
{
	gboolean result;
#line 349 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_set_visible_view (self, "");
#line 350 "../src/Views/InputMethod.vala"
	result = GDK_EVENT_PROPAGATE;
#line 350 "../src/Views/InputMethod.vala"
	return result;
#line 876 "InputMethod.c"
}

static gboolean
___lambda59__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda59_ ((KeyboardInputMethodPagePage*) self);
#line 348 "../src/Views/InputMethod.vala"
	return result;
#line 886 "InputMethod.c"
}

static void
keyboard_input_method_page_page_spawn_ibus_daemon (KeyboardInputMethodPagePage* self)
{
	gboolean is_spawn_succeeded = FALSE;
	guint timeout_start_daemon = 0U;
	GtkListBox* _tmp13_;
	GList* _tmp14_;
	GList* _tmp15_;
	gboolean _tmp16_;
	GError* _inner_error0_ = NULL;
#line 338 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/Views/InputMethod.vala"
	is_spawn_succeeded = FALSE;
#line 903 "InputMethod.c"
	{
		gboolean _tmp0_ = FALSE;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gboolean _tmp8_;
#line 341 "../src/Views/InputMethod.vala"
		_tmp1_ = g_strdup ("ibus-daemon");
#line 341 "../src/Views/InputMethod.vala"
		_tmp2_ = g_strdup ("-drx");
#line 341 "../src/Views/InputMethod.vala"
		_tmp3_ = g_new0 (gchar*, 2 + 1);
#line 341 "../src/Views/InputMethod.vala"
		_tmp3_[0] = _tmp1_;
#line 341 "../src/Views/InputMethod.vala"
		_tmp3_[1] = _tmp2_;
#line 341 "../src/Views/InputMethod.vala"
		_tmp4_ = _tmp3_;
#line 341 "../src/Views/InputMethod.vala"
		_tmp4__length1 = 2;
#line 341 "../src/Views/InputMethod.vala"
		_tmp6_ = _tmp5_ = g_get_environ ();
#line 341 "../src/Views/InputMethod.vala"
		_tmp7_ = _tmp6_;
#line 341 "../src/Views/InputMethod.vala"
		_tmp7__length1 = _vala_array_length (_tmp5_);
#line 341 "../src/Views/InputMethod.vala"
		_tmp8_ = g_spawn_sync ("/", _tmp4_, _tmp7_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 341 "../src/Views/InputMethod.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 341 "../src/Views/InputMethod.vala"
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 341 "../src/Views/InputMethod.vala"
		_tmp0_ = _tmp8_;
#line 341 "../src/Views/InputMethod.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "../src/Views/InputMethod.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 948 "InputMethod.c"
				goto __catch0_g_spawn_error;
			}
#line 341 "../src/Views/InputMethod.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 341 "../src/Views/InputMethod.vala"
			g_clear_error (&_inner_error0_);
#line 341 "../src/Views/InputMethod.vala"
			return;
#line 957 "InputMethod.c"
		}
#line 341 "../src/Views/InputMethod.vala"
		is_spawn_succeeded = _tmp0_;
#line 961 "InputMethod.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 340 "../src/Views/InputMethod.vala"
		e = _inner_error0_;
#line 340 "../src/Views/InputMethod.vala"
		_inner_error0_ = NULL;
#line 343 "../src/Views/InputMethod.vala"
		_tmp9_ = e;
#line 343 "../src/Views/InputMethod.vala"
		_tmp10_ = _tmp9_->message;
#line 343 "../src/Views/InputMethod.vala"
		g_warning ("InputMethod.vala:343: %s", _tmp10_);
#line 344 "../src/Views/InputMethod.vala"
		_tmp11_ = e;
#line 344 "../src/Views/InputMethod.vala"
		_tmp12_ = _tmp11_->message;
#line 344 "../src/Views/InputMethod.vala"
		keyboard_input_method_page_page_set_visible_view (self, _tmp12_);
#line 345 "../src/Views/InputMethod.vala"
		_g_error_free0 (e);
#line 345 "../src/Views/InputMethod.vala"
		return;
#line 991 "InputMethod.c"
	}
	__finally0:
#line 340 "../src/Views/InputMethod.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 340 "../src/Views/InputMethod.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 340 "../src/Views/InputMethod.vala"
		g_clear_error (&_inner_error0_);
#line 340 "../src/Views/InputMethod.vala"
		return;
#line 1002 "InputMethod.c"
	}
#line 348 "../src/Views/InputMethod.vala"
	timeout_start_daemon = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda59__gsource_func, g_object_ref (self), g_object_unref);
#line 352 "../src/Views/InputMethod.vala"
	timeout_start_daemon = (guint) 0;
#line 354 "../src/Views/InputMethod.vala"
	_tmp13_ = self->priv->listbox;
#line 354 "../src/Views/InputMethod.vala"
	_tmp14_ = gtk_container_get_children ((GtkContainer*) _tmp13_);
#line 354 "../src/Views/InputMethod.vala"
	_tmp15_ = _tmp14_;
#line 354 "../src/Views/InputMethod.vala"
	_tmp16_ = is_spawn_succeeded & (g_list_length (_tmp15_) > ((guint) 0));
#line 354 "../src/Views/InputMethod.vala"
	(_tmp15_ == NULL) ? NULL : (_tmp15_ = (g_list_free (_tmp15_), NULL));
#line 354 "../src/Views/InputMethod.vala"
	if (_tmp16_) {
#line 355 "../src/Views/InputMethod.vala"
		keyboard_input_method_page_page_write_ibus_autostart_file (self, TRUE);
#line 1022 "InputMethod.c"
	}
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
#line 377 "../src/Views/InputMethod.vala"
	if (length >= 0) {
#line 1032 "InputMethod.c"
		gchar** result;
		gssize i;
#line 377 "../src/Views/InputMethod.vala"
		result = g_new0 (gchar*, length + 1);
#line 377 "../src/Views/InputMethod.vala"
		for (i = 0; i < length; i++) {
#line 1039 "InputMethod.c"
			gchar* _tmp0_;
#line 377 "../src/Views/InputMethod.vala"
			_tmp0_ = g_strdup (self[i]);
#line 377 "../src/Views/InputMethod.vala"
			result[i] = _tmp0_;
#line 1045 "InputMethod.c"
		}
#line 377 "../src/Views/InputMethod.vala"
		return result;
#line 1049 "InputMethod.c"
	}
#line 377 "../src/Views/InputMethod.vala"
	return NULL;
#line 1053 "InputMethod.c"
}

static void
keyboard_input_method_page_page_write_ibus_autostart_file (KeyboardInputMethodPagePage* self,
                                                           gboolean enable)
{
	gchar* config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* startup_dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** languages = NULL;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint languages_length1;
	gint _languages_size_;
	gchar* preferred_language = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp16_;
	GKeyFile* _tmp17_;
	const gchar* _tmp18_;
	GKeyFile* _tmp19_;
	const gchar* _tmp20_;
	GKeyFile* _tmp21_;
	GKeyFile* _tmp22_;
	GKeyFile* _tmp23_;
	GKeyFile* _tmp24_;
	gchar* path = NULL;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 359 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/Views/InputMethod.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 361 "../src/Views/InputMethod.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 361 "../src/Views/InputMethod.vala"
	config_dir = _tmp1_;
#line 362 "../src/Views/InputMethod.vala"
	_tmp2_ = config_dir;
#line 362 "../src/Views/InputMethod.vala"
	_tmp3_ = g_build_filename (_tmp2_, "autostart", NULL);
#line 362 "../src/Views/InputMethod.vala"
	startup_dir = _tmp3_;
#line 365 "../src/Views/InputMethod.vala"
	_tmp4_ = startup_dir;
#line 365 "../src/Views/InputMethod.vala"
	if (!g_file_test (_tmp4_, G_FILE_TEST_EXISTS)) {
#line 1111 "InputMethod.c"
		GFile* file = NULL;
		const gchar* _tmp5_;
		GFile* _tmp6_;
#line 366 "../src/Views/InputMethod.vala"
		_tmp5_ = startup_dir;
#line 366 "../src/Views/InputMethod.vala"
		_tmp6_ = g_file_new_for_path (_tmp5_);
#line 366 "../src/Views/InputMethod.vala"
		file = _tmp6_;
#line 1121 "InputMethod.c"
		{
			GFile* _tmp7_;
#line 369 "../src/Views/InputMethod.vala"
			_tmp7_ = file;
#line 369 "../src/Views/InputMethod.vala"
			g_file_make_directory_with_parents (_tmp7_, NULL, &_inner_error0_);
#line 369 "../src/Views/InputMethod.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1130 "InputMethod.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 368 "../src/Views/InputMethod.vala"
			e = _inner_error0_;
#line 368 "../src/Views/InputMethod.vala"
			_inner_error0_ = NULL;
#line 371 "../src/Views/InputMethod.vala"
			_tmp8_ = e;
#line 371 "../src/Views/InputMethod.vala"
			_tmp9_ = _tmp8_->message;
#line 371 "../src/Views/InputMethod.vala"
			g_warning ("InputMethod.vala:371: %s", _tmp9_);
#line 372 "../src/Views/InputMethod.vala"
			_g_error_free0 (e);
#line 372 "../src/Views/InputMethod.vala"
			_g_object_unref0 (file);
#line 372 "../src/Views/InputMethod.vala"
			_g_free0 (startup_dir);
#line 372 "../src/Views/InputMethod.vala"
			_g_free0 (config_dir);
#line 372 "../src/Views/InputMethod.vala"
			return;
#line 1160 "InputMethod.c"
		}
		__finally0:
#line 368 "../src/Views/InputMethod.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 368 "../src/Views/InputMethod.vala"
			_g_object_unref0 (file);
#line 368 "../src/Views/InputMethod.vala"
			_g_free0 (startup_dir);
#line 368 "../src/Views/InputMethod.vala"
			_g_free0 (config_dir);
#line 368 "../src/Views/InputMethod.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 368 "../src/Views/InputMethod.vala"
			g_clear_error (&_inner_error0_);
#line 368 "../src/Views/InputMethod.vala"
			return;
#line 1177 "InputMethod.c"
		}
#line 365 "../src/Views/InputMethod.vala"
		_g_object_unref0 (file);
#line 1181 "InputMethod.c"
	}
#line 377 "../src/Views/InputMethod.vala"
	_tmp11_ = _tmp10_ = g_get_language_names ();
#line 377 "../src/Views/InputMethod.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup4 (_tmp11_, _vala_array_length (_tmp10_)) : _tmp11_;
#line 377 "../src/Views/InputMethod.vala"
	_tmp12__length1 = _vala_array_length (_tmp10_);
#line 377 "../src/Views/InputMethod.vala"
	languages = _tmp12_;
#line 377 "../src/Views/InputMethod.vala"
	languages_length1 = _tmp12__length1;
#line 377 "../src/Views/InputMethod.vala"
	_languages_size_ = languages_length1;
#line 378 "../src/Views/InputMethod.vala"
	_tmp13_ = languages;
#line 378 "../src/Views/InputMethod.vala"
	_tmp13__length1 = languages_length1;
#line 378 "../src/Views/InputMethod.vala"
	_tmp14_ = _tmp13_[0];
#line 378 "../src/Views/InputMethod.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 378 "../src/Views/InputMethod.vala"
	preferred_language = _tmp15_;
#line 380 "../src/Views/InputMethod.vala"
	_tmp16_ = g_key_file_new ();
#line 380 "../src/Views/InputMethod.vala"
	keyfile = _tmp16_;
#line 381 "../src/Views/InputMethod.vala"
	_tmp17_ = keyfile;
#line 381 "../src/Views/InputMethod.vala"
	_tmp18_ = preferred_language;
#line 381 "../src/Views/InputMethod.vala"
	g_key_file_set_locale_string (_tmp17_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_NAME, _tmp18_, _ ("IBus Daemon"));
#line 382 "../src/Views/InputMethod.vala"
	_tmp19_ = keyfile;
#line 382 "../src/Views/InputMethod.vala"
	_tmp20_ = preferred_language;
#line 382 "../src/Views/InputMethod.vala"
	g_key_file_set_locale_string (_tmp19_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_COMMENT, _tmp20_, _ ("Use and manage input methods"));
#line 386 "../src/Views/InputMethod.vala"
	_tmp21_ = keyfile;
#line 386 "../src/Views/InputMethod.vala"
	g_key_file_set_string (_tmp21_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, "ibus-daemon -drx");
#line 387 "../src/Views/InputMethod.vala"
	_tmp22_ = keyfile;
#line 387 "../src/Views/InputMethod.vala"
	g_key_file_set_string (_tmp22_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_ICON, "ibus-setup");
#line 388 "../src/Views/InputMethod.vala"
	_tmp23_ = keyfile;
#line 388 "../src/Views/InputMethod.vala"
	g_key_file_set_string (_tmp23_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_TYPE, "Application");
#line 389 "../src/Views/InputMethod.vala"
	_tmp24_ = keyfile;
#line 389 "../src/Views/InputMethod.vala"
	g_key_file_set_boolean (_tmp24_, G_KEY_FILE_DESKTOP_GROUP, "X-GNOME-Autostart-enabled", enable);
#line 391 "../src/Views/InputMethod.vala"
	_tmp25_ = startup_dir;
#line 391 "../src/Views/InputMethod.vala"
	_tmp26_ = g_build_filename (_tmp25_, "ibus-daemon.desktop", NULL);
#line 391 "../src/Views/InputMethod.vala"
	path = _tmp26_;
#line 1243 "InputMethod.c"
	{
		const gchar* _tmp27_;
		GKeyFile* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
#line 395 "../src/Views/InputMethod.vala"
		_tmp27_ = path;
#line 395 "../src/Views/InputMethod.vala"
		_tmp28_ = keyfile;
#line 395 "../src/Views/InputMethod.vala"
		_tmp29_ = g_key_file_to_data (_tmp28_, NULL, NULL);
#line 395 "../src/Views/InputMethod.vala"
		_tmp30_ = _tmp29_;
#line 395 "../src/Views/InputMethod.vala"
		g_file_set_contents (_tmp27_, _tmp30_, (gssize) -1, &_inner_error0_);
#line 395 "../src/Views/InputMethod.vala"
		_g_free0 (_tmp30_);
#line 395 "../src/Views/InputMethod.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1263 "InputMethod.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp31_;
		GError* _tmp32_;
		const gchar* _tmp33_;
#line 394 "../src/Views/InputMethod.vala"
		e = _inner_error0_;
#line 394 "../src/Views/InputMethod.vala"
		_inner_error0_ = NULL;
#line 397 "../src/Views/InputMethod.vala"
		_tmp31_ = path;
#line 397 "../src/Views/InputMethod.vala"
		_tmp32_ = e;
#line 397 "../src/Views/InputMethod.vala"
		_tmp33_ = _tmp32_->message;
#line 397 "../src/Views/InputMethod.vala"
		g_warning ("InputMethod.vala:397: Could not write to file %s: %s", _tmp31_, _tmp33_);
#line 394 "../src/Views/InputMethod.vala"
		_g_error_free0 (e);
#line 1288 "InputMethod.c"
	}
	__finally1:
#line 394 "../src/Views/InputMethod.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 394 "../src/Views/InputMethod.vala"
		_g_free0 (path);
#line 394 "../src/Views/InputMethod.vala"
		_g_key_file_unref0 (keyfile);
#line 394 "../src/Views/InputMethod.vala"
		_g_free0 (preferred_language);
#line 394 "../src/Views/InputMethod.vala"
		languages = (_vala_array_free (languages, languages_length1, (GDestroyNotify) g_free), NULL);
#line 394 "../src/Views/InputMethod.vala"
		_g_free0 (startup_dir);
#line 394 "../src/Views/InputMethod.vala"
		_g_free0 (config_dir);
#line 394 "../src/Views/InputMethod.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 394 "../src/Views/InputMethod.vala"
		g_clear_error (&_inner_error0_);
#line 394 "../src/Views/InputMethod.vala"
		return;
#line 1311 "InputMethod.c"
	}
#line 359 "../src/Views/InputMethod.vala"
	_g_free0 (path);
#line 359 "../src/Views/InputMethod.vala"
	_g_key_file_unref0 (keyfile);
#line 359 "../src/Views/InputMethod.vala"
	_g_free0 (preferred_language);
#line 359 "../src/Views/InputMethod.vala"
	languages = (_vala_array_free (languages, languages_length1, (GDestroyNotify) g_free), NULL);
#line 359 "../src/Views/InputMethod.vala"
	_g_free0 (startup_dir);
#line 359 "../src/Views/InputMethod.vala"
	_g_free0 (config_dir);
#line 1325 "InputMethod.c"
}

static void
keyboard_input_method_page_page_set_visible_view (KeyboardInputMethodPagePage* self,
                                                  const gchar* error_message)
{
#line 401 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 401 "../src/Views/InputMethod.vala"
	g_return_if_fail (error_message != NULL);
#line 402 "../src/Views/InputMethod.vala"
	if (g_strcmp0 (error_message, "") != 0) {
#line 1338 "InputMethod.c"
		GtkStack* _tmp0_;
		GraniteWidgetsAlertView* _tmp1_;
#line 403 "../src/Views/InputMethod.vala"
		_tmp0_ = self->priv->stack;
#line 403 "../src/Views/InputMethod.vala"
		gtk_stack_set_visible_child_name (_tmp0_, "spawn_failed_view");
#line 404 "../src/Views/InputMethod.vala"
		_tmp1_ = self->priv->spawn_failed_alert;
#line 404 "../src/Views/InputMethod.vala"
		granite_widgets_alert_view_set_description (_tmp1_, error_message);
#line 1349 "InputMethod.c"
	} else {
		IBusBus* _tmp2_;
#line 405 "../src/Views/InputMethod.vala"
		_tmp2_ = self->priv->bus;
#line 405 "../src/Views/InputMethod.vala"
		if (ibus_bus_is_connected (_tmp2_)) {
#line 1356 "InputMethod.c"
			GtkStack* _tmp3_;
#line 406 "../src/Views/InputMethod.vala"
			_tmp3_ = self->priv->stack;
#line 406 "../src/Views/InputMethod.vala"
			gtk_stack_set_visible_child_name (_tmp3_, "main_view");
#line 407 "../src/Views/InputMethod.vala"
			keyboard_input_method_page_page_update_engines_list (self);
#line 408 "../src/Views/InputMethod.vala"
			keyboard_input_method_page_page_update_popover_engines_list (self);
#line 1366 "InputMethod.c"
		} else {
			GtkStack* _tmp4_;
#line 410 "../src/Views/InputMethod.vala"
			_tmp4_ = self->priv->stack;
#line 410 "../src/Views/InputMethod.vala"
			gtk_stack_set_visible_child_name (_tmp4_, "no_daemon_runnning_view");
#line 1373 "InputMethod.c"
		}
	}
}

static gchar*
keyboard_input_method_page_page_gettext_engine_longname (KeyboardInputMethodPagePage* self,
                                                         IBusEngineDesc* engine)
{
	gchar* name = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* textdomain = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* result;
#line 415 "../src/Views/InputMethod.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 415 "../src/Views/InputMethod.vala"
	g_return_val_if_fail (engine != NULL, NULL);
#line 416 "../src/Views/InputMethod.vala"
	_tmp0_ = ibus_engine_desc_get_name (engine);
#line 416 "../src/Views/InputMethod.vala"
	_tmp1_ = _tmp0_;
#line 416 "../src/Views/InputMethod.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 416 "../src/Views/InputMethod.vala"
	name = _tmp2_;
#line 417 "../src/Views/InputMethod.vala"
	_tmp3_ = name;
#line 417 "../src/Views/InputMethod.vala"
	if (g_str_has_prefix (_tmp3_, "xkb:")) {
#line 1413 "InputMethod.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 418 "../src/Views/InputMethod.vala"
		_tmp4_ = ibus_engine_desc_get_longname (engine);
#line 418 "../src/Views/InputMethod.vala"
		_tmp5_ = _tmp4_;
#line 418 "../src/Views/InputMethod.vala"
		_tmp6_ = g_strdup (g_dgettext ("xkeyboard-config", _tmp5_));
#line 418 "../src/Views/InputMethod.vala"
		result = _tmp6_;
#line 418 "../src/Views/InputMethod.vala"
		_g_free0 (name);
#line 418 "../src/Views/InputMethod.vala"
		return result;
#line 1429 "InputMethod.c"
	}
#line 421 "../src/Views/InputMethod.vala"
	_tmp7_ = ibus_engine_desc_get_textdomain (engine);
#line 421 "../src/Views/InputMethod.vala"
	_tmp8_ = _tmp7_;
#line 421 "../src/Views/InputMethod.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 421 "../src/Views/InputMethod.vala"
	textdomain = _tmp9_;
#line 422 "../src/Views/InputMethod.vala"
	_tmp10_ = textdomain;
#line 422 "../src/Views/InputMethod.vala"
	if (g_strcmp0 (_tmp10_, "") == 0) {
#line 1443 "InputMethod.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 423 "../src/Views/InputMethod.vala"
		_tmp11_ = ibus_engine_desc_get_longname (engine);
#line 423 "../src/Views/InputMethod.vala"
		_tmp12_ = _tmp11_;
#line 423 "../src/Views/InputMethod.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 423 "../src/Views/InputMethod.vala"
		result = _tmp13_;
#line 423 "../src/Views/InputMethod.vala"
		_g_free0 (textdomain);
#line 423 "../src/Views/InputMethod.vala"
		_g_free0 (name);
#line 423 "../src/Views/InputMethod.vala"
		return result;
#line 1461 "InputMethod.c"
	}
#line 426 "../src/Views/InputMethod.vala"
	_tmp14_ = textdomain;
#line 426 "../src/Views/InputMethod.vala"
	_tmp15_ = ibus_engine_desc_get_longname (engine);
#line 426 "../src/Views/InputMethod.vala"
	_tmp16_ = _tmp15_;
#line 426 "../src/Views/InputMethod.vala"
	_tmp17_ = g_strdup (g_dgettext (_tmp14_, _tmp16_));
#line 426 "../src/Views/InputMethod.vala"
	result = _tmp17_;
#line 426 "../src/Views/InputMethod.vala"
	_g_free0 (textdomain);
#line 426 "../src/Views/InputMethod.vala"
	_g_free0 (name);
#line 426 "../src/Views/InputMethod.vala"
	return result;
#line 1479 "InputMethod.c"
}

void
keyboard_input_method_page_page_update_popover_engines_list (KeyboardInputMethodPagePage* self)
{
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	GList* _tmp2_;
	GList* engine_lists = NULL;
	GList* _tmp3_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp20_;
	GList* _tmp21_;
#line 429 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/Views/InputMethod.vala"
	_tmp0_ = ibus_bus_new ();
#line 430 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp0_);
#line 430 "../src/Views/InputMethod.vala"
	_tmp1_ = _tmp0_;
#line 430 "../src/Views/InputMethod.vala"
	_tmp2_ = ibus_bus_list_engines (_tmp1_);
#line 430 "../src/Views/InputMethod.vala"
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
#line 430 "../src/Views/InputMethod.vala"
	self->priv->engines = _tmp2_;
#line 430 "../src/Views/InputMethod.vala"
	_g_object_unref0 (_tmp1_);
#line 431 "../src/Views/InputMethod.vala"
	engine_lists = NULL;
#line 432 "../src/Views/InputMethod.vala"
	_tmp3_ = self->priv->engines;
#line 1512 "InputMethod.c"
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
#line 432 "../src/Views/InputMethod.vala"
		engine_collection = _tmp3_;
#line 432 "../src/Views/InputMethod.vala"
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 1520 "InputMethod.c"
			IBusEngineDesc* _tmp4_;
			IBusEngineDesc* engine = NULL;
#line 432 "../src/Views/InputMethod.vala"
			_tmp4_ = _g_object_ref0 ((IBusEngineDesc*) engine_it->data);
#line 432 "../src/Views/InputMethod.vala"
			engine = _tmp4_;
#line 1527 "InputMethod.c"
			{
				gchar* full_name = NULL;
				IBusEngineDesc* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				IBusEngineDesc* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				IBusEngineDesc* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				KeyboardInputMethodPageAddEnginesList* _tmp19_;
#line 433 "../src/Views/InputMethod.vala"
				_tmp5_ = engine;
#line 433 "../src/Views/InputMethod.vala"
				_tmp6_ = ibus_engine_desc_get_language (_tmp5_);
#line 433 "../src/Views/InputMethod.vala"
				_tmp7_ = _tmp6_;
#line 433 "../src/Views/InputMethod.vala"
				_tmp8_ = ibus_get_language_name (_tmp7_);
#line 433 "../src/Views/InputMethod.vala"
				_tmp9_ = _tmp8_;
#line 433 "../src/Views/InputMethod.vala"
				_tmp10_ = engine;
#line 433 "../src/Views/InputMethod.vala"
				_tmp11_ = keyboard_input_method_page_page_gettext_engine_longname (self, _tmp10_);
#line 433 "../src/Views/InputMethod.vala"
				_tmp12_ = _tmp11_;
#line 433 "../src/Views/InputMethod.vala"
				_tmp13_ = g_strdup_printf ("%s - %s", _tmp9_, _tmp12_);
#line 433 "../src/Views/InputMethod.vala"
				_tmp14_ = _tmp13_;
#line 433 "../src/Views/InputMethod.vala"
				_g_free0 (_tmp12_);
#line 433 "../src/Views/InputMethod.vala"
				_g_free0 (_tmp9_);
#line 433 "../src/Views/InputMethod.vala"
				full_name = _tmp14_;
#line 437 "../src/Views/InputMethod.vala"
				_tmp15_ = engine;
#line 437 "../src/Views/InputMethod.vala"
				_tmp16_ = ibus_engine_desc_get_name (_tmp15_);
#line 437 "../src/Views/InputMethod.vala"
				_tmp17_ = _tmp16_;
#line 437 "../src/Views/InputMethod.vala"
				_tmp18_ = full_name;
#line 437 "../src/Views/InputMethod.vala"
				_tmp19_ = keyboard_input_method_page_add_engines_list_new (_tmp17_, _tmp18_);
#line 437 "../src/Views/InputMethod.vala"
				engine_lists = g_list_append (engine_lists, _tmp19_);
#line 432 "../src/Views/InputMethod.vala"
				_g_free0 (full_name);
#line 432 "../src/Views/InputMethod.vala"
				_g_object_unref0 (engine);
#line 1587 "InputMethod.c"
			}
		}
	}
#line 440 "../src/Views/InputMethod.vala"
	_tmp20_ = self->priv->add_engines_popover;
#line 440 "../src/Views/InputMethod.vala"
	_tmp21_ = engine_lists;
#line 440 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_add_engines_popover_update_engines_list (_tmp20_, _tmp21_);
#line 429 "../src/Views/InputMethod.vala"
	(engine_lists == NULL) ? NULL : (engine_lists = (_g_list_free__g_object_unref0_ (engine_lists), NULL));
#line 1599 "InputMethod.c"
}

static void
keyboard_input_method_page_page_update_entry_test_usable (KeyboardInputMethodPagePage* self)
{
	gboolean _tmp0_ = FALSE;
	KeyboardSourceSettings* _tmp1_;
	KeyboardInputSource* _tmp2_;
	KeyboardInputSource* _tmp3_;
#line 443 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 444 "../src/Views/InputMethod.vala"
	_tmp1_ = self->priv->settings;
#line 444 "../src/Views/InputMethod.vala"
	_tmp2_ = keyboard_source_settings_get_active_input_source (_tmp1_);
#line 444 "../src/Views/InputMethod.vala"
	_tmp3_ = _tmp2_;
#line 444 "../src/Views/InputMethod.vala"
	if (_tmp3_ != NULL) {
#line 1619 "InputMethod.c"
		KeyboardSourceSettings* _tmp4_;
		KeyboardInputSource* _tmp5_;
		KeyboardInputSource* _tmp6_;
		KeyboardLayoutType _tmp7_;
		KeyboardLayoutType _tmp8_;
#line 445 "../src/Views/InputMethod.vala"
		_tmp4_ = self->priv->settings;
#line 445 "../src/Views/InputMethod.vala"
		_tmp5_ = keyboard_source_settings_get_active_input_source (_tmp4_);
#line 445 "../src/Views/InputMethod.vala"
		_tmp6_ = _tmp5_;
#line 445 "../src/Views/InputMethod.vala"
		_tmp7_ = keyboard_input_source_get_layout_type (_tmp6_);
#line 445 "../src/Views/InputMethod.vala"
		_tmp8_ = _tmp7_;
#line 445 "../src/Views/InputMethod.vala"
		_tmp0_ = _tmp8_ == KEYBOARD_LAYOUT_TYPE_IBUS;
#line 1637 "InputMethod.c"
	} else {
#line 444 "../src/Views/InputMethod.vala"
		_tmp0_ = FALSE;
#line 1641 "InputMethod.c"
	}
#line 444 "../src/Views/InputMethod.vala"
	if (_tmp0_) {
#line 1645 "InputMethod.c"
		GtkEntry* _tmp9_;
		GtkEntry* _tmp10_;
#line 447 "../src/Views/InputMethod.vala"
		_tmp9_ = self->priv->entry_test;
#line 447 "../src/Views/InputMethod.vala"
		gtk_entry_set_placeholder_text (_tmp9_, _ ("Type to test your input method"));
#line 448 "../src/Views/InputMethod.vala"
		_tmp10_ = self->priv->entry_test;
#line 448 "../src/Views/InputMethod.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
#line 1656 "InputMethod.c"
	} else {
		GtkEntry* _tmp11_;
		GtkEntry* _tmp12_;
#line 450 "../src/Views/InputMethod.vala"
		_tmp11_ = self->priv->entry_test;
#line 450 "../src/Views/InputMethod.vala"
		gtk_entry_set_placeholder_text (_tmp11_, _ ("A keyboard layout is active"));
#line 451 "../src/Views/InputMethod.vala"
		_tmp12_ = self->priv->entry_test;
#line 451 "../src/Views/InputMethod.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, FALSE);
#line 1668 "InputMethod.c"
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 455 "../src/Views/InputMethod.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 455 "../src/Views/InputMethod.vala"
	return _data14_;
#line 1679 "InputMethod.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 455 "../src/Views/InputMethod.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 1689 "InputMethod.c"
		KeyboardInputMethodPagePage* self;
#line 455 "../src/Views/InputMethod.vala"
		self = _data14_->self;
#line 455 "../src/Views/InputMethod.vala"
		_g_free0 (_data14_->engine_name);
#line 455 "../src/Views/InputMethod.vala"
		_g_object_unref0 (self);
#line 455 "../src/Views/InputMethod.vala"
		g_slice_free (Block14Data, _data14_);
#line 1699 "InputMethod.c"
	}
}

static void
__lambda60_ (Block14Data* _data14_,
             GtkWidget* widget)
{
	KeyboardInputMethodPagePage* self;
	GtkListBoxRow* row = NULL;
	GtkListBoxRow* _tmp0_;
	gchar* row_name = NULL;
	GtkListBoxRow* _tmp1_;
	gconstpointer _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 467 "../src/Views/InputMethod.vala"
	self = _data14_->self;
#line 467 "../src/Views/InputMethod.vala"
	g_return_if_fail (widget != NULL);
#line 468 "../src/Views/InputMethod.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 468 "../src/Views/InputMethod.vala"
	row = _tmp0_;
#line 469 "../src/Views/InputMethod.vala"
	_tmp1_ = row;
#line 469 "../src/Views/InputMethod.vala"
	_tmp2_ = g_object_get_data ((GObject*) _tmp1_, "engine-name");
#line 469 "../src/Views/InputMethod.vala"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 469 "../src/Views/InputMethod.vala"
	row_name = _tmp3_;
#line 470 "../src/Views/InputMethod.vala"
	_tmp4_ = row_name;
#line 470 "../src/Views/InputMethod.vala"
	_tmp5_ = _data14_->engine_name;
#line 470 "../src/Views/InputMethod.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 1738 "InputMethod.c"
		GtkListBox* _tmp6_;
		GtkListBoxRow* _tmp7_;
#line 471 "../src/Views/InputMethod.vala"
		_tmp6_ = self->priv->listbox;
#line 471 "../src/Views/InputMethod.vala"
		_tmp7_ = row;
#line 471 "../src/Views/InputMethod.vala"
		gtk_list_box_select_row (_tmp6_, _tmp7_);
#line 1747 "InputMethod.c"
	} else {
		GtkListBox* _tmp8_;
		GtkListBoxRow* _tmp9_;
#line 473 "../src/Views/InputMethod.vala"
		_tmp8_ = self->priv->listbox;
#line 473 "../src/Views/InputMethod.vala"
		_tmp9_ = row;
#line 473 "../src/Views/InputMethod.vala"
		gtk_list_box_unselect_row (_tmp8_, _tmp9_);
#line 1757 "InputMethod.c"
	}
#line 467 "../src/Views/InputMethod.vala"
	_g_free0 (row_name);
#line 467 "../src/Views/InputMethod.vala"
	_g_object_unref0 (row);
#line 1763 "InputMethod.c"
}

static void
___lambda60__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 467 "../src/Views/InputMethod.vala"
	__lambda60_ (self, widget);
#line 1772 "InputMethod.c"
}

static void
keyboard_input_method_page_page_update_list_box_selected_row (KeyboardInputMethodPagePage* self)
{
	Block14Data* _data14_;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	KeyboardSourceSettings* _tmp2_;
	KeyboardInputSource* _tmp3_;
	KeyboardInputSource* _tmp4_;
	GtkListBox* _tmp18_;
	GtkMenuButton* _tmp19_;
	GtkListBox* _tmp20_;
	GtkListBoxRow* _tmp21_;
#line 455 "../src/Views/InputMethod.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/Views/InputMethod.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 455 "../src/Views/InputMethod.vala"
	_data14_->_ref_count_ = 1;
#line 455 "../src/Views/InputMethod.vala"
	_data14_->self = g_object_ref (self);
#line 456 "../src/Views/InputMethod.vala"
	_tmp0_ = g_strdup ("");
#line 456 "../src/Views/InputMethod.vala"
	_data14_->engine_name = _tmp0_;
#line 458 "../src/Views/InputMethod.vala"
	_tmp2_ = self->priv->settings;
#line 458 "../src/Views/InputMethod.vala"
	_tmp3_ = keyboard_source_settings_get_active_input_source (_tmp2_);
#line 458 "../src/Views/InputMethod.vala"
	_tmp4_ = _tmp3_;
#line 458 "../src/Views/InputMethod.vala"
	if (_tmp4_ != NULL) {
#line 1808 "InputMethod.c"
		KeyboardSourceSettings* _tmp5_;
		KeyboardInputSource* _tmp6_;
		KeyboardInputSource* _tmp7_;
		KeyboardLayoutType _tmp8_;
		KeyboardLayoutType _tmp9_;
#line 459 "../src/Views/InputMethod.vala"
		_tmp5_ = self->priv->settings;
#line 459 "../src/Views/InputMethod.vala"
		_tmp6_ = keyboard_source_settings_get_active_input_source (_tmp5_);
#line 459 "../src/Views/InputMethod.vala"
		_tmp7_ = _tmp6_;
#line 459 "../src/Views/InputMethod.vala"
		_tmp8_ = keyboard_input_source_get_layout_type (_tmp7_);
#line 459 "../src/Views/InputMethod.vala"
		_tmp9_ = _tmp8_;
#line 459 "../src/Views/InputMethod.vala"
		_tmp1_ = _tmp9_ == KEYBOARD_LAYOUT_TYPE_IBUS;
#line 1826 "InputMethod.c"
	} else {
#line 458 "../src/Views/InputMethod.vala"
		_tmp1_ = FALSE;
#line 1830 "InputMethod.c"
	}
#line 458 "../src/Views/InputMethod.vala"
	if (_tmp1_) {
#line 1834 "InputMethod.c"
		KeyboardSourceSettings* _tmp10_;
		KeyboardInputSource* _tmp11_;
		KeyboardInputSource* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		IBusBus* _tmp16_;
		const gchar* _tmp17_;
#line 461 "../src/Views/InputMethod.vala"
		_tmp10_ = self->priv->settings;
#line 461 "../src/Views/InputMethod.vala"
		_tmp11_ = keyboard_source_settings_get_active_input_source (_tmp10_);
#line 461 "../src/Views/InputMethod.vala"
		_tmp12_ = _tmp11_;
#line 461 "../src/Views/InputMethod.vala"
		_tmp13_ = keyboard_input_source_get_name (_tmp12_);
#line 461 "../src/Views/InputMethod.vala"
		_tmp14_ = _tmp13_;
#line 461 "../src/Views/InputMethod.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 461 "../src/Views/InputMethod.vala"
		_g_free0 (_data14_->engine_name);
#line 461 "../src/Views/InputMethod.vala"
		_data14_->engine_name = _tmp15_;
#line 462 "../src/Views/InputMethod.vala"
		_tmp16_ = self->priv->bus;
#line 462 "../src/Views/InputMethod.vala"
		_tmp17_ = _data14_->engine_name;
#line 462 "../src/Views/InputMethod.vala"
		ibus_bus_set_global_engine (_tmp16_, _tmp17_);
#line 1865 "InputMethod.c"
	}
#line 467 "../src/Views/InputMethod.vala"
	_tmp18_ = self->priv->listbox;
#line 467 "../src/Views/InputMethod.vala"
	gtk_container_foreach ((GtkContainer*) _tmp18_, ___lambda60__gtk_callback, _data14_);
#line 477 "../src/Views/InputMethod.vala"
	_tmp19_ = self->priv->remove_button;
#line 477 "../src/Views/InputMethod.vala"
	_tmp20_ = self->priv->listbox;
#line 477 "../src/Views/InputMethod.vala"
	_tmp21_ = gtk_list_box_get_selected_row (_tmp20_);
#line 477 "../src/Views/InputMethod.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, _tmp21_ != NULL);
#line 455 "../src/Views/InputMethod.vala"
	block14_data_unref (_data14_);
#line 455 "../src/Views/InputMethod.vala"
	_data14_ = NULL;
#line 1883 "InputMethod.c"
}

KeyboardInputMethodPagePage*
keyboard_input_method_page_page_construct (GType object_type)
{
	KeyboardInputMethodPagePage * self = NULL;
#line 18 "../src/Views/InputMethod.vala"
	self = (KeyboardInputMethodPagePage*) g_object_new (object_type, NULL);
#line 18 "../src/Views/InputMethod.vala"
	return self;
#line 1894 "InputMethod.c"
}

KeyboardInputMethodPagePage*
keyboard_input_method_page_page_new (void)
{
#line 18 "../src/Views/InputMethod.vala"
	return keyboard_input_method_page_page_construct (KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE);
#line 1902 "InputMethod.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 37 "../src/Views/InputMethod.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 37 "../src/Views/InputMethod.vala"
	return _data15_;
#line 1912 "InputMethod.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 37 "../src/Views/InputMethod.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 1922 "InputMethod.c"
		KeyboardInputMethodPagePage* self;
#line 37 "../src/Views/InputMethod.vala"
		self = _data15_->self;
#line 37 "../src/Views/InputMethod.vala"
		_g_object_unref0 (_data15_->keyboard_shortcut_combobox);
#line 37 "../src/Views/InputMethod.vala"
		_g_object_unref0 (self);
#line 37 "../src/Views/InputMethod.vala"
		g_slice_free (Block15Data, _data15_);
#line 1932 "InputMethod.c"
	}
}

static void
_keyboard_input_method_page_page___lambda61_ (KeyboardInputMethodPagePage* self)
{
#line 61 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_spawn_ibus_daemon (self);
#line 1941 "InputMethod.c"
}

static void
__keyboard_input_method_page_page___lambda61__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                           gpointer self)
{
#line 60 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda61_ ((KeyboardInputMethodPagePage*) self);
#line 1950 "InputMethod.c"
}

static void
_keyboard_input_method_page_page___lambda62_ (KeyboardInputMethodPagePage* self,
                                              GtkListBoxRow* row)
{
	gboolean _tmp0_ = FALSE;
#line 84 "../src/Views/InputMethod.vala"
	if (!self->priv->selection_changing) {
#line 84 "../src/Views/InputMethod.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ());
#line 1962 "InputMethod.c"
	} else {
#line 84 "../src/Views/InputMethod.vala"
		_tmp0_ = FALSE;
#line 1966 "InputMethod.c"
	}
#line 84 "../src/Views/InputMethod.vala"
	if (_tmp0_) {
#line 1970 "InputMethod.c"
		gchar* engine_name = NULL;
		gconstpointer _tmp1_;
		gchar* _tmp2_;
		KeyboardSourceSettings* _tmp3_;
		const gchar* _tmp4_;
		IBusBus* _tmp5_;
		const gchar* _tmp6_;
#line 85 "../src/Views/InputMethod.vala"
		self->priv->selection_changing = TRUE;
#line 86 "../src/Views/InputMethod.vala"
		_tmp1_ = g_object_get_data ((GObject*) row, "engine-name");
#line 86 "../src/Views/InputMethod.vala"
		_tmp2_ = g_strdup ((const gchar*) _tmp1_);
#line 86 "../src/Views/InputMethod.vala"
		engine_name = _tmp2_;
#line 87 "../src/Views/InputMethod.vala"
		_tmp3_ = self->priv->settings;
#line 87 "../src/Views/InputMethod.vala"
		_tmp4_ = engine_name;
#line 87 "../src/Views/InputMethod.vala"
		keyboard_source_settings_set_active_engine_name (_tmp3_, _tmp4_);
#line 88 "../src/Views/InputMethod.vala"
		_tmp5_ = self->priv->bus;
#line 88 "../src/Views/InputMethod.vala"
		_tmp6_ = engine_name;
#line 88 "../src/Views/InputMethod.vala"
		ibus_bus_set_global_engine (_tmp5_, _tmp6_);
#line 89 "../src/Views/InputMethod.vala"
		keyboard_input_method_page_page_update_entry_test_usable (self);
#line 90 "../src/Views/InputMethod.vala"
		self->priv->selection_changing = FALSE;
#line 84 "../src/Views/InputMethod.vala"
		_g_free0 (engine_name);
#line 2004 "InputMethod.c"
	}
}

static void
__keyboard_input_method_page_page___lambda62__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                         GtkListBoxRow* row,
                                                                         gpointer self)
{
#line 81 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda62_ ((KeyboardInputMethodPagePage*) self, row);
#line 2015 "InputMethod.c"
}

static void
_keyboard_input_method_page_page___lambda63_ (KeyboardInputMethodPagePage* self,
                                              const gchar* name)
{
#line 95 "../src/Views/InputMethod.vala"
	g_return_if_fail (name != NULL);
#line 96 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_update_list_box_selected_row (self);
#line 97 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_update_entry_test_usable (self);
#line 2028 "InputMethod.c"
}

static void
__keyboard_input_method_page_page___lambda63__ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                              const gchar* name,
                                                                              gpointer self)
{
#line 95 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda63_ ((KeyboardInputMethodPagePage*) self, name);
#line 2038 "InputMethod.c"
}

static void
_keyboard_input_method_page_page___lambda64_ (KeyboardInputMethodPagePage* self)
{
	KeyboardInputMethodPageAddEnginesPopover* _tmp0_;
#line 205 "../src/Views/InputMethod.vala"
	_tmp0_ = self->priv->add_engines_popover;
#line 205 "../src/Views/InputMethod.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
#line 2049 "InputMethod.c"
}

static void
__keyboard_input_method_page_page___lambda64__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 204 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda64_ ((KeyboardInputMethodPagePage*) self);
#line 2058 "InputMethod.c"
}

static void
_keyboard_input_method_page_page___lambda65_ (KeyboardInputMethodPagePage* self,
                                              const gchar* engine)
{
	KeyboardSourceSettings* _tmp0_;
#line 208 "../src/Views/InputMethod.vala"
	g_return_if_fail (engine != NULL);
#line 209 "../src/Views/InputMethod.vala"
	_tmp0_ = self->priv->settings;
#line 209 "../src/Views/InputMethod.vala"
	if (keyboard_source_settings_add_active_engine (_tmp0_, engine)) {
#line 210 "../src/Views/InputMethod.vala"
		keyboard_input_method_page_page_update_engines_list (self);
#line 2074 "InputMethod.c"
	}
}

static void
__keyboard_input_method_page_page___lambda65__keyboard_input_method_page_add_engines_popover_add_engine (KeyboardInputMethodPageAddEnginesPopover* _sender,
                                                                                                         const gchar* new_engine,
                                                                                                         gpointer self)
{
#line 208 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda65_ ((KeyboardInputMethodPagePage*) self, new_engine);
#line 2085 "InputMethod.c"
}

static void
_g_free0_ (gpointer var)
{
#line 218 "../src/Views/InputMethod.vala"
	var = (g_free (var), NULL);
#line 2093 "InputMethod.c"
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
#line 218 "../src/Views/InputMethod.vala"
	self = *((gchar**) data);
#line 218 "../src/Views/InputMethod.vala"
	_g_free0_ (self);
#line 2104 "InputMethod.c"
}

static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer g = NULL;
	gpointer* _tmp0_;
	gint _tmp0__length1;
	gpointer _tmp1_;
	gpointer result;
#line 6125 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 6126 "glib-2.0.vapi"
	_vala_assert (self->len > index, "length > index");
#line 6127 "glib-2.0.vapi"
	_tmp0_ = self->data;
#line 6127 "glib-2.0.vapi"
	_tmp0__length1 = self->len;
#line 6127 "glib-2.0.vapi"
	_tmp1_ = _tmp0_[index];
#line 6127 "glib-2.0.vapi"
	_tmp0_[index] = NULL;
#line 6127 "glib-2.0.vapi"
	g = _tmp1_;
#line 6128 "glib-2.0.vapi"
	g_array_remove_index (self, index);
#line 6129 "glib-2.0.vapi"
	result = g;
#line 6129 "glib-2.0.vapi"
	return result;
#line 2136 "InputMethod.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 232 "../src/Views/InputMethod.vala"
	if ((*length) == (*size)) {
#line 232 "../src/Views/InputMethod.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 232 "../src/Views/InputMethod.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2151 "InputMethod.c"
	}
#line 232 "../src/Views/InputMethod.vala"
	(*array)[(*length)++] = value;
#line 232 "../src/Views/InputMethod.vala"
	(*array)[*length] = NULL;
#line 2157 "InputMethod.c"
}

static void
_keyboard_input_method_page_page___lambda66_ (KeyboardInputMethodPagePage* self)
{
	gint index = 0;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GArray* removed_lists = NULL;
	GArray* _tmp2_;
	KeyboardSourceSettings* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GArray* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** new_engines = NULL;
	gint new_engines_length1 = 0;
	gint _new_engines_size_ = 0;
	KeyboardSourceSettings* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	KeyboardSourceSettings* _tmp22_;
#line 215 "../src/Views/InputMethod.vala"
	_tmp0_ = self->priv->listbox;
#line 215 "../src/Views/InputMethod.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 215 "../src/Views/InputMethod.vala"
	index = gtk_list_box_row_get_index (_tmp1_);
#line 218 "../src/Views/InputMethod.vala"
	_tmp2_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 218 "../src/Views/InputMethod.vala"
	g_array_set_clear_func (_tmp2_, (GDestroyNotify) _vala_gchar_free_function_content_of);
#line 218 "../src/Views/InputMethod.vala"
	removed_lists = _tmp2_;
#line 219 "../src/Views/InputMethod.vala"
	_tmp3_ = self->priv->settings;
#line 219 "../src/Views/InputMethod.vala"
	_tmp4_ = keyboard_source_settings_get_active_engines (_tmp3_, &_tmp5_);
#line 219 "../src/Views/InputMethod.vala"
	_tmp4__length1 = _tmp5_;
#line 219 "../src/Views/InputMethod.vala"
	_tmp6_ = _tmp4_;
#line 219 "../src/Views/InputMethod.vala"
	_tmp6__length1 = _tmp4__length1;
#line 2206 "InputMethod.c"
	{
		gchar** active_engine_collection = NULL;
		gint active_engine_collection_length1 = 0;
		gint _active_engine_collection_size_ = 0;
		gint active_engine_it = 0;
#line 219 "../src/Views/InputMethod.vala"
		active_engine_collection = _tmp6_;
#line 219 "../src/Views/InputMethod.vala"
		active_engine_collection_length1 = _tmp6__length1;
#line 219 "../src/Views/InputMethod.vala"
		for (active_engine_it = 0; active_engine_it < active_engine_collection_length1; active_engine_it = active_engine_it + 1) {
#line 2218 "InputMethod.c"
			gchar* _tmp7_;
			gchar* active_engine = NULL;
#line 219 "../src/Views/InputMethod.vala"
			_tmp7_ = g_strdup (active_engine_collection[active_engine_it]);
#line 219 "../src/Views/InputMethod.vala"
			active_engine = _tmp7_;
#line 2225 "InputMethod.c"
			{
				GArray* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 220 "../src/Views/InputMethod.vala"
				_tmp8_ = removed_lists;
#line 220 "../src/Views/InputMethod.vala"
				_tmp9_ = active_engine;
#line 220 "../src/Views/InputMethod.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 220 "../src/Views/InputMethod.vala"
				g_array_append_val (_tmp8_, _tmp10_);
#line 219 "../src/Views/InputMethod.vala"
				_g_free0 (active_engine);
#line 2240 "InputMethod.c"
			}
		}
	}
#line 224 "../src/Views/InputMethod.vala"
	_tmp11_ = removed_lists;
#line 224 "../src/Views/InputMethod.vala"
	_tmp12_ = vala_g_array_remove_index (_tmp11_, (guint) index);
#line 224 "../src/Views/InputMethod.vala"
	_tmp13_ = _tmp12_;
#line 224 "../src/Views/InputMethod.vala"
	_g_free0 (_tmp13_);
#line 2252 "InputMethod.c"
	{
		gint i = 0;
#line 231 "../src/Views/InputMethod.vala"
		i = 0;
#line 2257 "InputMethod.c"
		{
			gboolean _tmp14_ = FALSE;
#line 231 "../src/Views/InputMethod.vala"
			_tmp14_ = TRUE;
#line 231 "../src/Views/InputMethod.vala"
			while (TRUE) {
#line 2264 "InputMethod.c"
				GArray* _tmp16_;
				GArray* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
#line 231 "../src/Views/InputMethod.vala"
				if (!_tmp14_) {
#line 2271 "InputMethod.c"
					gint _tmp15_;
#line 231 "../src/Views/InputMethod.vala"
					_tmp15_ = i;
#line 231 "../src/Views/InputMethod.vala"
					i = _tmp15_ + 1;
#line 2277 "InputMethod.c"
				}
#line 231 "../src/Views/InputMethod.vala"
				_tmp14_ = FALSE;
#line 231 "../src/Views/InputMethod.vala"
				_tmp16_ = removed_lists;
#line 231 "../src/Views/InputMethod.vala"
				if (!(((guint) i) < _tmp16_->len)) {
#line 231 "../src/Views/InputMethod.vala"
					break;
#line 2287 "InputMethod.c"
				}
#line 232 "../src/Views/InputMethod.vala"
				_tmp17_ = removed_lists;
#line 232 "../src/Views/InputMethod.vala"
				_tmp18_ = g_array_index (_tmp17_, gchar*, (guint) i);
#line 232 "../src/Views/InputMethod.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 232 "../src/Views/InputMethod.vala"
				_vala_array_add6 (&new_engines, &new_engines_length1, &_new_engines_size_, _tmp19_);
#line 2297 "InputMethod.c"
			}
		}
	}
#line 235 "../src/Views/InputMethod.vala"
	_tmp20_ = self->priv->settings;
#line 235 "../src/Views/InputMethod.vala"
	_tmp21_ = new_engines;
#line 235 "../src/Views/InputMethod.vala"
	_tmp21__length1 = new_engines_length1;
#line 235 "../src/Views/InputMethod.vala"
	keyboard_source_settings_set_active_engines (_tmp20_, _tmp21_, _tmp21__length1);
#line 236 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_update_engines_list (self);
#line 237 "../src/Views/InputMethod.vala"
	_tmp22_ = self->priv->settings;
#line 237 "../src/Views/InputMethod.vala"
	keyboard_source_settings_set_active_index (_tmp22_, (guint) 0);
#line 214 "../src/Views/InputMethod.vala"
	new_engines = (_vala_array_free (new_engines, new_engines_length1, (GDestroyNotify) g_free), NULL);
#line 214 "../src/Views/InputMethod.vala"
	_g_array_unref0 (removed_lists);
#line 2319 "InputMethod.c"
}

static void
__keyboard_input_method_page_page___lambda66__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 214 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda66_ ((KeyboardInputMethodPagePage*) self);
#line 2328 "InputMethod.c"
}

static void
_keyboard_input_method_page_page___lambda67_ (Block15Data* _data15_)
{
	KeyboardInputMethodPagePage* self;
	GtkComboBoxText* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 240 "../src/Views/InputMethod.vala"
	self = _data15_->self;
#line 241 "../src/Views/InputMethod.vala"
	_tmp0_ = _data15_->keyboard_shortcut_combobox;
#line 241 "../src/Views/InputMethod.vala"
	_tmp1_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp0_);
#line 241 "../src/Views/InputMethod.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_set_keyboard_shortcut (self, _tmp2_);
#line 2348 "InputMethod.c"
}

static void
__keyboard_input_method_page_page___lambda67__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self)
{
#line 240 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda67_ (self);
#line 2357 "InputMethod.c"
}

static void
_keyboard_input_method_page_page___lambda68_ (KeyboardInputMethodPagePage* self)
{
#line 248 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_update_list_box_selected_row (self);
#line 249 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_update_entry_test_usable (self);
#line 2367 "InputMethod.c"
}

static void
__keyboard_input_method_page_page___lambda68__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 247 "../src/Views/InputMethod.vala"
	_keyboard_input_method_page_page___lambda68_ ((KeyboardInputMethodPagePage*) self);
#line 2377 "InputMethod.c"
}

static GObject *
keyboard_input_method_page_page_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KeyboardInputMethodPagePage * self;
	Block15Data* _data15_;
	KeyboardSourceSettings* _tmp0_;
	IBusBus* _tmp1_;
	GSettings* _tmp2_;
	GSettings* keyboard_settings = NULL;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GraniteWidgetsAlertView* no_daemon_runnning_alert = NULL;
	GraniteWidgetsAlertView* _tmp9_ = NULL;
	GraniteWidgetsAlertView* _tmp10_;
	GtkStyleContext* _tmp11_;
	GraniteWidgetsAlertView* _tmp12_;
	GraniteWidgetsAlertView* _tmp13_;
	GraniteWidgetsAlertView* _tmp14_ = NULL;
	GraniteWidgetsAlertView* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkListBox* _tmp17_ = NULL;
	GtkListBox* _tmp18_;
	IBusBus* _tmp19_;
	IBusBus* _tmp20_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp21_ = NULL;
	GtkScrolledWindow* _tmp22_;
	GtkListBox* _tmp23_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp24_;
	GtkMenuButton* add_button = NULL;
	GtkImage* _tmp25_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp26_;
	GtkPopover* _tmp27_;
	gchar* _tmp28_;
	GtkMenuButton* _tmp29_ = NULL;
	GtkImage* _tmp30_;
	gchar* _tmp31_;
	GtkMenuButton* _tmp32_ = NULL;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp33_;
	GtkActionBar* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkActionBar* _tmp36_;
	GtkMenuButton* _tmp37_;
	GtkActionBar* _tmp38_;
	GtkMenuButton* _tmp39_;
	GtkGrid* left_grid = NULL;
	GtkGrid* _tmp40_;
	GtkGrid* _tmp41_;
	GtkScrolledWindow* _tmp42_;
	GtkGrid* _tmp43_;
	GtkActionBar* _tmp44_;
	GtkFrame* display = NULL;
	GtkFrame* _tmp45_;
	GtkFrame* _tmp46_;
	GtkGrid* _tmp47_;
	GtkLabel* keyboard_shortcut_label = NULL;
	GtkLabel* _tmp48_ = NULL;
	GtkComboBoxText* _tmp49_ = NULL;
	GtkComboBoxText* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GtkComboBoxText* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	GtkComboBoxText* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	GtkComboBoxText* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	GtkLabel* show_ibus_panel_label = NULL;
	GtkLabel* _tmp62_ = NULL;
	GtkComboBoxText* show_ibus_panel_combobox = NULL;
	GtkComboBoxText* _tmp63_ = NULL;
	GtkComboBoxText* _tmp64_;
	GtkComboBoxText* _tmp65_;
	GtkComboBoxText* _tmp66_;
	GtkLabel* embed_preedit_text_label = NULL;
	GtkLabel* _tmp67_ = NULL;
	GtkSwitch* embed_preedit_text_switch = NULL;
	GtkSwitch* _tmp68_ = NULL;
	GtkEntry* _tmp69_ = NULL;
	GtkGrid* right_grid = NULL;
	GtkGrid* _tmp70_ = NULL;
	GtkGrid* _tmp71_;
	GtkLabel* _tmp72_;
	GtkGrid* _tmp73_;
	GtkComboBoxText* _tmp74_;
	GtkGrid* _tmp75_;
	GtkLabel* _tmp76_;
	GtkGrid* _tmp77_;
	GtkComboBoxText* _tmp78_;
	GtkGrid* _tmp79_;
	GtkLabel* _tmp80_;
	GtkGrid* _tmp81_;
	GtkSwitch* _tmp82_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp83_ = NULL;
	GtkGrid* _tmp84_;
	GtkFrame* _tmp85_;
	GtkGrid* _tmp86_;
	GtkGrid* _tmp87_;
	GtkGrid* _tmp88_;
	GtkEntry* _tmp89_;
	GtkStack* _tmp90_;
	GtkStack* _tmp91_;
	GraniteWidgetsAlertView* _tmp92_;
	GtkStack* _tmp93_;
	GraniteWidgetsAlertView* _tmp94_;
	GtkStack* _tmp95_;
	GtkGrid* _tmp96_;
	GtkStack* _tmp97_;
	GtkStack* _tmp98_;
	GtkMenuButton* _tmp99_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp100_;
	GtkMenuButton* _tmp101_;
	GtkComboBoxText* _tmp102_;
	GSettings* _tmp103_;
	GtkComboBoxText* _tmp104_;
	GSettings* _tmp105_;
	GtkSwitch* _tmp106_;
	KeyboardSourceSettings* _tmp107_;
#line 37 "../src/Views/InputMethod.vala"
	parent_class = G_OBJECT_CLASS (keyboard_input_method_page_page_parent_class);
#line 37 "../src/Views/InputMethod.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/Views/InputMethod.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE, KeyboardInputMethodPagePage);
#line 37 "../src/Views/InputMethod.vala"
	_data15_ = g_slice_new0 (Block15Data);
#line 37 "../src/Views/InputMethod.vala"
	_data15_->_ref_count_ = 1;
#line 37 "../src/Views/InputMethod.vala"
	_data15_->self = g_object_ref (self);
#line 38 "../src/Views/InputMethod.vala"
	_tmp0_ = keyboard_source_settings_get_instance ();
#line 38 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->settings);
#line 38 "../src/Views/InputMethod.vala"
	self->priv->settings = _tmp0_;
#line 39 "../src/Views/InputMethod.vala"
	_tmp1_ = ibus_bus_new ();
#line 39 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp1_);
#line 39 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->bus);
#line 39 "../src/Views/InputMethod.vala"
	self->priv->bus = _tmp1_;
#line 40 "../src/Views/InputMethod.vala"
	_tmp2_ = g_settings_new ("org.freedesktop.ibus.panel");
#line 40 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->ibus_panel_settings);
#line 40 "../src/Views/InputMethod.vala"
	self->priv->ibus_panel_settings = _tmp2_;
#line 43 "../src/Views/InputMethod.vala"
	_tmp3_ = g_settings_new ("io.elementary.switchboard.keyboard");
#line 43 "../src/Views/InputMethod.vala"
	keyboard_settings = _tmp3_;
#line 44 "../src/Views/InputMethod.vala"
	_tmp4_ = keyboard_settings;
#line 44 "../src/Views/InputMethod.vala"
	if (g_settings_get_boolean (_tmp4_, "first-launch")) {
#line 2547 "InputMethod.c"
		GSettings* _tmp5_;
		GSettings* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 45 "../src/Views/InputMethod.vala"
		_tmp5_ = keyboard_settings;
#line 45 "../src/Views/InputMethod.vala"
		g_settings_set_boolean (_tmp5_, "first-launch", FALSE);
#line 46 "../src/Views/InputMethod.vala"
		_tmp6_ = keyboard_plug_ibus_general_settings;
#line 46 "../src/Views/InputMethod.vala"
		_tmp7_ = g_new0 (gchar*, 0 + 1);
#line 46 "../src/Views/InputMethod.vala"
		_tmp8_ = _tmp7_;
#line 46 "../src/Views/InputMethod.vala"
		_tmp8__length1 = 0;
#line 46 "../src/Views/InputMethod.vala"
		g_settings_set_strv (_tmp6_, "preload-engines", _tmp8_);
#line 46 "../src/Views/InputMethod.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 2569 "InputMethod.c"
	}
#line 50 "../src/Views/InputMethod.vala"
	_tmp9_ = granite_widgets_alert_view_new (_ ("IBus Daemon is not running"), _ ("You need to run the IBus daemon to enable or configure input method en" \
"gines."), "dialog-information");
#line 50 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 50 "../src/Views/InputMethod.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 50 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp9_);
#line 50 "../src/Views/InputMethod.vala"
	no_daemon_runnning_alert = _tmp9_;
#line 58 "../src/Views/InputMethod.vala"
	_tmp10_ = no_daemon_runnning_alert;
#line 58 "../src/Views/InputMethod.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 58 "../src/Views/InputMethod.vala"
	gtk_style_context_remove_class (_tmp11_, GTK_STYLE_CLASS_VIEW);
#line 59 "../src/Views/InputMethod.vala"
	_tmp12_ = no_daemon_runnning_alert;
#line 59 "../src/Views/InputMethod.vala"
	granite_widgets_alert_view_show_action (_tmp12_, _ ("Start IBus Daemon"));
#line 60 "../src/Views/InputMethod.vala"
	_tmp13_ = no_daemon_runnning_alert;
#line 60 "../src/Views/InputMethod.vala"
	g_signal_connect_object (_tmp13_, "action-activated", (GCallback) __keyboard_input_method_page_page___lambda61__granite_widgets_alert_view_action_activated, self, 0);
#line 65 "../src/Views/InputMethod.vala"
	_tmp14_ = granite_widgets_alert_view_new (_ ("Could not start the IBus daemon"), "", "dialog-error");
#line 65 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 65 "../src/Views/InputMethod.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 65 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp14_);
#line 65 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->spawn_failed_alert);
#line 65 "../src/Views/InputMethod.vala"
	self->priv->spawn_failed_alert = _tmp14_;
#line 74 "../src/Views/InputMethod.vala"
	_tmp15_ = self->priv->spawn_failed_alert;
#line 74 "../src/Views/InputMethod.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 74 "../src/Views/InputMethod.vala"
	gtk_style_context_remove_class (_tmp16_, GTK_STYLE_CLASS_VIEW);
#line 77 "../src/Views/InputMethod.vala"
	_tmp17_ = (GtkListBox*) gtk_list_box_new ();
#line 77 "../src/Views/InputMethod.vala"
	gtk_list_box_set_selection_mode (_tmp17_, GTK_SELECTION_BROWSE);
#line 77 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp17_);
#line 77 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->listbox);
#line 77 "../src/Views/InputMethod.vala"
	self->priv->listbox = _tmp17_;
#line 81 "../src/Views/InputMethod.vala"
	_tmp18_ = self->priv->listbox;
#line 81 "../src/Views/InputMethod.vala"
	g_signal_connect_object (_tmp18_, "row-selected", (GCallback) __keyboard_input_method_page_page___lambda62__gtk_list_box_row_selected, self, 0);
#line 94 "../src/Views/InputMethod.vala"
	_tmp19_ = self->priv->bus;
#line 94 "../src/Views/InputMethod.vala"
	ibus_bus_set_watch_ibus_signal (_tmp19_, TRUE);
#line 95 "../src/Views/InputMethod.vala"
	_tmp20_ = self->priv->bus;
#line 95 "../src/Views/InputMethod.vala"
	g_signal_connect_object (_tmp20_, "global-engine-changed", (GCallback) __keyboard_input_method_page_page___lambda63__ibus_bus_global_engine_changed, self, 0);
#line 100 "../src/Views/InputMethod.vala"
	_tmp21_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 100 "../src/Views/InputMethod.vala"
	g_object_set (_tmp21_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 100 "../src/Views/InputMethod.vala"
	g_object_set ((GtkWidget*) _tmp21_, "expand", TRUE, NULL);
#line 100 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp21_);
#line 100 "../src/Views/InputMethod.vala"
	scroll = _tmp21_;
#line 104 "../src/Views/InputMethod.vala"
	_tmp22_ = scroll;
#line 104 "../src/Views/InputMethod.vala"
	_tmp23_ = self->priv->listbox;
#line 104 "../src/Views/InputMethod.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 106 "../src/Views/InputMethod.vala"
	_tmp24_ = keyboard_input_method_page_add_engines_popover_new ();
#line 106 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp24_);
#line 106 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->add_engines_popover);
#line 106 "../src/Views/InputMethod.vala"
	self->priv->add_engines_popover = _tmp24_;
#line 108 "../src/Views/InputMethod.vala"
	_tmp25_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 108 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp25_);
#line 108 "../src/Views/InputMethod.vala"
	_tmp26_ = self->priv->add_engines_popover;
#line 108 "../src/Views/InputMethod.vala"
	_tmp27_ = _g_object_ref0 ((GtkPopover*) _tmp26_);
#line 108 "../src/Views/InputMethod.vala"
	_tmp28_ = g_strdup (_ ("Add…"));
#line 108 "../src/Views/InputMethod.vala"
	_tmp29_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 108 "../src/Views/InputMethod.vala"
	gtk_button_set_image ((GtkButton*) _tmp29_, (GtkWidget*) _tmp25_);
#line 108 "../src/Views/InputMethod.vala"
	_g_object_unref0 (_tmp25_);
#line 108 "../src/Views/InputMethod.vala"
	gtk_menu_button_set_popover (_tmp29_, _tmp27_);
#line 108 "../src/Views/InputMethod.vala"
	_g_object_unref0 (_tmp27_);
#line 108 "../src/Views/InputMethod.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _tmp28_);
#line 108 "../src/Views/InputMethod.vala"
	_g_free0 (_tmp28_);
#line 108 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp29_);
#line 108 "../src/Views/InputMethod.vala"
	add_button = _tmp29_;
#line 114 "../src/Views/InputMethod.vala"
	_tmp30_ = (GtkImage*) gtk_image_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 114 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp30_);
#line 114 "../src/Views/InputMethod.vala"
	_tmp31_ = g_strdup (_ ("Remove"));
#line 114 "../src/Views/InputMethod.vala"
	_tmp32_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 114 "../src/Views/InputMethod.vala"
	gtk_button_set_image ((GtkButton*) _tmp32_, (GtkWidget*) _tmp30_);
#line 114 "../src/Views/InputMethod.vala"
	_g_object_unref0 (_tmp30_);
#line 114 "../src/Views/InputMethod.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _tmp31_);
#line 114 "../src/Views/InputMethod.vala"
	_g_free0 (_tmp31_);
#line 114 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp32_);
#line 114 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 114 "../src/Views/InputMethod.vala"
	self->priv->remove_button = _tmp32_;
#line 119 "../src/Views/InputMethod.vala"
	_tmp33_ = (GtkActionBar*) gtk_action_bar_new ();
#line 119 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp33_);
#line 119 "../src/Views/InputMethod.vala"
	actionbar = _tmp33_;
#line 120 "../src/Views/InputMethod.vala"
	_tmp34_ = actionbar;
#line 120 "../src/Views/InputMethod.vala"
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 120 "../src/Views/InputMethod.vala"
	gtk_style_context_add_class (_tmp35_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
#line 121 "../src/Views/InputMethod.vala"
	_tmp36_ = actionbar;
#line 121 "../src/Views/InputMethod.vala"
	_tmp37_ = add_button;
#line 121 "../src/Views/InputMethod.vala"
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 122 "../src/Views/InputMethod.vala"
	_tmp38_ = actionbar;
#line 122 "../src/Views/InputMethod.vala"
	_tmp39_ = self->priv->remove_button;
#line 122 "../src/Views/InputMethod.vala"
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 124 "../src/Views/InputMethod.vala"
	_tmp40_ = (GtkGrid*) gtk_grid_new ();
#line 124 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp40_);
#line 124 "../src/Views/InputMethod.vala"
	left_grid = _tmp40_;
#line 125 "../src/Views/InputMethod.vala"
	_tmp41_ = left_grid;
#line 125 "../src/Views/InputMethod.vala"
	_tmp42_ = scroll;
#line 125 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp42_, 0, 0, 1, 1);
#line 126 "../src/Views/InputMethod.vala"
	_tmp43_ = left_grid;
#line 126 "../src/Views/InputMethod.vala"
	_tmp44_ = actionbar;
#line 126 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp43_, (GtkWidget*) _tmp44_, 0, 1, 1, 1);
#line 128 "../src/Views/InputMethod.vala"
	_tmp45_ = (GtkFrame*) gtk_frame_new (NULL);
#line 128 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp45_);
#line 128 "../src/Views/InputMethod.vala"
	display = _tmp45_;
#line 129 "../src/Views/InputMethod.vala"
	_tmp46_ = display;
#line 129 "../src/Views/InputMethod.vala"
	_tmp47_ = left_grid;
#line 129 "../src/Views/InputMethod.vala"
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 131 "../src/Views/InputMethod.vala"
	_tmp48_ = (GtkLabel*) gtk_label_new (_ ("Switch engines:"));
#line 131 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp48_, GTK_ALIGN_END);
#line 131 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp48_);
#line 131 "../src/Views/InputMethod.vala"
	keyboard_shortcut_label = _tmp48_;
#line 135 "../src/Views/InputMethod.vala"
	_tmp49_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 135 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp49_, GTK_ALIGN_START);
#line 135 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp49_);
#line 135 "../src/Views/InputMethod.vala"
	_data15_->keyboard_shortcut_combobox = _tmp49_;
#line 138 "../src/Views/InputMethod.vala"
	_tmp50_ = _data15_->keyboard_shortcut_combobox;
#line 138 "../src/Views/InputMethod.vala"
	_tmp51_ = granite_accel_to_string ("<Alt>space");
#line 138 "../src/Views/InputMethod.vala"
	_tmp52_ = _tmp51_;
#line 138 "../src/Views/InputMethod.vala"
	gtk_combo_box_text_append (_tmp50_, "alt-space", _tmp52_);
#line 138 "../src/Views/InputMethod.vala"
	_g_free0 (_tmp52_);
#line 139 "../src/Views/InputMethod.vala"
	_tmp53_ = _data15_->keyboard_shortcut_combobox;
#line 139 "../src/Views/InputMethod.vala"
	_tmp54_ = granite_accel_to_string ("<Control>space");
#line 139 "../src/Views/InputMethod.vala"
	_tmp55_ = _tmp54_;
#line 139 "../src/Views/InputMethod.vala"
	gtk_combo_box_text_append (_tmp53_, "ctl-space", _tmp55_);
#line 139 "../src/Views/InputMethod.vala"
	_g_free0 (_tmp55_);
#line 140 "../src/Views/InputMethod.vala"
	_tmp56_ = _data15_->keyboard_shortcut_combobox;
#line 140 "../src/Views/InputMethod.vala"
	_tmp57_ = granite_accel_to_string ("<Shift>space");
#line 140 "../src/Views/InputMethod.vala"
	_tmp58_ = _tmp57_;
#line 140 "../src/Views/InputMethod.vala"
	gtk_combo_box_text_append (_tmp56_, "shift-space", _tmp58_);
#line 140 "../src/Views/InputMethod.vala"
	_g_free0 (_tmp58_);
#line 141 "../src/Views/InputMethod.vala"
	_tmp59_ = _data15_->keyboard_shortcut_combobox;
#line 141 "../src/Views/InputMethod.vala"
	_tmp60_ = keyboard_input_method_page_page_get_keyboard_shortcut (self);
#line 141 "../src/Views/InputMethod.vala"
	_tmp61_ = _tmp60_;
#line 141 "../src/Views/InputMethod.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp59_, _tmp61_);
#line 141 "../src/Views/InputMethod.vala"
	_g_free0 (_tmp61_);
#line 143 "../src/Views/InputMethod.vala"
	_tmp62_ = (GtkLabel*) gtk_label_new (_ ("Show property panel:"));
#line 143 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp62_, GTK_ALIGN_END);
#line 143 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp62_);
#line 143 "../src/Views/InputMethod.vala"
	show_ibus_panel_label = _tmp62_;
#line 147 "../src/Views/InputMethod.vala"
	_tmp63_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 147 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp63_, GTK_ALIGN_START);
#line 147 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp63_);
#line 147 "../src/Views/InputMethod.vala"
	show_ibus_panel_combobox = _tmp63_;
#line 150 "../src/Views/InputMethod.vala"
	_tmp64_ = show_ibus_panel_combobox;
#line 150 "../src/Views/InputMethod.vala"
	gtk_combo_box_text_append (_tmp64_, "none", _ ("Do not show"));
#line 151 "../src/Views/InputMethod.vala"
	_tmp65_ = show_ibus_panel_combobox;
#line 151 "../src/Views/InputMethod.vala"
	gtk_combo_box_text_append (_tmp65_, "auto-hide", _ ("Auto hide"));
#line 152 "../src/Views/InputMethod.vala"
	_tmp66_ = show_ibus_panel_combobox;
#line 152 "../src/Views/InputMethod.vala"
	gtk_combo_box_text_append (_tmp66_, "always-show", _ ("Always show"));
#line 154 "../src/Views/InputMethod.vala"
	_tmp67_ = (GtkLabel*) gtk_label_new (_ ("Embed preedit text in application window:"));
#line 154 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp67_, GTK_ALIGN_END);
#line 154 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp67_);
#line 154 "../src/Views/InputMethod.vala"
	embed_preedit_text_label = _tmp67_;
#line 158 "../src/Views/InputMethod.vala"
	_tmp68_ = (GtkSwitch*) gtk_switch_new ();
#line 158 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp68_, GTK_ALIGN_START);
#line 158 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp68_);
#line 158 "../src/Views/InputMethod.vala"
	embed_preedit_text_switch = _tmp68_;
#line 162 "../src/Views/InputMethod.vala"
	_tmp69_ = (GtkEntry*) gtk_entry_new ();
#line 162 "../src/Views/InputMethod.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp69_, TRUE);
#line 162 "../src/Views/InputMethod.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp69_, GTK_ALIGN_END);
#line 162 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp69_);
#line 162 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->entry_test);
#line 162 "../src/Views/InputMethod.vala"
	self->priv->entry_test = _tmp69_;
#line 167 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_update_entry_test_usable (self);
#line 169 "../src/Views/InputMethod.vala"
	_tmp70_ = (GtkGrid*) gtk_grid_new ();
#line 169 "../src/Views/InputMethod.vala"
	gtk_grid_set_column_spacing (_tmp70_, 12);
#line 169 "../src/Views/InputMethod.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp70_, GTK_ALIGN_CENTER);
#line 169 "../src/Views/InputMethod.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp70_, TRUE);
#line 169 "../src/Views/InputMethod.vala"
	g_object_set ((GtkWidget*) _tmp70_, "margin", 12, NULL);
#line 169 "../src/Views/InputMethod.vala"
	gtk_grid_set_row_spacing (_tmp70_, 12);
#line 169 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp70_);
#line 169 "../src/Views/InputMethod.vala"
	right_grid = _tmp70_;
#line 176 "../src/Views/InputMethod.vala"
	_tmp71_ = right_grid;
#line 176 "../src/Views/InputMethod.vala"
	_tmp72_ = keyboard_shortcut_label;
#line 176 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 0, 0, 1, 1);
#line 177 "../src/Views/InputMethod.vala"
	_tmp73_ = right_grid;
#line 177 "../src/Views/InputMethod.vala"
	_tmp74_ = _data15_->keyboard_shortcut_combobox;
#line 177 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 1, 0, 1, 1);
#line 178 "../src/Views/InputMethod.vala"
	_tmp75_ = right_grid;
#line 178 "../src/Views/InputMethod.vala"
	_tmp76_ = show_ibus_panel_label;
#line 178 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 0, 1, 1, 1);
#line 179 "../src/Views/InputMethod.vala"
	_tmp77_ = right_grid;
#line 179 "../src/Views/InputMethod.vala"
	_tmp78_ = show_ibus_panel_combobox;
#line 179 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 1, 1, 1, 1);
#line 180 "../src/Views/InputMethod.vala"
	_tmp79_ = right_grid;
#line 180 "../src/Views/InputMethod.vala"
	_tmp80_ = embed_preedit_text_label;
#line 180 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 0, 2, 1, 1);
#line 181 "../src/Views/InputMethod.vala"
	_tmp81_ = right_grid;
#line 181 "../src/Views/InputMethod.vala"
	_tmp82_ = embed_preedit_text_switch;
#line 181 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, 1, 2, 1, 1);
#line 183 "../src/Views/InputMethod.vala"
	_tmp83_ = (GtkGrid*) gtk_grid_new ();
#line 183 "../src/Views/InputMethod.vala"
	gtk_grid_set_column_spacing (_tmp83_, 12);
#line 183 "../src/Views/InputMethod.vala"
	gtk_grid_set_row_spacing (_tmp83_, 12);
#line 183 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp83_);
#line 183 "../src/Views/InputMethod.vala"
	main_grid = _tmp83_;
#line 187 "../src/Views/InputMethod.vala"
	_tmp84_ = main_grid;
#line 187 "../src/Views/InputMethod.vala"
	_tmp85_ = display;
#line 187 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp84_, (GtkWidget*) _tmp85_, 0, 0, 1, 2);
#line 188 "../src/Views/InputMethod.vala"
	_tmp86_ = main_grid;
#line 188 "../src/Views/InputMethod.vala"
	_tmp87_ = right_grid;
#line 188 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp86_, (GtkWidget*) _tmp87_, 1, 0, 1, 1);
#line 189 "../src/Views/InputMethod.vala"
	_tmp88_ = main_grid;
#line 189 "../src/Views/InputMethod.vala"
	_tmp89_ = self->priv->entry_test;
#line 189 "../src/Views/InputMethod.vala"
	gtk_grid_attach (_tmp88_, (GtkWidget*) _tmp89_, 1, 1, 1, 1);
#line 191 "../src/Views/InputMethod.vala"
	_tmp90_ = (GtkStack*) gtk_stack_new ();
#line 191 "../src/Views/InputMethod.vala"
	g_object_ref_sink (_tmp90_);
#line 191 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->stack);
#line 191 "../src/Views/InputMethod.vala"
	self->priv->stack = _tmp90_;
#line 192 "../src/Views/InputMethod.vala"
	_tmp91_ = self->priv->stack;
#line 192 "../src/Views/InputMethod.vala"
	_tmp92_ = no_daemon_runnning_alert;
#line 192 "../src/Views/InputMethod.vala"
	gtk_stack_add_named (_tmp91_, (GtkWidget*) _tmp92_, "no_daemon_runnning_view");
#line 193 "../src/Views/InputMethod.vala"
	_tmp93_ = self->priv->stack;
#line 193 "../src/Views/InputMethod.vala"
	_tmp94_ = self->priv->spawn_failed_alert;
#line 193 "../src/Views/InputMethod.vala"
	gtk_stack_add_named (_tmp93_, (GtkWidget*) _tmp94_, "spawn_failed_view");
#line 194 "../src/Views/InputMethod.vala"
	_tmp95_ = self->priv->stack;
#line 194 "../src/Views/InputMethod.vala"
	_tmp96_ = main_grid;
#line 194 "../src/Views/InputMethod.vala"
	gtk_stack_add_named (_tmp95_, (GtkWidget*) _tmp96_, "main_view");
#line 195 "../src/Views/InputMethod.vala"
	_tmp97_ = self->priv->stack;
#line 195 "../src/Views/InputMethod.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp97_);
#line 197 "../src/Views/InputMethod.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 12);
#line 198 "../src/Views/InputMethod.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 12);
#line 199 "../src/Views/InputMethod.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 12);
#line 200 "../src/Views/InputMethod.vala"
	_tmp98_ = self->priv->stack;
#line 200 "../src/Views/InputMethod.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp98_);
#line 202 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_set_visible_view (self, "");
#line 204 "../src/Views/InputMethod.vala"
	_tmp99_ = add_button;
#line 204 "../src/Views/InputMethod.vala"
	g_signal_connect_object ((GtkButton*) _tmp99_, "clicked", (GCallback) __keyboard_input_method_page_page___lambda64__gtk_button_clicked, self, 0);
#line 208 "../src/Views/InputMethod.vala"
	_tmp100_ = self->priv->add_engines_popover;
#line 208 "../src/Views/InputMethod.vala"
	g_signal_connect_object (_tmp100_, "add-engine", (GCallback) __keyboard_input_method_page_page___lambda65__keyboard_input_method_page_add_engines_popover_add_engine, self, 0);
#line 214 "../src/Views/InputMethod.vala"
	_tmp101_ = self->priv->remove_button;
#line 214 "../src/Views/InputMethod.vala"
	g_signal_connect_object ((GtkButton*) _tmp101_, "clicked", (GCallback) __keyboard_input_method_page_page___lambda66__gtk_button_clicked, self, 0);
#line 240 "../src/Views/InputMethod.vala"
	_tmp102_ = _data15_->keyboard_shortcut_combobox;
#line 240 "../src/Views/InputMethod.vala"
	g_signal_connect_data ((GtkComboBox*) _tmp102_, "changed", (GCallback) __keyboard_input_method_page_page___lambda67__gtk_combo_box_changed, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 244 "../src/Views/InputMethod.vala"
	_tmp103_ = self->priv->ibus_panel_settings;
#line 244 "../src/Views/InputMethod.vala"
	_tmp104_ = show_ibus_panel_combobox;
#line 244 "../src/Views/InputMethod.vala"
	g_settings_bind (_tmp103_, "show", (GObject*) _tmp104_, "active", G_SETTINGS_BIND_DEFAULT);
#line 245 "../src/Views/InputMethod.vala"
	_tmp105_ = keyboard_plug_ibus_general_settings;
#line 245 "../src/Views/InputMethod.vala"
	_tmp106_ = embed_preedit_text_switch;
#line 245 "../src/Views/InputMethod.vala"
	g_settings_bind (_tmp105_, "embed-preedit-text", (GObject*) _tmp106_, "active", G_SETTINGS_BIND_DEFAULT);
#line 247 "../src/Views/InputMethod.vala"
	_tmp107_ = self->priv->settings;
#line 247 "../src/Views/InputMethod.vala"
	g_signal_connect_object ((GObject*) _tmp107_, "notify::active-index", (GCallback) __keyboard_input_method_page_page___lambda68__g_object_notify, self, 0);
#line 252 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_update_list_box_selected_row (self);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (main_grid);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (right_grid);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (embed_preedit_text_switch);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (embed_preedit_text_label);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (show_ibus_panel_combobox);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (show_ibus_panel_label);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (keyboard_shortcut_label);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (display);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (left_grid);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (actionbar);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (add_button);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (scroll);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (no_daemon_runnning_alert);
#line 37 "../src/Views/InputMethod.vala"
	_g_object_unref0 (keyboard_settings);
#line 37 "../src/Views/InputMethod.vala"
	block15_data_unref (_data15_);
#line 37 "../src/Views/InputMethod.vala"
	_data15_ = NULL;
#line 37 "../src/Views/InputMethod.vala"
	return obj;
#line 3067 "InputMethod.c"
}

static void
keyboard_input_method_page_page_class_init (KeyboardInputMethodPagePageClass * klass,
                                            gpointer klass_data)
{
#line 18 "../src/Views/InputMethod.vala"
	keyboard_input_method_page_page_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Views/InputMethod.vala"
	g_type_class_adjust_private_offset (klass, &KeyboardInputMethodPagePage_private_offset);
#line 18 "../src/Views/InputMethod.vala"
	G_OBJECT_CLASS (klass)->constructor = keyboard_input_method_page_page_constructor;
#line 18 "../src/Views/InputMethod.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_input_method_page_page_finalize;
#line 3082 "InputMethod.c"
}

static void
keyboard_input_method_page_page_instance_init (KeyboardInputMethodPagePage * self,
                                               gpointer klass)
{
#line 18 "../src/Views/InputMethod.vala"
	self->priv = keyboard_input_method_page_page_get_instance_private (self);
#line 21 "../src/Views/InputMethod.vala"
	self->priv->selection_changing = FALSE;
#line 3093 "InputMethod.c"
}

static void
keyboard_input_method_page_page_finalize (GObject * obj)
{
	KeyboardInputMethodPagePage * self;
#line 18 "../src/Views/InputMethod.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE, KeyboardInputMethodPagePage);
#line 19 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->bus);
#line 20 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->ibus_panel_settings);
#line 24 "../src/Views/InputMethod.vala"
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
#line 29 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->spawn_failed_alert);
#line 30 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->listbox);
#line 31 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->settings);
#line 32 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 33 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->add_engines_popover);
#line 34 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->stack);
#line 35 "../src/Views/InputMethod.vala"
	_g_object_unref0 (self->priv->entry_test);
#line 18 "../src/Views/InputMethod.vala"
	G_OBJECT_CLASS (keyboard_input_method_page_page_parent_class)->finalize (obj);
#line 3124 "InputMethod.c"
}

static GType
keyboard_input_method_page_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardInputMethodPagePageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_input_method_page_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardInputMethodPagePage), 0, (GInstanceInitFunc) keyboard_input_method_page_page_instance_init, NULL };
	GType keyboard_input_method_page_page_type_id;
	keyboard_input_method_page_page_type_id = g_type_register_static (gtk_grid_get_type (), "KeyboardInputMethodPagePage", &g_define_type_info, 0);
	KeyboardInputMethodPagePage_private_offset = g_type_add_instance_private (keyboard_input_method_page_page_type_id, sizeof (KeyboardInputMethodPagePagePrivate));
	return keyboard_input_method_page_page_type_id;
}

GType
keyboard_input_method_page_page_get_type (void)
{
	static volatile gsize keyboard_input_method_page_page_type_id__once = 0;
	if (g_once_init_enter (&keyboard_input_method_page_page_type_id__once)) {
		GType keyboard_input_method_page_page_type_id;
		keyboard_input_method_page_page_type_id = keyboard_input_method_page_page_get_type_once ();
		g_once_init_leave (&keyboard_input_method_page_page_type_id__once, keyboard_input_method_page_page_type_id);
	}
	return keyboard_input_method_page_page_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

