/* Display.c generated by valac 0.56.10, the Vala compiler
 * generated from Display.vala, do not modify */

/*
* Copyright 2017-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* widget to display/add/remove/move keyboard layouts*/

#include "keyboard.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

#define KEYBOARD_TYPE_SOURCE_SETTINGS (keyboard_source_settings_get_type ())
#define KEYBOARD_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings))
#define KEYBOARD_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))
#define KEYBOARD_IS_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_IS_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_SOURCE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))

typedef struct _KeyboardSourceSettings KeyboardSourceSettings;
typedef struct _KeyboardSourceSettingsClass KeyboardSourceSettingsClass;
enum  {
	KEYBOARD_LAYOUT_PAGE_DISPLAY_0_PROPERTY,
	KEYBOARD_LAYOUT_PAGE_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* keyboard_layout_page_display_properties[KEYBOARD_LAYOUT_PAGE_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _KeyboardLayoutPageDisplayPrivate {
	KeyboardSourceSettings* settings;
	GtkTreeView* tree;
	GtkButton* up_button;
	GtkButton* down_button;
	GtkButton* add_button;
	GtkButton* remove_button;
	gboolean cursor_changing;
};

struct _Block4Data {
	int _ref_count_;
	KeyboardLayoutPageDisplay* self;
	guint index;
};

struct _Block5Data {
	int _ref_count_;
	KeyboardLayoutPageDisplay* self;
	GtkListStore* list_store;
	GtkTreeIter* iter;
	guint index;
};

static gint KeyboardLayoutPageDisplay_private_offset;
static gpointer keyboard_layout_page_display_parent_class = NULL;

VALA_EXTERN GType keyboard_source_settings_get_type (void) G_GNUC_CONST ;
static void keyboard_layout_page_display_update_buttons (KeyboardLayoutPageDisplay* self);
static gint keyboard_layout_page_display_get_cursor_index (KeyboardLayoutPageDisplay* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void keyboard_layout_page_display_update_cursor (KeyboardLayoutPageDisplay* self);
VALA_EXTERN KeyboardInputSource* keyboard_source_settings_get_active_input_source (KeyboardSourceSettings* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean ___lambda12_ (Block4Data* _data4_,
                       GtkTreeModel* model,
                       GtkTreePath* path,
                       GtkTreeIter* iter);
VALA_EXTERN guint keyboard_source_settings_get_active_index (KeyboardSourceSettings* self);
static gboolean ____lambda12__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* iter,
                                                    gpointer self);
static void keyboard_layout_page_display_rebuild_list (KeyboardLayoutPageDisplay* self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN void keyboard_source_settings_foreach_layout (KeyboardSourceSettings* self,
                                              GFunc func,
                                              gpointer func_target);
static void __lambda13_ (Block5Data* _data5_,
                  KeyboardInputSource* input_source);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static void ___lambda13__gfunc (gconstpointer data,
                         gpointer self);
static GObject * keyboard_layout_page_display_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
VALA_EXTERN KeyboardSourceSettings* keyboard_source_settings_get_instance (void);
static void _keyboard_layout_page_display___lambda14_ (KeyboardLayoutPageDisplay* self);
static void __lambda26_ (KeyboardLayoutPageDisplay* self,
                  const gchar* layout,
                  const gchar* variant);
VALA_EXTERN gboolean keyboard_source_settings_add_layout (KeyboardSourceSettings* self,
                                              KeyboardInputSource* new_layout);
static void ___lambda26__keyboard_layout_page_add_layout_dialog_layout_added (KeyboardLayoutPageAddLayoutDialog* _sender,
                                                                       const gchar* language,
                                                                       const gchar* layout,
                                                                       gpointer self);
static void __keyboard_layout_page_display___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _keyboard_layout_page_display___lambda27_ (KeyboardLayoutPageDisplay* self);
VALA_EXTERN void keyboard_source_settings_remove_active_layout (KeyboardSourceSettings* self);
static void __keyboard_layout_page_display___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _keyboard_layout_page_display___lambda28_ (KeyboardLayoutPageDisplay* self);
VALA_EXTERN void keyboard_source_settings_move_active_layout_up (KeyboardSourceSettings* self);
static void __keyboard_layout_page_display___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _keyboard_layout_page_display___lambda29_ (KeyboardLayoutPageDisplay* self);
VALA_EXTERN void keyboard_source_settings_move_active_layout_down (KeyboardSourceSettings* self);
static void __keyboard_layout_page_display___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _keyboard_layout_page_display___lambda30_ (KeyboardLayoutPageDisplay* self);
VALA_EXTERN void keyboard_source_settings_set_active_index (KeyboardSourceSettings* self,
                                                guint value);
static void __keyboard_layout_page_display___lambda30__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                                                              gpointer self);
static void _keyboard_layout_page_display___lambda31_ (KeyboardLayoutPageDisplay* self);
static void __keyboard_layout_page_display___lambda31__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void _keyboard_layout_page_display_rebuild_list_keyboard_source_settings_external_layout_change (KeyboardSourceSettings* _sender,
                                                                                                 gpointer self);
static void keyboard_layout_page_display_finalize (GObject * obj);
static GType keyboard_layout_page_display_get_type_once (void);

static inline gpointer
keyboard_layout_page_display_get_instance_private (KeyboardLayoutPageDisplay* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardLayoutPageDisplay_private_offset);
}

static void
keyboard_layout_page_display_update_buttons (KeyboardLayoutPageDisplay* self)
{
	gint rows = 0;
	GtkTreeView* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	gint index = 0;
	gboolean _tmp3_ = FALSE;
	GtkButton* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
#line 136 "../src/Widgets/Layout/Display.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = self->priv->tree;
#line 137 "../src/Widgets/Layout/Display.vala"
	_tmp1_ = gtk_tree_view_get_model (_tmp0_);
#line 137 "../src/Widgets/Layout/Display.vala"
	_tmp2_ = _tmp1_;
#line 137 "../src/Widgets/Layout/Display.vala"
	rows = gtk_tree_model_iter_n_children (_tmp2_, NULL);
#line 138 "../src/Widgets/Layout/Display.vala"
	index = keyboard_layout_page_display_get_cursor_index (self);
#line 141 "../src/Widgets/Layout/Display.vala"
	if (rows > 1) {
#line 141 "../src/Widgets/Layout/Display.vala"
		_tmp3_ = index != 0;
#line 188 "Display.c"
	} else {
#line 141 "../src/Widgets/Layout/Display.vala"
		_tmp3_ = FALSE;
#line 192 "Display.c"
	}
#line 141 "../src/Widgets/Layout/Display.vala"
	_tmp4_ = self->priv->up_button;
#line 141 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, _tmp3_);
#line 142 "../src/Widgets/Layout/Display.vala"
	if (rows > 1) {
#line 142 "../src/Widgets/Layout/Display.vala"
		_tmp5_ = index < (rows - 1);
#line 202 "Display.c"
	} else {
#line 142 "../src/Widgets/Layout/Display.vala"
		_tmp5_ = FALSE;
#line 206 "Display.c"
	}
#line 142 "../src/Widgets/Layout/Display.vala"
	_tmp6_ = self->priv->down_button;
#line 142 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, _tmp5_);
#line 143 "../src/Widgets/Layout/Display.vala"
	_tmp7_ = self->priv->remove_button;
#line 143 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, rows > 0);
#line 216 "Display.c"
}

/**
     * Returns the index of the selected (xkb) layout in the list of (all) input sources.
     * In case the list contains no layouts, it returns -1.
     */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 153 "../src/Widgets/Layout/Display.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 228 "Display.c"
}

static gint
keyboard_layout_page_display_get_cursor_index (KeyboardLayoutPageDisplay* self)
{
	GtkTreePath* path = NULL;
	GtkTreeView* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreePath* _tmp2_;
	GtkTreeIter iter = {0};
	GtkTreeView* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	guint index = 0U;
	GtkTreeView* _tmp8_;
	GtkTreeModel* _tmp9_;
	GtkTreeModel* _tmp10_;
	GtkTreeIter _tmp11_;
	guint _tmp12_ = 0U;
	gint result;
#line 150 "../src/Widgets/Layout/Display.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 153 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = self->priv->tree;
#line 153 "../src/Widgets/Layout/Display.vala"
	gtk_tree_view_get_cursor (_tmp0_, &_tmp1_, NULL);
#line 153 "../src/Widgets/Layout/Display.vala"
	__vala_GtkTreePath_free0 (path);
#line 153 "../src/Widgets/Layout/Display.vala"
	path = _tmp1_;
#line 155 "../src/Widgets/Layout/Display.vala"
	_tmp2_ = path;
#line 155 "../src/Widgets/Layout/Display.vala"
	if (_tmp2_ == NULL) {
#line 156 "../src/Widgets/Layout/Display.vala"
		result = -1;
#line 156 "../src/Widgets/Layout/Display.vala"
		__vala_GtkTreePath_free0 (path);
#line 156 "../src/Widgets/Layout/Display.vala"
		return result;
#line 271 "Display.c"
	}
#line 160 "../src/Widgets/Layout/Display.vala"
	_tmp3_ = self->priv->tree;
#line 160 "../src/Widgets/Layout/Display.vala"
	_tmp4_ = gtk_tree_view_get_model (_tmp3_);
#line 160 "../src/Widgets/Layout/Display.vala"
	_tmp5_ = _tmp4_;
#line 160 "../src/Widgets/Layout/Display.vala"
	_tmp6_ = path;
#line 160 "../src/Widgets/Layout/Display.vala"
	gtk_tree_model_get_iter (_tmp5_, &_tmp7_, _tmp6_);
#line 160 "../src/Widgets/Layout/Display.vala"
	iter = _tmp7_;
#line 162 "../src/Widgets/Layout/Display.vala"
	_tmp8_ = self->priv->tree;
#line 162 "../src/Widgets/Layout/Display.vala"
	_tmp9_ = gtk_tree_view_get_model (_tmp8_);
#line 162 "../src/Widgets/Layout/Display.vala"
	_tmp10_ = _tmp9_;
#line 162 "../src/Widgets/Layout/Display.vala"
	_tmp11_ = iter;
#line 162 "../src/Widgets/Layout/Display.vala"
	gtk_tree_model_get (_tmp10_, &_tmp11_, 2, &_tmp12_, -1, -1);
#line 162 "../src/Widgets/Layout/Display.vala"
	index = _tmp12_;
#line 163 "../src/Widgets/Layout/Display.vala"
	result = (gint) index;
#line 163 "../src/Widgets/Layout/Display.vala"
	__vala_GtkTreePath_free0 (path);
#line 163 "../src/Widgets/Layout/Display.vala"
	return result;
#line 303 "Display.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 172 "../src/Widgets/Layout/Display.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 172 "../src/Widgets/Layout/Display.vala"
	return _data4_;
#line 313 "Display.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 172 "../src/Widgets/Layout/Display.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 323 "Display.c"
		KeyboardLayoutPageDisplay* self;
#line 172 "../src/Widgets/Layout/Display.vala"
		self = _data4_->self;
#line 172 "../src/Widgets/Layout/Display.vala"
		_g_object_unref0 (self);
#line 172 "../src/Widgets/Layout/Display.vala"
		g_slice_free (Block4Data, _data4_);
#line 331 "Display.c"
	}
}

static gboolean
___lambda12_ (Block4Data* _data4_,
              GtkTreeModel* model,
              GtkTreePath* path,
              GtkTreeIter* iter)
{
	KeyboardLayoutPageDisplay* self;
	GtkTreeView* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeIter _tmp3_;
	guint _tmp4_ = 0U;
	KeyboardSourceSettings* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gboolean result;
#line 174 "../src/Widgets/Layout/Display.vala"
	self = _data4_->self;
#line 174 "../src/Widgets/Layout/Display.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 174 "../src/Widgets/Layout/Display.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 174 "../src/Widgets/Layout/Display.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 175 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = self->priv->tree;
#line 175 "../src/Widgets/Layout/Display.vala"
	_tmp1_ = gtk_tree_view_get_model (_tmp0_);
#line 175 "../src/Widgets/Layout/Display.vala"
	_tmp2_ = _tmp1_;
#line 175 "../src/Widgets/Layout/Display.vala"
	_tmp3_ = *iter;
#line 175 "../src/Widgets/Layout/Display.vala"
	gtk_tree_model_get (_tmp2_, &_tmp3_, 2, &_tmp4_, -1);
#line 175 "../src/Widgets/Layout/Display.vala"
	_data4_->index = _tmp4_;
#line 176 "../src/Widgets/Layout/Display.vala"
	_tmp5_ = self->priv->settings;
#line 176 "../src/Widgets/Layout/Display.vala"
	_tmp6_ = keyboard_source_settings_get_active_index (_tmp5_);
#line 176 "../src/Widgets/Layout/Display.vala"
	_tmp7_ = _tmp6_;
#line 176 "../src/Widgets/Layout/Display.vala"
	if (_data4_->index == _tmp7_) {
#line 379 "Display.c"
		GtkTreeView* _tmp8_;
#line 177 "../src/Widgets/Layout/Display.vala"
		_tmp8_ = self->priv->tree;
#line 177 "../src/Widgets/Layout/Display.vala"
		gtk_tree_view_set_cursor (_tmp8_, path, NULL, FALSE);
#line 178 "../src/Widgets/Layout/Display.vala"
		result = TRUE;
#line 178 "../src/Widgets/Layout/Display.vala"
		return result;
#line 389 "Display.c"
	}
#line 181 "../src/Widgets/Layout/Display.vala"
	result = FALSE;
#line 181 "../src/Widgets/Layout/Display.vala"
	return result;
#line 395 "Display.c"
}

static gboolean
____lambda12__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                           GtkTreePath* path,
                                           GtkTreeIter* iter,
                                           gpointer self)
{
	gboolean result;
	result = ___lambda12_ (self, model, path, iter);
#line 174 "../src/Widgets/Layout/Display.vala"
	return result;
#line 408 "Display.c"
}

static void
keyboard_layout_page_display_update_cursor (KeyboardLayoutPageDisplay* self)
{
	gboolean _tmp0_ = FALSE;
	GtkTreeView* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	KeyboardSourceSettings* _tmp7_;
	KeyboardInputSource* _tmp8_;
	KeyboardInputSource* _tmp9_;
	KeyboardLayoutType _tmp10_;
	KeyboardLayoutType _tmp11_;
#line 166 "../src/Widgets/Layout/Display.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/Widgets/Layout/Display.vala"
	if (self->priv->cursor_changing) {
#line 167 "../src/Widgets/Layout/Display.vala"
		_tmp0_ = TRUE;
#line 429 "Display.c"
	} else {
		KeyboardSourceSettings* _tmp1_;
		KeyboardInputSource* _tmp2_;
		KeyboardInputSource* _tmp3_;
#line 167 "../src/Widgets/Layout/Display.vala"
		_tmp1_ = self->priv->settings;
#line 167 "../src/Widgets/Layout/Display.vala"
		_tmp2_ = keyboard_source_settings_get_active_input_source (_tmp1_);
#line 167 "../src/Widgets/Layout/Display.vala"
		_tmp3_ = _tmp2_;
#line 167 "../src/Widgets/Layout/Display.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 442 "Display.c"
	}
#line 167 "../src/Widgets/Layout/Display.vala"
	if (_tmp0_) {
#line 168 "../src/Widgets/Layout/Display.vala"
		return;
#line 448 "Display.c"
	}
#line 171 "../src/Widgets/Layout/Display.vala"
	_tmp4_ = self->priv->tree;
#line 171 "../src/Widgets/Layout/Display.vala"
	_tmp5_ = gtk_tree_path_new ();
#line 171 "../src/Widgets/Layout/Display.vala"
	_tmp6_ = _tmp5_;
#line 171 "../src/Widgets/Layout/Display.vala"
	gtk_tree_view_set_cursor (_tmp4_, _tmp6_, NULL, FALSE);
#line 171 "../src/Widgets/Layout/Display.vala"
	__vala_GtkTreePath_free0 (_tmp6_);
#line 172 "../src/Widgets/Layout/Display.vala"
	_tmp7_ = self->priv->settings;
#line 172 "../src/Widgets/Layout/Display.vala"
	_tmp8_ = keyboard_source_settings_get_active_input_source (_tmp7_);
#line 172 "../src/Widgets/Layout/Display.vala"
	_tmp9_ = _tmp8_;
#line 172 "../src/Widgets/Layout/Display.vala"
	_tmp10_ = keyboard_input_source_get_layout_type (_tmp9_);
#line 172 "../src/Widgets/Layout/Display.vala"
	_tmp11_ = _tmp10_;
#line 172 "../src/Widgets/Layout/Display.vala"
	if (_tmp11_ == KEYBOARD_LAYOUT_TYPE_XKB) {
#line 472 "Display.c"
		Block4Data* _data4_;
		GtkTreeView* _tmp12_;
		GtkTreeModel* _tmp13_;
		GtkTreeModel* _tmp14_;
#line 172 "../src/Widgets/Layout/Display.vala"
		_data4_ = g_slice_new0 (Block4Data);
#line 172 "../src/Widgets/Layout/Display.vala"
		_data4_->_ref_count_ = 1;
#line 172 "../src/Widgets/Layout/Display.vala"
		_data4_->self = g_object_ref (self);
#line 173 "../src/Widgets/Layout/Display.vala"
		_data4_->index = (guint) 0;
#line 174 "../src/Widgets/Layout/Display.vala"
		_tmp12_ = self->priv->tree;
#line 174 "../src/Widgets/Layout/Display.vala"
		_tmp13_ = gtk_tree_view_get_model (_tmp12_);
#line 174 "../src/Widgets/Layout/Display.vala"
		_tmp14_ = _tmp13_;
#line 174 "../src/Widgets/Layout/Display.vala"
		gtk_tree_model_foreach (_tmp14_, ____lambda12__gtk_tree_model_foreach_func, _data4_);
#line 172 "../src/Widgets/Layout/Display.vala"
		block4_data_unref (_data4_);
#line 172 "../src/Widgets/Layout/Display.vala"
		_data4_ = NULL;
#line 497 "Display.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 186 "../src/Widgets/Layout/Display.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 186 "../src/Widgets/Layout/Display.vala"
	return _data5_;
#line 508 "Display.c"
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 186 "../src/Widgets/Layout/Display.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 516 "Display.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 186 "../src/Widgets/Layout/Display.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 526 "Display.c"
		KeyboardLayoutPageDisplay* self;
#line 186 "../src/Widgets/Layout/Display.vala"
		self = _data5_->self;
#line 186 "../src/Widgets/Layout/Display.vala"
		__vala_GtkTreeIter_free0 (_data5_->iter);
#line 186 "../src/Widgets/Layout/Display.vala"
		_g_object_unref0 (_data5_->list_store);
#line 186 "../src/Widgets/Layout/Display.vala"
		_g_object_unref0 (self);
#line 186 "../src/Widgets/Layout/Display.vala"
		g_slice_free (Block5Data, _data5_);
#line 538 "Display.c"
	}
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 192 "../src/Widgets/Layout/Display.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 547 "Display.c"
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 192 "../src/Widgets/Layout/Display.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 555 "Display.c"
}

static void
__lambda13_ (Block5Data* _data5_,
             KeyboardInputSource* input_source)
{
	KeyboardLayoutPageDisplay* self;
	KeyboardLayoutType _tmp0_;
	KeyboardLayoutType _tmp1_;
	guint _tmp16_;
#line 190 "../src/Widgets/Layout/Display.vala"
	self = _data5_->self;
#line 190 "../src/Widgets/Layout/Display.vala"
	g_return_if_fail (input_source != NULL);
#line 191 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = keyboard_input_source_get_layout_type (input_source);
#line 191 "../src/Widgets/Layout/Display.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/Widgets/Layout/Display.vala"
	if (_tmp1_ == KEYBOARD_LAYOUT_TYPE_XKB) {
#line 576 "Display.c"
		GtkTreeIter _tmp2_ = {0};
		GtkTreeIter _tmp3_;
		GtkTreeIter* _tmp4_;
		KeyboardXkbLayoutHandler* _tmp5_;
		KeyboardXkbLayoutHandler* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GtkTreeIter _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GtkTreeIter _tmp14_;
		GtkTreeIter _tmp15_;
#line 192 "../src/Widgets/Layout/Display.vala"
		gtk_list_store_append (_data5_->list_store, &_tmp2_);
#line 192 "../src/Widgets/Layout/Display.vala"
		__vala_GtkTreeIter_free0 (_data5_->iter);
#line 192 "../src/Widgets/Layout/Display.vala"
		_tmp3_ = _tmp2_;
#line 192 "../src/Widgets/Layout/Display.vala"
		_tmp4_ = __vala_GtkTreeIter_copy0 (&_tmp3_);
#line 192 "../src/Widgets/Layout/Display.vala"
		_data5_->iter = _tmp4_;
#line 193 "../src/Widgets/Layout/Display.vala"
		_tmp5_ = keyboard_xkb_layout_handler_get_instance ();
#line 193 "../src/Widgets/Layout/Display.vala"
		_tmp6_ = _tmp5_;
#line 193 "../src/Widgets/Layout/Display.vala"
		_tmp7_ = keyboard_input_source_get_name (input_source);
#line 193 "../src/Widgets/Layout/Display.vala"
		_tmp8_ = _tmp7_;
#line 193 "../src/Widgets/Layout/Display.vala"
		_tmp9_ = keyboard_xkb_layout_handler_get_display_name (_tmp6_, _tmp8_);
#line 193 "../src/Widgets/Layout/Display.vala"
		_tmp10_ = _tmp9_;
#line 193 "../src/Widgets/Layout/Display.vala"
		_tmp11_ = *_data5_->iter;
#line 193 "../src/Widgets/Layout/Display.vala"
		gtk_list_store_set (_data5_->list_store, &_tmp11_, 0, _tmp10_, -1);
#line 193 "../src/Widgets/Layout/Display.vala"
		_g_free0 (_tmp10_);
#line 193 "../src/Widgets/Layout/Display.vala"
		_g_object_unref0 (_tmp6_);
#line 194 "../src/Widgets/Layout/Display.vala"
		_tmp12_ = keyboard_input_source_get_name (input_source);
#line 194 "../src/Widgets/Layout/Display.vala"
		_tmp13_ = _tmp12_;
#line 194 "../src/Widgets/Layout/Display.vala"
		_tmp14_ = *_data5_->iter;
#line 194 "../src/Widgets/Layout/Display.vala"
		gtk_list_store_set (_data5_->list_store, &_tmp14_, 1, _tmp13_, -1);
#line 195 "../src/Widgets/Layout/Display.vala"
		_tmp15_ = *_data5_->iter;
#line 195 "../src/Widgets/Layout/Display.vala"
		gtk_list_store_set (_data5_->list_store, &_tmp15_, 2, _data5_->index, -1);
#line 633 "Display.c"
	}
#line 198 "../src/Widgets/Layout/Display.vala"
	_tmp16_ = _data5_->index;
#line 198 "../src/Widgets/Layout/Display.vala"
	_data5_->index = _tmp16_ + 1;
#line 639 "Display.c"
}

static void
___lambda13__gfunc (gconstpointer data,
                    gpointer self)
{
#line 190 "../src/Widgets/Layout/Display.vala"
	__lambda13_ (self, (KeyboardInputSource*) data);
#line 648 "Display.c"
}

static void
keyboard_layout_page_display_rebuild_list (KeyboardLayoutPageDisplay* self)
{
	Block5Data* _data5_;
	GtkListStore* _tmp0_;
	KeyboardSourceSettings* _tmp1_;
	GtkTreeView* _tmp2_;
#line 186 "../src/Widgets/Layout/Display.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/Widgets/Layout/Display.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 186 "../src/Widgets/Layout/Display.vala"
	_data5_->_ref_count_ = 1;
#line 186 "../src/Widgets/Layout/Display.vala"
	_data5_->self = g_object_ref (self);
#line 187 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT, -1);
#line 187 "../src/Widgets/Layout/Display.vala"
	_data5_->list_store = _tmp0_;
#line 188 "../src/Widgets/Layout/Display.vala"
	_data5_->iter = NULL;
#line 189 "../src/Widgets/Layout/Display.vala"
	_data5_->index = (guint) 0;
#line 190 "../src/Widgets/Layout/Display.vala"
	_tmp1_ = self->priv->settings;
#line 190 "../src/Widgets/Layout/Display.vala"
	keyboard_source_settings_foreach_layout (_tmp1_, ___lambda13__gfunc, _data5_);
#line 201 "../src/Widgets/Layout/Display.vala"
	_tmp2_ = self->priv->tree;
#line 201 "../src/Widgets/Layout/Display.vala"
	gtk_tree_view_set_model (_tmp2_, (GtkTreeModel*) _data5_->list_store);
#line 202 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_update_cursor (self);
#line 203 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_update_buttons (self);
#line 186 "../src/Widgets/Layout/Display.vala"
	block5_data_unref (_data5_);
#line 186 "../src/Widgets/Layout/Display.vala"
	_data5_ = NULL;
#line 690 "Display.c"
}

KeyboardLayoutPageDisplay*
keyboard_layout_page_display_construct (GType object_type)
{
	KeyboardLayoutPageDisplay * self = NULL;
#line 21 "../src/Widgets/Layout/Display.vala"
	self = (KeyboardLayoutPageDisplay*) g_object_new (object_type, NULL);
#line 21 "../src/Widgets/Layout/Display.vala"
	return self;
#line 701 "Display.c"
}

KeyboardLayoutPageDisplay*
keyboard_layout_page_display_new (void)
{
#line 21 "../src/Widgets/Layout/Display.vala"
	return keyboard_layout_page_display_construct (KEYBOARD_LAYOUT_PAGE_TYPE_DISPLAY);
#line 709 "Display.c"
}

static void
__lambda26_ (KeyboardLayoutPageDisplay* self,
             const gchar* layout,
             const gchar* variant)
{
	KeyboardSourceSettings* _tmp0_;
	KeyboardInputSource* _tmp1_;
	KeyboardInputSource* _tmp2_;
#line 93 "../src/Widgets/Layout/Display.vala"
	g_return_if_fail (layout != NULL);
#line 93 "../src/Widgets/Layout/Display.vala"
	g_return_if_fail (variant != NULL);
#line 94 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = self->priv->settings;
#line 94 "../src/Widgets/Layout/Display.vala"
	_tmp1_ = keyboard_input_source_new_xkb (layout, variant);
#line 94 "../src/Widgets/Layout/Display.vala"
	_tmp2_ = _tmp1_;
#line 94 "../src/Widgets/Layout/Display.vala"
	keyboard_source_settings_add_layout (_tmp0_, _tmp2_);
#line 94 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (_tmp2_);
#line 95 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_rebuild_list (self);
#line 736 "Display.c"
}

static void
___lambda26__keyboard_layout_page_add_layout_dialog_layout_added (KeyboardLayoutPageAddLayoutDialog* _sender,
                                                                  const gchar* language,
                                                                  const gchar* layout,
                                                                  gpointer self)
{
#line 93 "../src/Widgets/Layout/Display.vala"
	__lambda26_ ((KeyboardLayoutPageDisplay*) self, language, layout);
#line 747 "Display.c"
}

static void
_keyboard_layout_page_display___lambda14_ (KeyboardLayoutPageDisplay* self)
{
	KeyboardLayoutPageAddLayoutDialog* dialog = NULL;
	KeyboardLayoutPageAddLayoutDialog* _tmp0_;
	KeyboardLayoutPageAddLayoutDialog* _tmp1_;
	GtkWidget* _tmp2_;
	KeyboardLayoutPageAddLayoutDialog* _tmp3_;
	KeyboardLayoutPageAddLayoutDialog* _tmp4_;
#line 89 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = keyboard_layout_page_add_layout_dialog_new ();
#line 89 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp0_);
#line 89 "../src/Widgets/Layout/Display.vala"
	dialog = _tmp0_;
#line 90 "../src/Widgets/Layout/Display.vala"
	_tmp1_ = dialog;
#line 90 "../src/Widgets/Layout/Display.vala"
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 90 "../src/Widgets/Layout/Display.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_window_get_type (), GtkWindow));
#line 91 "../src/Widgets/Layout/Display.vala"
	_tmp3_ = dialog;
#line 91 "../src/Widgets/Layout/Display.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 93 "../src/Widgets/Layout/Display.vala"
	_tmp4_ = dialog;
#line 93 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object (_tmp4_, "layout-added", (GCallback) ___lambda26__keyboard_layout_page_add_layout_dialog_layout_added, self, 0);
#line 88 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (dialog);
#line 781 "Display.c"
}

static void
__keyboard_layout_page_display___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 88 "../src/Widgets/Layout/Display.vala"
	_keyboard_layout_page_display___lambda14_ ((KeyboardLayoutPageDisplay*) self);
#line 790 "Display.c"
}

static void
_keyboard_layout_page_display___lambda27_ (KeyboardLayoutPageDisplay* self)
{
	KeyboardSourceSettings* _tmp0_;
#line 100 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = self->priv->settings;
#line 100 "../src/Widgets/Layout/Display.vala"
	keyboard_source_settings_remove_active_layout (_tmp0_);
#line 101 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_rebuild_list (self);
#line 803 "Display.c"
}

static void
__keyboard_layout_page_display___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 99 "../src/Widgets/Layout/Display.vala"
	_keyboard_layout_page_display___lambda27_ ((KeyboardLayoutPageDisplay*) self);
#line 812 "Display.c"
}

static void
_keyboard_layout_page_display___lambda28_ (KeyboardLayoutPageDisplay* self)
{
	KeyboardSourceSettings* _tmp0_;
#line 105 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = self->priv->settings;
#line 105 "../src/Widgets/Layout/Display.vala"
	keyboard_source_settings_move_active_layout_up (_tmp0_);
#line 106 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_rebuild_list (self);
#line 825 "Display.c"
}

static void
__keyboard_layout_page_display___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 104 "../src/Widgets/Layout/Display.vala"
	_keyboard_layout_page_display___lambda28_ ((KeyboardLayoutPageDisplay*) self);
#line 834 "Display.c"
}

static void
_keyboard_layout_page_display___lambda29_ (KeyboardLayoutPageDisplay* self)
{
	KeyboardSourceSettings* _tmp0_;
#line 110 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = self->priv->settings;
#line 110 "../src/Widgets/Layout/Display.vala"
	keyboard_source_settings_move_active_layout_down (_tmp0_);
#line 111 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_rebuild_list (self);
#line 847 "Display.c"
}

static void
__keyboard_layout_page_display___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 109 "../src/Widgets/Layout/Display.vala"
	_keyboard_layout_page_display___lambda29_ ((KeyboardLayoutPageDisplay*) self);
#line 856 "Display.c"
}

static void
_keyboard_layout_page_display___lambda30_ (KeyboardLayoutPageDisplay* self)
{
	gint new_index = 0;
#line 115 "../src/Widgets/Layout/Display.vala"
	self->priv->cursor_changing = TRUE;
#line 117 "../src/Widgets/Layout/Display.vala"
	new_index = keyboard_layout_page_display_get_cursor_index (self);
#line 118 "../src/Widgets/Layout/Display.vala"
	if (new_index >= 0) {
#line 869 "Display.c"
		KeyboardSourceSettings* _tmp0_;
#line 119 "../src/Widgets/Layout/Display.vala"
		_tmp0_ = self->priv->settings;
#line 119 "../src/Widgets/Layout/Display.vala"
		keyboard_source_settings_set_active_index (_tmp0_, (guint) new_index);
#line 875 "Display.c"
	}
#line 122 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_update_buttons (self);
#line 124 "../src/Widgets/Layout/Display.vala"
	self->priv->cursor_changing = FALSE;
#line 881 "Display.c"
}

static void
__keyboard_layout_page_display___lambda30__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                                                         gpointer self)
{
#line 114 "../src/Widgets/Layout/Display.vala"
	_keyboard_layout_page_display___lambda30_ ((KeyboardLayoutPageDisplay*) self);
#line 890 "Display.c"
}

static void
_keyboard_layout_page_display___lambda31_ (KeyboardLayoutPageDisplay* self)
{
#line 128 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_update_cursor (self);
#line 898 "Display.c"
}

static void
__keyboard_layout_page_display___lambda31__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 127 "../src/Widgets/Layout/Display.vala"
	_keyboard_layout_page_display___lambda31_ ((KeyboardLayoutPageDisplay*) self);
#line 908 "Display.c"
}

static void
_keyboard_layout_page_display_rebuild_list_keyboard_source_settings_external_layout_change (KeyboardSourceSettings* _sender,
                                                                                            gpointer self)
{
#line 131 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_rebuild_list ((KeyboardLayoutPageDisplay*) self);
#line 917 "Display.c"
}

static GObject *
keyboard_layout_page_display_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KeyboardLayoutPageDisplay * self;
	KeyboardSourceSettings* _tmp0_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp1_ = NULL;
	GtkTreeView* _tmp2_ = NULL;
	GtkTreeView* _tmp3_;
	GtkCellRendererText* _tmp4_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp5_ = NULL;
	GtkScrolledWindow* _tmp6_;
	GtkTreeView* _tmp7_;
	gchar* _tmp8_;
	GtkButton* _tmp9_ = NULL;
	gchar* _tmp10_;
	GtkButton* _tmp11_ = NULL;
	gchar* _tmp12_;
	GtkButton* _tmp13_ = NULL;
	gchar* _tmp14_;
	GtkButton* _tmp15_ = NULL;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp16_;
	GtkActionBar* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkActionBar* _tmp19_;
	GtkButton* _tmp20_;
	GtkActionBar* _tmp21_;
	GtkButton* _tmp22_;
	GtkActionBar* _tmp23_;
	GtkButton* _tmp24_;
	GtkActionBar* _tmp25_;
	GtkButton* _tmp26_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GtkScrolledWindow* _tmp29_;
	GtkGrid* _tmp30_;
	GtkActionBar* _tmp31_;
	GtkGrid* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkTreeView* _tmp37_;
	KeyboardSourceSettings* _tmp38_;
	KeyboardSourceSettings* _tmp39_;
#line 35 "../src/Widgets/Layout/Display.vala"
	parent_class = G_OBJECT_CLASS (keyboard_layout_page_display_parent_class);
#line 35 "../src/Widgets/Layout/Display.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../src/Widgets/Layout/Display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_LAYOUT_PAGE_TYPE_DISPLAY, KeyboardLayoutPageDisplay);
#line 36 "../src/Widgets/Layout/Display.vala"
	_tmp0_ = keyboard_source_settings_get_instance ();
#line 36 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->settings);
#line 36 "../src/Widgets/Layout/Display.vala"
	self->priv->settings = _tmp0_;
#line 38 "../src/Widgets/Layout/Display.vala"
	_tmp1_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 38 "../src/Widgets/Layout/Display.vala"
	g_object_set (_tmp1_, "ellipsize-set", TRUE, NULL);
#line 38 "../src/Widgets/Layout/Display.vala"
	g_object_set (_tmp1_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 38 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp1_);
#line 38 "../src/Widgets/Layout/Display.vala"
	cell = _tmp1_;
#line 43 "../src/Widgets/Layout/Display.vala"
	_tmp2_ = (GtkTreeView*) gtk_tree_view_new ();
#line 43 "../src/Widgets/Layout/Display.vala"
	gtk_tree_view_set_headers_visible (_tmp2_, FALSE);
#line 43 "../src/Widgets/Layout/Display.vala"
	g_object_set ((GtkWidget*) _tmp2_, "expand", TRUE, NULL);
#line 43 "../src/Widgets/Layout/Display.vala"
	gtk_tree_view_set_tooltip_column (_tmp2_, 0);
#line 43 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp2_);
#line 43 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->tree);
#line 43 "../src/Widgets/Layout/Display.vala"
	self->priv->tree = _tmp2_;
#line 48 "../src/Widgets/Layout/Display.vala"
	_tmp3_ = self->priv->tree;
#line 48 "../src/Widgets/Layout/Display.vala"
	_tmp4_ = cell;
#line 48 "../src/Widgets/Layout/Display.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp3_, -1, NULL, (GtkCellRenderer*) _tmp4_, "text", 0, NULL);
#line 50 "../src/Widgets/Layout/Display.vala"
	_tmp5_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 50 "../src/Widgets/Layout/Display.vala"
	g_object_set (_tmp5_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 50 "../src/Widgets/Layout/Display.vala"
	g_object_set ((GtkWidget*) _tmp5_, "expand", TRUE, NULL);
#line 50 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp5_);
#line 50 "../src/Widgets/Layout/Display.vala"
	scroll = _tmp5_;
#line 54 "../src/Widgets/Layout/Display.vala"
	_tmp6_ = scroll;
#line 54 "../src/Widgets/Layout/Display.vala"
	_tmp7_ = self->priv->tree;
#line 54 "../src/Widgets/Layout/Display.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 56 "../src/Widgets/Layout/Display.vala"
	_tmp8_ = g_strdup (_ ("Add…"));
#line 56 "../src/Widgets/Layout/Display.vala"
	_tmp9_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 56 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _tmp8_);
#line 56 "../src/Widgets/Layout/Display.vala"
	_g_free0 (_tmp8_);
#line 56 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp9_);
#line 56 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->add_button);
#line 56 "../src/Widgets/Layout/Display.vala"
	self->priv->add_button = _tmp9_;
#line 60 "../src/Widgets/Layout/Display.vala"
	_tmp10_ = g_strdup (_ ("Remove"));
#line 60 "../src/Widgets/Layout/Display.vala"
	_tmp11_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 60 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 60 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp10_);
#line 60 "../src/Widgets/Layout/Display.vala"
	_g_free0 (_tmp10_);
#line 60 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp11_);
#line 60 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 60 "../src/Widgets/Layout/Display.vala"
	self->priv->remove_button = _tmp11_;
#line 65 "../src/Widgets/Layout/Display.vala"
	_tmp12_ = g_strdup (_ ("Move up"));
#line 65 "../src/Widgets/Layout/Display.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("go-up-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 65 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
#line 65 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp12_);
#line 65 "../src/Widgets/Layout/Display.vala"
	_g_free0 (_tmp12_);
#line 65 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp13_);
#line 65 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->up_button);
#line 65 "../src/Widgets/Layout/Display.vala"
	self->priv->up_button = _tmp13_;
#line 70 "../src/Widgets/Layout/Display.vala"
	_tmp14_ = g_strdup (_ ("Move down"));
#line 70 "../src/Widgets/Layout/Display.vala"
	_tmp15_ = (GtkButton*) gtk_button_new_from_icon_name ("go-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 70 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, FALSE);
#line 70 "../src/Widgets/Layout/Display.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp15_, _tmp14_);
#line 70 "../src/Widgets/Layout/Display.vala"
	_g_free0 (_tmp14_);
#line 70 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp15_);
#line 70 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->down_button);
#line 70 "../src/Widgets/Layout/Display.vala"
	self->priv->down_button = _tmp15_;
#line 75 "../src/Widgets/Layout/Display.vala"
	_tmp16_ = (GtkActionBar*) gtk_action_bar_new ();
#line 75 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp16_);
#line 75 "../src/Widgets/Layout/Display.vala"
	actionbar = _tmp16_;
#line 76 "../src/Widgets/Layout/Display.vala"
	_tmp17_ = actionbar;
#line 76 "../src/Widgets/Layout/Display.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 76 "../src/Widgets/Layout/Display.vala"
	gtk_style_context_add_class (_tmp18_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
#line 77 "../src/Widgets/Layout/Display.vala"
	_tmp19_ = actionbar;
#line 77 "../src/Widgets/Layout/Display.vala"
	_tmp20_ = self->priv->add_button;
#line 77 "../src/Widgets/Layout/Display.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 78 "../src/Widgets/Layout/Display.vala"
	_tmp21_ = actionbar;
#line 78 "../src/Widgets/Layout/Display.vala"
	_tmp22_ = self->priv->remove_button;
#line 78 "../src/Widgets/Layout/Display.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 79 "../src/Widgets/Layout/Display.vala"
	_tmp23_ = actionbar;
#line 79 "../src/Widgets/Layout/Display.vala"
	_tmp24_ = self->priv->up_button;
#line 79 "../src/Widgets/Layout/Display.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 80 "../src/Widgets/Layout/Display.vala"
	_tmp25_ = actionbar;
#line 80 "../src/Widgets/Layout/Display.vala"
	_tmp26_ = self->priv->down_button;
#line 80 "../src/Widgets/Layout/Display.vala"
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 82 "../src/Widgets/Layout/Display.vala"
	_tmp27_ = (GtkGrid*) gtk_grid_new ();
#line 82 "../src/Widgets/Layout/Display.vala"
	g_object_ref_sink (_tmp27_);
#line 82 "../src/Widgets/Layout/Display.vala"
	grid = _tmp27_;
#line 83 "../src/Widgets/Layout/Display.vala"
	_tmp28_ = grid;
#line 83 "../src/Widgets/Layout/Display.vala"
	_tmp29_ = scroll;
#line 83 "../src/Widgets/Layout/Display.vala"
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 0, 0, 1, 1);
#line 84 "../src/Widgets/Layout/Display.vala"
	_tmp30_ = grid;
#line 84 "../src/Widgets/Layout/Display.vala"
	_tmp31_ = actionbar;
#line 84 "../src/Widgets/Layout/Display.vala"
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 0, 1, 1, 1);
#line 86 "../src/Widgets/Layout/Display.vala"
	_tmp32_ = grid;
#line 86 "../src/Widgets/Layout/Display.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
#line 88 "../src/Widgets/Layout/Display.vala"
	_tmp33_ = self->priv->add_button;
#line 88 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object (_tmp33_, "clicked", (GCallback) __keyboard_layout_page_display___lambda14__gtk_button_clicked, self, 0);
#line 99 "../src/Widgets/Layout/Display.vala"
	_tmp34_ = self->priv->remove_button;
#line 99 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object (_tmp34_, "clicked", (GCallback) __keyboard_layout_page_display___lambda27__gtk_button_clicked, self, 0);
#line 104 "../src/Widgets/Layout/Display.vala"
	_tmp35_ = self->priv->up_button;
#line 104 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object (_tmp35_, "clicked", (GCallback) __keyboard_layout_page_display___lambda28__gtk_button_clicked, self, 0);
#line 109 "../src/Widgets/Layout/Display.vala"
	_tmp36_ = self->priv->down_button;
#line 109 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) __keyboard_layout_page_display___lambda29__gtk_button_clicked, self, 0);
#line 114 "../src/Widgets/Layout/Display.vala"
	_tmp37_ = self->priv->tree;
#line 114 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object (_tmp37_, "cursor-changed", (GCallback) __keyboard_layout_page_display___lambda30__gtk_tree_view_cursor_changed, self, G_CONNECT_AFTER);
#line 127 "../src/Widgets/Layout/Display.vala"
	_tmp38_ = self->priv->settings;
#line 127 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object ((GObject*) _tmp38_, "notify::active-index", (GCallback) __keyboard_layout_page_display___lambda31__g_object_notify, self, 0);
#line 131 "../src/Widgets/Layout/Display.vala"
	_tmp39_ = self->priv->settings;
#line 131 "../src/Widgets/Layout/Display.vala"
	g_signal_connect_object (_tmp39_, "external-layout-change", (GCallback) _keyboard_layout_page_display_rebuild_list_keyboard_source_settings_external_layout_change, self, 0);
#line 133 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_rebuild_list (self);
#line 35 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (grid);
#line 35 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (actionbar);
#line 35 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (scroll);
#line 35 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (cell);
#line 35 "../src/Widgets/Layout/Display.vala"
	return obj;
#line 1190 "Display.c"
}

static void
keyboard_layout_page_display_class_init (KeyboardLayoutPageDisplayClass * klass,
                                         gpointer klass_data)
{
#line 21 "../src/Widgets/Layout/Display.vala"
	keyboard_layout_page_display_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/Layout/Display.vala"
	g_type_class_adjust_private_offset (klass, &KeyboardLayoutPageDisplay_private_offset);
#line 21 "../src/Widgets/Layout/Display.vala"
	G_OBJECT_CLASS (klass)->constructor = keyboard_layout_page_display_constructor;
#line 21 "../src/Widgets/Layout/Display.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_layout_page_display_finalize;
#line 1205 "Display.c"
}

static void
keyboard_layout_page_display_instance_init (KeyboardLayoutPageDisplay * self,
                                            gpointer klass)
{
#line 21 "../src/Widgets/Layout/Display.vala"
	self->priv = keyboard_layout_page_display_get_instance_private (self);
#line 33 "../src/Widgets/Layout/Display.vala"
	self->priv->cursor_changing = FALSE;
#line 1216 "Display.c"
}

static void
keyboard_layout_page_display_finalize (GObject * obj)
{
	KeyboardLayoutPageDisplay * self;
#line 21 "../src/Widgets/Layout/Display.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_LAYOUT_PAGE_TYPE_DISPLAY, KeyboardLayoutPageDisplay);
#line 22 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->settings);
#line 23 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->tree);
#line 24 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->up_button);
#line 25 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->down_button);
#line 26 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->add_button);
#line 27 "../src/Widgets/Layout/Display.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 21 "../src/Widgets/Layout/Display.vala"
	G_OBJECT_CLASS (keyboard_layout_page_display_parent_class)->finalize (obj);
#line 1239 "Display.c"
}

static GType
keyboard_layout_page_display_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardLayoutPageDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_layout_page_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardLayoutPageDisplay), 0, (GInstanceInitFunc) keyboard_layout_page_display_instance_init, NULL };
	GType keyboard_layout_page_display_type_id;
	keyboard_layout_page_display_type_id = g_type_register_static (gtk_frame_get_type (), "KeyboardLayoutPageDisplay", &g_define_type_info, 0);
	KeyboardLayoutPageDisplay_private_offset = g_type_add_instance_private (keyboard_layout_page_display_type_id, sizeof (KeyboardLayoutPageDisplayPrivate));
	return keyboard_layout_page_display_type_id;
}

GType
keyboard_layout_page_display_get_type (void)
{
	static volatile gsize keyboard_layout_page_display_type_id__once = 0;
	if (g_once_init_enter (&keyboard_layout_page_display_type_id__once)) {
		GType keyboard_layout_page_display_type_id;
		keyboard_layout_page_display_type_id = keyboard_layout_page_display_get_type_once ();
		g_once_init_leave (&keyboard_layout_page_display_type_id__once, keyboard_layout_page_display_type_id);
	}
	return keyboard_layout_page_display_type_id__once;
}

